void my_lcdprint(char *s)
{ 
  char i;
  char len;
  len=strlen(lcd_buffer);  
  for(i=len;i<16;i++) s[i]=' ';
  s[16]=0;
  
  if (IspReg==111 && s[9]=='R' && flNumStrPrint==0) s[9]='N';
  
  lcd.print(s);  
 

  // Если состояние отправки - надо отправить экран, тогда отправляем еще и на сервер.
  if (flGPRSState==20 || flGPRSState==164)
  {
    if (flNumStrPrint==0)
    {   // Первой строчкой отправляем id устройства и первую строку экрана
        sprintf(my_gprs_buffer,"%s;%s",idDevice,s); //запись в буфер текста и значений температуры в подготовленном
        Serial2.print(my_gprs_buffer);
        #ifdef TESTGSM
            Serial.println("SendDTA1:");
            Serial.println(my_gprs_buffer);
        #endif
        
    }
    else
    {   // Второй строчкой отправляем нужную часть экрана, состояние контроллера и последнюю выполненную команду. 
        sprintf(my_gprs_buffer,"%s;%3i;%3i;%c#",s,(int) IspReg,(int) StateMachine,cmdGPRSIsp);
        Serial2.println(my_gprs_buffer);
        #ifdef TESTGSM
             Serial.println("SendDTA2:");
            Serial.println(my_gprs_buffer);
        #endif
        flGPRSState++; // Переводим контроллер в состояние отправлено.
        //timeWaitGPRS=20;
        timeWaitGPRS=2; // Две секунды достаточно для отправки
    }
  }

  flNumStrPrint++;
  
  #ifdef TESTMEM
    Serial.println("\n[memCheck_print]"));
    Serial.println(freeRam());
  #endif
}

unsigned char hour,minute,second;
int V1,V2,V3;

void formTRZGDistill()
{
  if (TempDeflBegDistil>0)sprintf_P(lcd_buffer,PSTR("tD=%3i/%3i %4iW"),temps[TEMP_DEFL],TempDeflBegDistil,Power);
                     else sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],-TempDeflBegDistil,Power);
  
}

void formTSAErr()
{
   sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u TSA!"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
    my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("tT=%3i/%3i"),temps[TEMP_TSA],MAX_TEMP_TSA); //запись в буфер текста и значений температуры в подготовленном
}

void DisplayRectif()
{
         if (DispPage==0) 
          {
            switch (StateMachine)
            { 
            case 0: //Не запущено
            case 1: //Не запущено
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u Rect"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
             
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              //sprintf(lcd_buffer,"tK=%3i P=%4i"),temps[TEMP_KUB],Power); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 2: //Разгон
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R RZG"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              if (tEndRectRazgon>0)sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
                               else sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i %4iW"),temps[TEMP_RK20],-tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 3: //Стабилицация колонны
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R NSB"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tN=%3i(%3i)%4iW"),temps[TEMP_RK20],(IspReg==111 ?(int)(SecOstatok):(int)(Seconds-SecTempPrev)),PowerRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 4: //Отбор голов
              if (IspReg!=118)
              {
               sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R GLV"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      
                my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
                if (UrovenProvodimostSR==0)
                 sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],tEndRectOtbGlv,PowerRect); //запись в буфер текста и значений температуры в подготовленном
                else
                  if (UrovenProvodimostSR>0)
                  {
                    if  (UrovenProvodimostSR==2)sprintf_P(lcd_buffer,PSTR("Pr=%3i/%3i %4iW"),U_GLV,UROVEN_ALARM,PowerRect); //запись в буфер текста и значений температуры в подготовленном
                                            else sprintf_P(lcd_buffer,PSTR("Pr=%3i/%3i %4iW"),U_GLV,UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
                  }
                  else
                   sprintf_P(lcd_buffer,PSTR("Tm=%3i/%3i %4iW"),(int) SecOstatok,-UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
                }
              else
              {
         
               sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u RF GLV"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
               //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
                if (TekFraction<CountFractionRect) V2=TempFractionRect[TekFraction];
                if (V2>=0)sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],V2,UstPower);
                      else sprintf_P(lcd_buffer,PSTR("t=%5imin %4iW"),(int) SecOstatok,UstPower);
                
              }  
              break;
            case 5: //Стоп, ожидание возврата температуры
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R Stop"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i %2i%%"),temps[TEMP_RK20],tStabSR,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 6: //Ректификация
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u RSt %2i%%"),hour,minute,second,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i/d%2i"),temps[TEMP_RK20],tStabSR+tDeltaRect,tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 7: //Отбор хвостов
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R Hvost"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i"),temps[TEMP_KUB],IspReg!=118 ? tEndRect:TekTemp); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 8: //Отбор ожидание 3 минут
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R Wait"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i"),temps[TEMP_KUB],IspReg!=118 ? tEndRect : TekTemp); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 9: //Ожидание датчика уровня
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R Wait"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("by Urov=%3i/%3i"),U_UROVEN,UROVEN_ALARM); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 100: //Окончание
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u Rec End"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i End"),temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 101: //Температура в ТСА превысила предельную
              formTSAErr();
              break;
            case 102: //Давление
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u Pres"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("MPX5010=%3i/%3i"),U_MPX5010,AlarmMPX5010); //запись в буфер текста и значений температуры в подготовленном
              break;
    
            }
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
            if (StateMachine!=5) 
            {   if (IspReg!=118) sprintf_P(lcd_buffer,PSTR("%3immV=%4u,%4u"),U_MPX5010,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
                  else 
                   if (TekFraction<CountFractionRect)
                   {
                     if (TempFractionRect[TekFraction]>0) 
                      sprintf_P(lcd_buffer,PSTR("%3imm t=%3i F%1i/%1i"),U_MPX5010,TempFractionRect[TekFraction],(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
                     else
                      sprintf_P(lcd_buffer,PSTR("%3imm %4im F%1i/%1i"),U_MPX5010,(int) SecOstatok,(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
                   }
                   else
                     sprintf_P(lcd_buffer,PSTR("%3immV=%4u F%1i/%1i"),U_MPX5010,U_UROVEN,(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
            }
            else sprintf_P(lcd_buffer,PSTR("%3imm reSt=%5i"),U_MPX5010,time1); //запись в буфер текста и значений температуры в подготовленном
          }
   
}

void DisplayDistDefl()
{
            if (DispPage==0) 
          {
            switch (StateMachine)
            { 
            case 0: //Не запущено
            case 1: //Нагрев до температуры 50 градусов
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DD"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              formTRZGDistill();
              break;
            case 2: //Ожидание закипания (прогреется дефлегматор)
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DD Rzg"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tD=%3i/%3i %4iW"),temps[TEMP_DEFL],TempDeflBegDistil,UstPower); 
              break;
            case 3: //Ожидание закипания (прогреется куб дефлегматор)
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DD Rzg"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],TempDeflBegDistil,UstPower); 
              break;
            case 4: //Работа без дефлегматора
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DD BezD"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tD=%3i/%3i %4iW"),temps[TEMP_DEFL],TempDefl,UstPower); 
              break;
            case 5: //Работа с 50% дефлегмацией
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DD 50%%"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tD=%3i/%3i %4iW"),temps[TEMP_DEFL],TempDefl-DeltaDefl,UstPower); 
              break;
            case 6: //Работа с 100% дефлегмацией
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DD 100%%"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tD=%3i/%3i %4iW"),temps[TEMP_DEFL],TempDefl-DeltaDefl,UstPower); 
              break;
            case 7: //Ожидание для охлаждения
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DD Wait"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i Wait=%4i"),temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 100: //Окончание
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DD end"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i end"),temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
              break;
            }
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("V%4u,%4u-%4iW"),U_VODA,U_UROVEN,deltaPower); //запись в буфер текста и значений температуры в подготовленном
          }

}
/*
void DisplaySimpleGLV()
{
          
          if (DispPage==0)
          {
            switch (StateMachine)
            { 
            case 0: //Не запущено
            case 1: //Нагрев до температуры 50 градусов
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Not"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              formTRZGDistill(); 
              break;
            case 2: //Ожидание закипания (прогреется дефлегматор)
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Rzg"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              formTRZGDistill(); 
              break;
            case 3: //Ожидание закипания (прогреется куб дефлегматор)
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Rzg"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],TempDeflBegDistil,Power); 
              break;
            case 4: //Отбор голов
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Otb"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],Temp3P,PowerGlvDistil); 
              break;
            case 5: //Ожидание 60 секунд для охлаждения
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sOtbGlv"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i Wait=%4i"),temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 100: //Окончание
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sOtbGlv"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i end"),temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 101: //Температура в ТСА превысила предельную
              formTSAErr();
              break;
            }
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3u,%3u,%3u"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("V=%4u,%4u,%4u"),U_VODA,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
          }
}*/

void DisplaySimpleDistill()
{
            if (DispPage==0) 
          {
            if (IspReg==104) 
            { 
              V1=1;
              V2=Temp1P;   
            }
            if (IspReg==106) 
            { 
              V1=2;
              V2=Temp2P;   
            }
            if (IspReg==107   || IspReg==105 ) 
            { 
              V1=3;
              V2=Temp3P;   
            }
    
            if (IspReg!=105) sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u %1u-Otbor"),hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
                        else sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    
            switch (StateMachine)
            { 
            case 0: //Не запущено
            case 1: //Нагрев до температуры 50 градусов
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              break;
            case 2: //Ожидание закипания (прогреется дефлегматор)
              if (IspReg!=105) sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u %1u-O Rzg"),hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
                           else sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Rzg"),hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              formTRZGDistill();
              break;
            case 3: //Дистилляция
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],V2,UstPower); 
              break;
            case 4: //Ожидание 60 секунд для охлаждения
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i Wait=%4i"),temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 100: //Окончание
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i end"),temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
              break;                        
            case 101: //Температура в ТСА превысила предельную
              formTSAErr();
              break;
            }
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("V%4u,%4u %4uW"),U_VODA,U_UROVEN,UstPower); //запись в буфер текста и значений температуры в подготовленном
          }

}
void DisplayFracionDistill()
{
           if (DispPage==0) 
          {
           sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DsF %1i/%1i"),hour,minute,second,(int) (TekFraction<CountFractionDist) ? TekFraction+1: CountFractionDist,(int) CountFractionDist); //запись в буфер текста и значений температуры в подготовленном
    
            switch (StateMachine)
            { 
            case 0: //Не запущено
            case 1: //Нагрев до температуры 50 градусов
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              break;
            case 2: //Ожидание закипания (прогреется дефлегматор)
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DsF Rzg"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              formTRZGDistill();
              break;
            case 3: //Дистилляция
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              
              if (TekFraction<CountFractionDist) V2=TempFractionDist[TekFraction];
              if (V2>=0)sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],V2,UstPower);
                    else sprintf_P(lcd_buffer,PSTR("t=%5imin %4iW"),(int) SecOstatok,UstPower);
                    
              break;
            case 4: //Ожидание 60 секунд для охлаждения
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i Wait=%4i"),temps[TEMP_KUB],time3); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 100: //Окончание
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i end"),temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
              break;                        
            case 101: //Температура в ТСА превысила предельную
              formTSAErr();
              break;
            }
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("V%4u,%4u %4uW"),U_VODA,U_UROVEN,UstPower); //запись в буфер текста и значений температуры в подготовленном
          }

}
void DisplayRazvar()
{
           if (DispPage==0) 
          {
            if (IspReg==114) sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u HLD Ztr"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
                         else sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u Razvar"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            
            switch (StateMachine)
            { 
            case 0: //Не запущено
//            case 1: //Нагрев до температуры 50 градусов
//             sprintf_P(lcd_buffer,PSTR("t=%3i P=%4i"),temps[TEMP_RAZVAR],UstPower); //запись в буфер текста и значений температуры в подготовленном
//              break;
            case 1: //Нагрев до температуры 50 градусов
             sprintf_P(lcd_buffer,PSTR("t=%3i/%3i %4iW"),temps[TEMP_RAZVAR],(int)TempZSP*10,UstPower); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 2: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
             sprintf_P(lcd_buffer,PSTR("t=%3i ZASYP & Dn"),temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 3: //Нагрев до температуры 64 градуса
             sprintf_P(lcd_buffer,PSTR("t=%3i/%3i %4iW"),temps[TEMP_RAZVAR],(int)TempZSPSld*10,UstPower); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 4: //Ожидание 15 минут, поддержка температуры
             sprintf_P(lcd_buffer,PSTR("t=%3i %4iW %4i"),temps[TEMP_RAZVAR],UstPower,time2); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 5: //Нагрев до кипения
              if (ds1820_devices<2)
               sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_RAZVAR],TempKipenZator,UstPower); //запись в буфер текста и значений температуры в подготовленном
              else
               sprintf_P(lcd_buffer,PSTR("tD=%3i/%3i %4iW"),temps[TEMP_DEFL],TempKipenZator,UstPower); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 6: //Варка
             sprintf_P(lcd_buffer,PSTR("t=%3i %4iW %4i"),temps[TEMP_RAZVAR],PowerRazvZerno,time2); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 7: //Охлаждение до температыры осахаривания
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i HLD-1"),temps[TEMP_RAZVAR],(int)TempZSPSld*10); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 8: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
             sprintf_P(lcd_buffer,PSTR("t=%3i SOLOD & Dn"),temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 9: //Мешаем 10 минут
             sprintf_P(lcd_buffer,PSTR("tK=%3i MIX %4i"),temps[TEMP_RAZVAR],time2); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 10: //Осахаривание
             sprintf_P(lcd_buffer,PSTR("tK=%3i OSH %4i"),temps[TEMP_RAZVAR],time2); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 11: //Охлаждение до температуры первичного внесения дрожжей осахаривания
             sprintf_P(lcd_buffer,PSTR("tK=%3i/400 HLD-2"),temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 12: //Охлаждение до температыры осахаривания
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i HLD-3"),temps[TEMP_RAZVAR],(int)TempHLDZatorBrog1*10); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 13: //Поддержка брожения, ничего не делаем, только мешаем периодически
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i BROG"),temps[TEMP_RAZVAR],(int)TempHLDZatorBrog1*10); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 14: //Поддержка брожения - охлаждение
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i BR-H"),temps[TEMP_RAZVAR],(int)TempHLDZatorBrog1*10-5); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 100: //Окончание
             sprintf_P(lcd_buffer,PSTR("t=%3i end"),temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
              break;
            }
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("OSH=%3u NPG=%4u"),(int)TempZSPSld*10,U_NPG); //запись в буфер текста и значений температуры в подготовленном
          }
 
}
/*
void DisplayNDRF()
{
            if (DispPage==0) 
          {
            switch (StateMachine)
            { 
            case 0: //Не запущено
            case 1: //Не запущено
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NDRF"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i P=%4i"),temps[TEMP_KUB],Power); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 2: //Разгон
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND RZG"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              if (tEndRectRazgon>0)sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
                               else sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i %4iW"),temps[TEMP_RK20],-tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 3: //Стабилицация колонны
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND NSB"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("t=%3i(%4i)%4iW"),temps[TEMP_RK20],(int)(SecOstatok),PowerRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 4: //Отбор голов
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND GLV"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              if (UrovenProvodimostSR==0)
               sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),temps[TEMP_KUB],tEndRectOtbGlv,PowerRect); //запись в буфер текста и значений температуры в подготовленном
              else
                if (UrovenProvodimostSR>0)
                 sprintf_P(lcd_buffer,PSTR("Pr=%3i/%3i %4iW"),U_GLV,UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
                else
                 sprintf_P(lcd_buffer,PSTR("Tm=%3i/%3i %4iW"),(int) SecOstatok,-UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 5: //Стоп, ожидание возврата температуры
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND Stop"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i %2i%%"),temps[TEMP_RK20],tStabSR,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 6: //Ректификация
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NDst %2i%%"),hour,minute,second,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i/d%2i"),temps[TEMP_RK20],tStabSR+tDeltaRect,tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 7: //Отбор хвостов
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND Hvst"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i"),temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 8: //Отбор ожидание 3 минут
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND Wait"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i"),temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 9: //Ожидание датчика уровня
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R Wait"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("by Urov=%3i/%3i"),U_UROVEN,UROVEN_ALARM); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 100: //Окончание
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND End"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i"),temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 101: //Температура в ТСА превысила предельную
              formTSAErr();
              break;
            case 102: //Давление
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u Pres"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("MPX5010=%3i/%3i"),U_MPX5010,AlarmMPX5010); //запись в буфер текста и значений температуры в подготовленном
              break;
    
            }
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3u,%3u,%3u"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("%3immV=%4u,%4u"),U_MPX5010,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
          }

}*/

void DisplayNBK()
{
          if (DispPage==0) 
          {
            switch (StateMachine)
            { 
            case 0: //Не запущено
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NBK"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tK=%3i,%3imm"),temps[TEMP_KUB],U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 1: //Ожидание закипания (прогреется дефлегматор)
            case 2: //Ожидание закипания (прогреется дефлегматор)
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NBK Rzg"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              formTRZGDistill();
            break;
            case 3: //Ожидание запуска
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NBK Beg"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("UP to Beg %3imm"),U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 4: //Запущено
            case 6: //Запущено, подача браги остановлена
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NBK Wrk"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("Sp=%4i,%3imm"),(int) SpeedNBK,U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 5: //Превышение температуры вверху
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NBK tmp"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("tD=%3i/970,s%4i"),temps[TEMP_DEFL],time2); //запись в буфер текста и значений температуры в подготовленном
              break;
            case 100: //Окончание
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NBK End"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
              //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("Sp=%4i,%3imm"),(int) SpeedNBK,U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
              break;
            }
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("%4uW,%3imm %3i"),UstPower,U_MPX5010,MaxPressByPeriod); //запись в буфер текста и значений температуры в подготовленном
          }
}
void DisplayTestKLP()
{
    if (DispPage==0) 
    {
     sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u tst Dev"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
     sprintf_P(lcd_buffer,PSTR("St=%3i CHIM=%3i"),StateMachine,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
    }
    else
    {
     sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
     sprintf_P(lcd_buffer,PSTR("%3u,%3u Gas=%4u"),temps[3],temps[4],U_GAS); //запись в буфер текста и значений температуры в подготовленном
    }
 
}

void DisplayExtContol()
{
    if (DispPage==0) 
    {
         sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ExtCtrl"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
          //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
         sprintf_P(lcd_buffer,PSTR("T=%3u,%3u %4iW"),temps[0],temps[1],UstPower); //запись в буфер текста и значений температуры в подготовленном
    }
    else
    {
     sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
     sprintf_P(lcd_buffer,PSTR("%3u,%3u Gas=%4u"),temps[3],temps[4],U_GAS); //запись в буфер текста и значений температуры в подготовленном
    }
 
}

void DisplayBeer()
{
    if (DispPage==0) 
    {
     sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u beer"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      if (StateMachine==2)  sprintf_P(lcd_buffer,PSTR("T=%3i/%3i P%2i/%2i"),temps[TEMP_TERMOSTAT],(int) tempP[KlTek]*10,(int) KlTek,(int) CntPause); //запись в буфер текста и значений температуры в подготовленном
      if (StateMachine==3)  
       {  if (timeP[KlTek]!=0)
           sprintf_P(lcd_buffer,PSTR("Ts=%5i P=%2i/%2i"),time2,(int) KlTek,(int) CntPause); //запись в буфер текста и значений температуры в подготовленном
          else
           sprintf_P(lcd_buffer,PSTR("Press UP to%2i/%2i"),(int) KlTek+1,(int) CntPause); //запись в буфер текста и значений температуры в подготовленном
           
     }             
      if (StateMachine==100)  sprintf_P(lcd_buffer,PSTR("end")); //запись в буфер текста и значений температуры в подготовленном
    }
    else
    {
     sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
     sprintf_P(lcd_buffer,PSTR("mix=%5i %4iW"),time1,UstPower); //запись в буфер текста и значений температуры в подготовленном
    }
}

void DisplayData()
{
  int tic1;
  static int PrevState=0;
  static char flDspDop=0; // Флаг для отображения информации (через раз)
  char j; // Временная переменная для цикла
  flNumStrPrint=0;
  flDspDop=!flDspDop;

  hour=Seconds / 3600;
  tic1=Seconds % 3600;
  minute=tic1 / 60;
  second=tic1 % 60;   

  if (FlState==0) 
    lcd.setCursor(0, 0);
  else 
  { 
    // Если предыдущее состояние было 0, то даем задерку в 1/10 секунды, чтобы не слишком часто обновлялся
    // дисплей.
    if (PrevState==0)  delay(100);

    if (FlState!=PrevState)
    {
      lcd.clear();  //очистка дисплея   
      PrevState=FlState;
    }

    lcd.setCursor(0, 0);
  }

  #ifdef TESTMEM
    Serial.println("\n[memCheck_displ]"));
    Serial.println(freeRam());
  #endif
    
  switch (FlState)
  {
  case 0:
  
    if (DispPage<2) // Первые две страницы отображаются по-разному, остальные всегда одни и те же
      {
        switch (IspReg)
        {
        case 101: // Displaying
          //sprintf(lcd_buffer,"S=%5u TT=%5u"),Seconds,MaxTimeTimer); //запись в буфер текста и значений температуры в подготовленном
    
          //  Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
          //  это напряжение нужно для калибровки нашего измерителя
    
          if (DispPage==0) 
          {
           sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u DSP 1/2"),hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("Zr=%4u U=%3i"),TicZero,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
          }
    
          if (DispPage==1) 
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("V=%4u,%4u,%4u"),U_VODA,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
          }
//          lcd.setCursor(0, 1);
//          my_lcdprint(lcd_buffer);                      
    
          break;
        case 102: // Термостат         
          if (DispPage==0) 
          {
           sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u TermSt"),hour,minute,second,Delta); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
           sprintf_P(lcd_buffer,PSTR("t=%3i/%3i(%2i) %1i"),temps[TEMP_TERMOSTAT],TempTerm,Delta,StateMachine); //запись в буфер текста и значений температуры в подготовленном
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("%3u,%3u P=%3imm"),temps[3],temps[4],U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
          }
          break;
        case 115: // Таймер
          if (DispPage==0) 
          {
           sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u Timer"),hour,minute,second,Delta); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            minute=Seconds / 60;
           sprintf_P(lcd_buffer,PSTR("tm=%3i/%3i %4iW"),minute,timerMinute,UstPower); //запись в буфер текста и значений температуры в подготовленном
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
           sprintf_P(lcd_buffer,PSTR("%3u,%3u %4iW"),temps[3],temps[4],PowerMinute); //запись в буфер текста и значений температуры в подготовленном
          }
          break;
        case 116: // Пивоварня - клон браумастера
          DisplayBeer();
          break;
        case 103: // Регулятор мощности
          if (DispPage==0) 
          {
            #ifndef USE_SLAVE
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u RMU=%3u"),hour,minute,second,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              #if SIMPLED_VERSION==20
             sprintf_P(lcd_buffer,PSTR("P=%3u/%3u%% c%3u"),UstPowerReg/10,Power/10,indexOut); //запись в буфер текста и значений температуры в подготовленном
              #else
             sprintf_P(lcd_buffer,PSTR("P=%4u/%4u c%3u"),UstPowerReg,Power,indexOut); //запись в буфер текста и значений температуры в подготовленном
              #endif
              #ifdef TEST
              if (NUM_PHASE>1)sprintf_P(lcd_buffer,PSTR("%s"),my_rx_buffer); //запись в буфер текста и значений температуры в подготовленном
              #endif
            #else
             sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u RMU=%3u"),hour,minute,second,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
             sprintf_P(lcd_buffer,PSTR("PSlv=%4u/%4u"),UstPower,Power); //запись в буфер текста и значений температуры в подготовленном
            #endif
          }
          else
          {
           sprintf_P(lcd_buffer,PSTR("D2 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
            my_lcdprint(lcd_buffer);
            #ifndef USE_SLAVE
           sprintf_P(lcd_buffer,PSTR("Up to auto=%4uW"),Power); //запись в буфер текста и значений температуры в подготовленном
            #else
            if (flAutoDetectPowerTEN)
             sprintf_P(lcd_buffer,PSTR("Up to auto=%4uW"),Power); //запись в буфер текста и значений температуры в подготовленном
            else
             sprintf_P(lcd_buffer,PSTR("SlaveOn (Up)=%1i"),(int) SlaveON); //запись в буфер текста и значений температуры в подготовленном
            #endif
          }
          break;
        case 105: // Отбор голов33
//          DisplaySimpleGLV();
//          break;
        case 104: // Перевый (недробный) отбор
        case 106: // Второй дробный отбор
        case 107: // Третий дробный отбор
          DisplaySimpleDistill();
          break;
    
       case 117: // Фракционная перегонка
          DisplayFracionDistill();
          break;
    
        case 108: // Разваривание
        case 113: // Разваривание мучно-солодового затора (без варки).
        case 114: // Разваривание
          DisplayRazvar();
          break;
        case 109: // Ректификация
        case 118: // Ректификация
          DisplayRectif();
          break;
          #ifndef TEST
          #ifndef DEBUG // Это отображение информации выкусываем, если в режиме теста, потому что не хватает памяти
          #ifndef TESTGSM
          #ifndef TESTGSM1
        case 110: // Дистилляция с дефлегматором
          DisplayDistDefl();
          break;
        case 111: // НДРФ
         DisplayRectif();
         break;
          #endif
          #endif
          #endif
          #endif
             
        case 112: // NBK
          DisplayNBK();
          break;
    
        case 130: // Резерв
          DisplayExtContol();
          break;
        case 129: // тест клапанов
          DisplayTestKLP();
          break;
        case 248:
//         sprintf_P(lcd_buffer,PSTR("LOW LEVEL VOLTS!")); //запись в буфер текста и значений температуры в подготовленном
//          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
//         sprintf_P(lcd_buffer,PSTR("Umax=%i Sec=%3i"),MaxVoltsOut,(int) ErrCountIndex*12); //запись в буфер текста и значений температуры в подготовленном
          break;
        case 249:
         sprintf_P(lcd_buffer,PSTR("NO DETECT ZERO!")); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
         sprintf_P(lcd_buffer,PSTR("Umax=%i"),MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
          break;
        case 250:
         sprintf_P(lcd_buffer,PSTR("ALARM VODA !")); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          break;
        case 251:
         sprintf_P(lcd_buffer,PSTR("ERR Ds18b20!")); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
         sprintf_P(lcd_buffer,PSTR("Num=%i"),(int) NumErrDs18); //запись в буфер текста и значений температуры в подготовленном
    
          break;
        case 252:
         sprintf_P(lcd_buffer,PSTR("ALARM GAS SENS!")); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          break;
        case 253:
         sprintf_P(lcd_buffer,PSTR("NPG OSUHENIE!")); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
         sprintf_P(lcd_buffer,PSTR("U_NPG=%i CNT=%i"),U_NPG, countAlrmNPG); //запись в буфер текста и значений температуры в подготовленном
          break;
        case 254:
         sprintf_P(lcd_buffer,PSTR("NPG PEREPOLN!")); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
         sprintf_P(lcd_buffer,PSTR("U_NPG=%i CNT=%i"),U_NPG, countAlrmNPG); //запись в буфер текста и значений температуры в подготовленном
          break;
    
        }   
        // Это обычное состояние
        //
        if (StateNPG==1 && DispPage==0)sprintf_P(lcd_buffer,PSTR("Napolnenie NPG..")); //запись в буфер текста и значений температуры в подготовленном
    
    }
     // Третья страница отображения универсальна, там показываем напряжение, дистанцию и возможное число ошибок
     // расчета среднеквадратичного. 
     
    if (DispPage==2)
    {
     sprintf_P(lcd_buffer,PSTR("D3 %3i,w%3u,i%3i"),(int)flGPRSState,(int)timeWaitGPRS,(int)timeGPRS); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
     sprintf_P(lcd_buffer,PSTR("%4iW,%3uV,%3uA"),FactPower,MaxVoltsOut,MaxIOut); //запись в буфер текста и значений температуры в подготовленном
    }
    // На четвертой странице показываем всю температуру и давление
    if (DispPage==3)
    {
       sprintf_P(lcd_buffer,PSTR("D4 T=%3i,%3i,%3i"),temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer);
       sprintf_P(lcd_buffer,PSTR("%3i,%3i P=%3imm"),temps[3],temps[4],U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    }
    
    // На пятой странице показываем состояние датчиков уровней
    if (DispPage==4)
    {
      sprintf(lcd_buffer,"D5 V=%4u,U=%4u", U_VODA,U_UROVEN); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"GL=%4u,At=%3imm",U_GLV, PressAtm); //запись в буфер текста и значений температуры в подготовленном
    }

    // На шестой странице показываем состояние датчиков уровней
    if (DispPage==5)
    {
     sprintf_P(lcd_buffer,PSTR("D6 GAS=%4u"), U_GAS); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
     sprintf_P(lcd_buffer,PSTR("zPS=%3u,%4uW"),(int) zPSOut,UstPwrPH1); //запись в буфер текста и значений температуры в подготовленном
    }

    // На седьмой странице показываем состояние регулятора мощности
    if (DispPage==6)
    {
      #if NUM_PHASE==1
         sprintf_P(lcd_buffer,PSTR(" %4i,%4i,%4iW"),UstPwrPH1,UstPwrPH2,UstPwrPH3); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
         sprintf_P(lcd_buffer,PSTR("D7 %3i,%3i,%3i %%"),KtPhase[0],KtPhase[1],KtPhase[2]); //запись в буфер текста и значений температуры в подготовленном
      #else
         sprintf_P(lcd_buffer,PSTR("D7 T=%4u,Z=%4u"), TimeOpenTriac,TicZero); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
         sprintf_P(lcd_buffer,PSTR("KLP=%4u,Bz=%3u"),TimeOpenKLP,(int)b_value[0]); //запись в буфер текста и значений температуры в подготовленном
      #endif
    }

    // На восьмой можно сменить состояние процесса.
    if (DispPage==7)
    {
     sprintf_P(lcd_buffer,PSTR("D8 State Debug")); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
     sprintf_P(lcd_buffer,PSTR("StateMacine=%i"),(int)StateMachine); //запись в буфер текста и значений температуры в подготовленном
    }
    
    // На девятой состояние ПИД-регулятора
    if (DispPage==8)
    {
     sprintf_P(lcd_buffer,PSTR("D9 N=%4i O=%4i"),NewErr,OldErrOut); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
     sprintf_P(lcd_buffer,PSTR("Dt=%4i It=%4i"),Dt,It); //запись в буфер текста и значений температуры в подготовленном
    }
    // На Десятой странице показываем максимальные температуры за процесс температуру и давление
    if (DispPage==9)
    {
       sprintf_P(lcd_buffer,PSTR("D10 MaxT=%3i,%3i"),Maxtemps[0],Maxtemps[1]); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer);
       sprintf_P(lcd_buffer,PSTR("%3i,%3i,%3i"),Maxtemps[2],Maxtemps[3],Maxtemps[4]); //запись в буфер текста и значений температуры в подготовленном
    }
    // На 11  странице показываем параметры расчета ПИД-регулятора
    if (DispPage==10)
    {
     sprintf_P(lcd_buffer,PSTR("D11 N,O=%3i %3i"),NewErrTemp,OldErrTempOut); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
     sprintf_P(lcd_buffer,PSTR("KId%4i %4i %3i"),KtT,ItTemp,DtTemp); //запись в буфер текста и значений температуры в подготовленном
    }

    if (flDspDop && DispDopInfo>0) // Если отображаем дополнительную информацию, тогда проверяем ее статус
    {

      if (BeepStateProcess>1) 
      {
        if (DispDopInfo==3 || DispDopInfo==4)
        {
          if (!(BeepStateProcess&B00000010) && DispDopInfo==3) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 2 разряде
          if (!(BeepStateProcess&B00000100) && DispDopInfo==4) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 3 разряде
        }
        else
          my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
      }
      else
        my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
      
      
      if(DispDopInfo==1)sprintf_P(lcd_buffer,PSTR("Smena TARA!(%3i)"),(IspReg==117 || IspReg==118) ? COUNT_ALARM_UROVEN_FR-CountAlarmUroven :COUNT_ALARM_UROVEN-CountAlarmUroven); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==2)sprintf_P(lcd_buffer,PSTR("VODA! (%3i)"),COUNT_ALARM_VODA-CountAlarmVoda); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==3)sprintf_P(lcd_buffer,PSTR("Low Power! %3iV"),MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==6)sprintf_P(lcd_buffer,PSTR("HIGH Power! %3iV"),MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==4)sprintf_P(lcd_buffer,PSTR("Err temp! ds=%2i"),(int) NumErrDs18 ); //Выводим на экран инфомацию о ошибке чтения датчика.
      if(DispDopInfo==5)sprintf_P(lcd_buffer,PSTR("!PRES=%3i/%3i/%2i" ),U_MPX5010,AlarmMPX5010,(MAX_ERR_MPX5010-CountAlarmMPX5010)); //Выводим на экран инфомацию о ошибке чтения датчика.
      
      // Активизируем разовую отправку состояния на сервер
      if (FlToGSM>1 && flGPRSState!=20  && flGPRSState!=164 && (timeGPRS==0 || flNeedCall==1) )
        {
          if (flNeedCall==1) 
           { 
              flGPRSState=40; // Активируем звонок если в этом есть необходимость
           }
           else  
           {   // Если в данный момент не производится дозвон, тогда активируем GPRS сессию. 
               if (flNeedCall!=2) flGPRSState=2;
           }
           // Активируем длительную сессию GPRS
          flNeedRefrServer=0;
          timeGPRS=250;
        }
    }
    
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 100:
   sprintf_P(lcd_buffer,PSTR("UstParam"),FlState); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 101:
   sprintf_P(lcd_buffer,PSTR("IsR = Displaying")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 102:
   sprintf_P(lcd_buffer,PSTR("IsR = Termostat")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 103:
   sprintf_P(lcd_buffer,PSTR("IsR = Reg Power")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 104:
   sprintf_P(lcd_buffer,PSTR("IsR = 1 ND otbor")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 105:
   sprintf_P(lcd_buffer,PSTR("IsR = otbor GLV")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 106:
   sprintf_P(lcd_buffer,PSTR("IsR = 2 DR otbor")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 107:
   sprintf_P(lcd_buffer,PSTR("IsR = 3 DR otbor")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 108:
   sprintf_P(lcd_buffer,PSTR("IsR = Zator")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Zerno")); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 109:
   sprintf_P(lcd_buffer,PSTR("IsR = Rectif")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 110:// Дистилляция с дефлегматором
   sprintf_P(lcd_buffer,PSTR("IsR = Dist Defl")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 111:// НДРФ
   sprintf_P(lcd_buffer,PSTR("IsR = NDRF")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 112:// НБК
   sprintf_P(lcd_buffer,PSTR("IsR = NBK")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 113:// солодо-мучной затор (без варки
   sprintf_P(lcd_buffer,PSTR("IsR = Zator")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Solod - Muka"),PowerRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 114:// Охлаждение затора
   sprintf_P(lcd_buffer,PSTR("IsR = HLD Zator")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("by Chiller&Mixer"),PowerRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 115:// Таймер
   sprintf_P(lcd_buffer,PSTR("IsR = Timer")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("ust Power")); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 116:// Варка пива
   sprintf_P(lcd_buffer,PSTR("IsR = Brewing")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Beer")); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
   case 117:// Фракционная дистилляция
   sprintf_P(lcd_buffer,PSTR("IsR = Distill")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Fractional")); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
   case 118:// Фракционная ректификация
   sprintf_P(lcd_buffer,PSTR("IsR = Rectif")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Fractional")); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
 case 130:
   sprintf_P(lcd_buffer,PSTR("IsR = External")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Control")); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 129:
   sprintf_P(lcd_buffer,PSTR("IsR = Test")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Device (%i)"),FlState); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 200:
   sprintf_P(lcd_buffer,PSTR("Max_t_Tst=%5i"),TempTerm); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 201:
   sprintf_P(lcd_buffer,PSTR("Power TEN=%5u"),Power); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 202:
   sprintf_P(lcd_buffer,PSTR("Power Reg=%5u"),UstPowerReg); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 203:
   sprintf_P(lcd_buffer,PSTR("ParamUSART=%u"),FlToUSART); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 204:
   sprintf_P(lcd_buffer,PSTR("ParamGSM=%u"),FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    if(FlToGSM==1 || FlToGSM==0)sprintf_P(lcd_buffer,PSTR("GSM (SMS)")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==2)sprintf_P(lcd_buffer,PSTR("GPRS Megafon")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==3)sprintf_P(lcd_buffer,PSTR("GPRS BeeLine")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==4)sprintf_P(lcd_buffer,PSTR("GPRS MTS")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==5)sprintf_P(lcd_buffer,PSTR("GPRS Rostelecom")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==6)sprintf_P(lcd_buffer,PSTR("GPRS Tele 2")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM>=7)sprintf_P(lcd_buffer,PSTR("GPRS Reserv %i"), (int) FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==10)sprintf_P(lcd_buffer,PSTR("Wi-Fi")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==11)sprintf_P(lcd_buffer,PSTR("Android ext")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==12)sprintf_P(lcd_buffer,PSTR("Android int")); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM>12)sprintf_P(lcd_buffer,PSTR("Err! 0..11 (%i)"),(int) FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 205:
   sprintf_P(lcd_buffer,PSTR("dtTermostat=%3i"),Delta); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 206:
   sprintf_P(lcd_buffer,PSTR("Temp 1 Nedrobn")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Distill=%3i"),Temp1P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 207:
   sprintf_P(lcd_buffer,PSTR("Temp 2 Drobn")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Distill=%3i"),Temp2P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 208:
   sprintf_P(lcd_buffer,PSTR("Temp 3 Drobn")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Distill=%3i"),Temp3P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 209:
   sprintf_P(lcd_buffer,PSTR("Temp Razgon Rect")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("(+Kub,-Kol)=%3i"),tEndRectRazgon); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 210:
   sprintf_P(lcd_buffer,PSTR("Power")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Rectif=%3i"),PowerRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 211:
   sprintf_P(lcd_buffer,PSTR("Vvod Popravok")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("ds18b20 ")); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 212:
   sprintf_P(lcd_buffer,PSTR("Temp Okon Otbor")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Glv Rectif=%3i"),tEndRectOtbGlv ); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 213:
   sprintf_P(lcd_buffer,PSTR("CHIM Otbor GLV")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Rectif=%5u"),timeChimRectOtbGlv); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 214:
   sprintf_P(lcd_buffer,PSTR("%% CHIM Otbor GLV")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Rectif=%3i"),(int) ProcChimOtbGlv); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 215:
   sprintf_P(lcd_buffer,PSTR("CHIM Otbor SR")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Rectif=%5u"),timeChimRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 216:
   sprintf_P(lcd_buffer,PSTR("Delta Otbor SR")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Rectif=%3u"),tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 217:
   sprintf_P(lcd_buffer,PSTR("Temp Okon Otbor")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("SR Rectif=%3i"),tEndRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 218:
   sprintf_P(lcd_buffer,PSTR("Temp Okon")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Rectif=%3i"),tEndRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 250:
   sprintf_P(lcd_buffer,PSTR("min %% CHIM")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR(" Otbor SR=%2i"),minProcChimOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 251:
   sprintf_P(lcd_buffer,PSTR("Edit Temp Stab")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Rectif=%3i"),tStabSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 252:
   sprintf_P(lcd_buffer,PSTR("Beg %% CHIM")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR(" Otbor SR=%2i"),begProcChimOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 253:
   sprintf_P(lcd_buffer,PSTR("Popr MPX=%4i"),P_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%4i/%4i"),U_MPX5010,U_MPX5010+P_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 219:
   sprintf_P(lcd_buffer,PSTR("Power GLV simple")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Distill=%4i"),PowerGlvDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 220:
   sprintf_P(lcd_buffer,PSTR("Power simple")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Distill=%4i"),PowerDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 221:
   sprintf_P(lcd_buffer,PSTR("Temp Begin Dist")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("(+Def -Kub)=%3i"),TempDeflBegDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 222:
   sprintf_P(lcd_buffer,PSTR("Temp Distill")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("With Defl=%3i"),TempDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 223:
   sprintf_P(lcd_buffer,PSTR("Delta Distill")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("With Defl=%3i"),DeltaDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 224:
   sprintf_P(lcd_buffer,PSTR("Temp Kub Okon")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("DistWithDefl=%3i"),tEndDistDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 225:
   sprintf_P(lcd_buffer,PSTR("BeepEndProc=%1u"),BeepEndProcess); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 226:
   sprintf_P(lcd_buffer,PSTR("BeepStateProc=%1u"),BeepStateProcess); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 227:
   sprintf_P(lcd_buffer,PSTR("BeepKeyPress=%1u"),BeepKeyPress); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 228:
   sprintf_P(lcd_buffer,PSTR("Power Razvar")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Zerno=%4i"),PowerRazvZerno); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 229:
   sprintf_P(lcd_buffer,PSTR("Power Varka")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Zerno=%4i"),PowerVarkaZerno); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 230:
   sprintf_P(lcd_buffer,PSTR("Period Refresh"));
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Server(sec)=%3u"),(unsigned int) PeriodRefrServer); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer);
    break;
  case 231:
   sprintf_P(lcd_buffer,PSTR("U Peregrev=%3uV"),(unsigned int) NaprPeregrev); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 232:
   sprintf_P(lcd_buffer,PSTR("Urv Barda=%4i"),UrovenBarda); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
   sprintf_P(lcd_buffer,PSTR("Barda(%4u)"),U_GLV); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer);
    break;
  case 233:
   sprintf_P(lcd_buffer,PSTR("Provod SR=%4i"),UrovenProvodimostSR); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 234:
   sprintf_P(lcd_buffer,PSTR("Time Stab (+/-)")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Kolonna=%5isec"),TimeStabKolonna); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 235:
   sprintf_P(lcd_buffer,PSTR("Edit T & CHIM")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Count CHIM=%3i"),(int) CntCHIM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 236:
   sprintf_P(lcd_buffer,PSTR("Auto - CHIM=%3i"),(int)DecrementCHIM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 237:
   sprintf_P(lcd_buffer,PSTR("Auto + CHIM=%3i"),(int)IncrementCHIM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 238:
   sprintf_P(lcd_buffer,PSTR("Time Auto +")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("CHIM=%5isec"),TimeAutoIncCHIM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 239:
   sprintf_P(lcd_buffer,PSTR("Time reStab(+/-)")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Kolonna=%5isec"),TimeRestabKolonna); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 240:
   sprintf_P(lcd_buffer,PSTR("Beer Pause")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Count =%3i"),(int) CntPause); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 241:
   sprintf_P(lcd_buffer,PSTR("Power correct")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("ASC712 =%3i"),(int) CorrectASC712); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 242:
   sprintf_P(lcd_buffer,PSTR("Server adr=")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%3u.%3u.%3u.%3u"),(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3]); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 243:
   sprintf_P(lcd_buffer,PSTR("Server port=")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%u"),ipPort); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 244:
   sprintf_P(lcd_buffer,PSTR("ID Device=")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%s"),idDevice); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 245:
   sprintf_P(lcd_buffer,PSTR("My Phone=")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%s"),my_phone); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 246:
   sprintf_P(lcd_buffer,PSTR("Alarm Pressure")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("MPX5010=%i"),AlarmMPX5010); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 247:
   sprintf_P(lcd_buffer,PSTR("Use Avtonom")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("HLD=%i"),FlAvtonom); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 248:
   sprintf_P(lcd_buffer,PSTR("Time Open")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("BRD=%i"),(int)timeOpenBRD); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 249:
   sprintf_P(lcd_buffer,PSTR("PID Paramters")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%4i %4i %4i"),(int)PIDTemp[0],(int)PIDTemp[1],(int)PIDTemp[2]); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 254:
   sprintf_P(lcd_buffer,PSTR("Power NBK=%4i"),PowerNBK); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 255:
   sprintf_P(lcd_buffer,PSTR("Wi-Fi AP=")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%s"),WiFiAP); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 256:
   sprintf_P(lcd_buffer,PSTR("Wi-Fi Password=")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%s"),WiFiPass); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 257:
   sprintf_P(lcd_buffer,PSTR("Fraction Dist")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Count =%3i"),(int) CountFractionDist); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 258:
   sprintf_P(lcd_buffer,PSTR("Fraction Rectif")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Count =%3i"),(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 259:
   sprintf_P(lcd_buffer,PSTR("Temp Zasyp")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Zator=%3i"),(int) TempZSP*10); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 260:
   sprintf_P(lcd_buffer,PSTR("Temp Osahariv")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Zator=%3i"),(int) TempZSPSld*10); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 261:
   sprintf_P(lcd_buffer,PSTR("Temp Brogenia")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Zator=%3i"),(int) TempHLDZatorBrog1*10); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 262:
   sprintf_P(lcd_buffer,PSTR("PhasePW %5i="),Power); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%4i+%4i+%4i"),PowerPhase[0],PowerPhase[1],PowerPhase[2]); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 263:
   sprintf_P(lcd_buffer,PSTR("Phase%% %3i="),(int)KtPhase[0]+KtPhase[1]+KtPhase[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("%3i + %3i + %3i"),(int)KtPhase[0],(int)KtPhase[1],(int)KtPhase[2]);
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;   
  case 264:
   sprintf_P(lcd_buffer,PSTR("min Pressure")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("NBK=%3i+%3i=%3i"),(int) minPressNBK*5,(int) deltaPressNBK,(int) minPressNBK*5+(int) deltaPressNBK); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 265:
   sprintf_P(lcd_buffer,PSTR("delta Pressure")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("NBK=%3i+%3i=%3i"),(int) minPressNBK*5,(int) deltaPressNBK,(int) minPressNBK*5+(int) deltaPressNBK); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 266:
   sprintf_P(lcd_buffer,PSTR("time Pressure")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("NBK=%3i"),(int) timePressNBK*5); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 267:
   sprintf_P(lcd_buffer,PSTR("Upravl Nasos")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("NBK=%3i"),(int)UprNasosNBK); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 268:
   sprintf_P(lcd_buffer,PSTR("%% otbor Tsarga")); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Paster(+/-)=%3i"),(int)ProcChimOtbCP); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 269:
    sprintf(lcd_buffer,String(F("ds18 Nums")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,String(F("%02i %02i %02i %02i %02i")).c_str(),(int)ds1820_nums[0]+1,(int)ds1820_nums[1]+1,(int)ds1820_nums[2]+1,(int)ds1820_nums[3]+1,(int)ds1820_nums[4]+1); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;   
  case 270:
    sprintf(lcd_buffer,String(F("Time AtmP=%3i")).c_str(),(int)timePressAtm); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,""); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 300:
   sprintf_P(lcd_buffer,PSTR("Temp%1i=%3u"),nPopr,temps[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("Popr=%3i T=%3u"),ds1820_popr[nPopr], (temps[nPopr]+ds1820_popr[nPopr])); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 301:
   sprintf_P(lcd_buffer,PSTR("TempK(%1i)=%4i"),(int) nPopr, tempK[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    if (flPopr==0) 
     {  
       sprintf_P(lcd_buffer,PSTR("%s %c"),lcd_buffer,'*');
     }
     
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
   sprintf_P(lcd_buffer,PSTR("CHIM(%1i)=%3i"), (int) nPopr, (int) CHIM[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    if (flPopr==1) 
     {  
       sprintf_P(lcd_buffer,PSTR("%s %c"),lcd_buffer,'*');
     }
    
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 302:
    // Первое значение это время работы насоса
    if (nPopr==0) 
     sprintf_P(lcd_buffer,PSTR("Work Pump =%2im"),(int) tempP[nPopr]); //запись в буфер текста и значений температуры в подготовленном 
    else
     sprintf_P(lcd_buffer,PSTR("TemP(%1i)=%3i.0"),(int) nPopr, (int) tempP[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    
    if (flPopr==0) 
     {  
       sprintf_P(lcd_buffer,PSTR("%s %c"),lcd_buffer,'*');
     }
     
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    if (nPopr==0) 
     sprintf_P(lcd_buffer,PSTR("Pause Pump=%2im"),(int) timeP[nPopr]); //запись в буфер текста и значений температуры в подготовленном 
    else
     sprintf_P(lcd_buffer,PSTR("TimP(%1i)=%3i m"), (int) nPopr, (int) timeP[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      
    if (flPopr==1) 
     {  
       sprintf_P(lcd_buffer,PSTR("%s %c"),lcd_buffer,'*');
     }
    
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 303:
   sprintf_P(lcd_buffer,PSTR("%3u.%3u.%3u.%3u"),(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=-1;
    while (j<nPopr*4)
    {
      j++;
      lcd_buffer[j]=' ';
    }
    lcd_buffer[j+1]='*';
    lcd_buffer[j+2]=0;
    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    
    break;
  case 304:
   sprintf_P(lcd_buffer,PSTR("%s (%3u)"),idDevice,(unsigned int)idDevice[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;
    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    
    break;

  case 305:
   sprintf_P(lcd_buffer,PSTR("%s/%3u)"),my_phone,(unsigned int)my_phone[nPopr]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;
    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    
    break;
  case 309:
   sprintf_P(lcd_buffer,PSTR("%4i %4i %4i"),(int)PIDTemp[0],(int)PIDTemp[1],(int)PIDTemp[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0)sprintf_P(lcd_buffer,PSTR("   P"));
    if (nPopr==1)sprintf_P(lcd_buffer,PSTR("        I"));
    if (nPopr==2)sprintf_P(lcd_buffer,PSTR("             D"));
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;

  case 310:
   sprintf_P(lcd_buffer,PSTR("%s /%3u"),WiFiAP,(unsigned int)WiFiAP[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;
    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    
    break;
  case 311:
   sprintf_P(lcd_buffer,PSTR("%s /%3u"),WiFiPass,(unsigned int)WiFiPass[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;
    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    
    break;
  case 312:
    // последнее значение это тест фракционника
    if (nPopr==MAX_CNT_FRACTION_DIST)
      { 
         sprintf_P(lcd_buffer,PSTR("Fraction Dist")); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
         sprintf_P(lcd_buffer,PSTR("Test =%3i"),(int) TekFraction+1); //запись в буфер текста и значений температуры в подготовленном
      }
    else
    {
      if (TempFractionDist[nPopr]>=0)
       sprintf_P(lcd_buffer,PSTR("tFrDst(%1i)=%4i"),(int) nPopr+1, (int) TempFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      else
       sprintf_P(lcd_buffer,PSTR("timFD(%1i)=%5im"),(int) nPopr+1, (int) -TempFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном        
      
      if (flPopr==0) 
       {  
         sprintf_P(lcd_buffer,PSTR("%s%c"),lcd_buffer,'*');
       }
       
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      
      if (flPopr==1) sprintf_P(lcd_buffer,PSTR("Angl=%3i*,%4iW"),(int) AngleFractionDist[nPopr] , PowerFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном
                else sprintf_P(lcd_buffer,PSTR("Angl=%3i ,%4iW"),(int) AngleFractionDist[nPopr] , PowerFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном 
     
      if (flPopr==2) sprintf_P(lcd_buffer,PSTR("%s%c"),lcd_buffer,'*');
    }
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 313:
    // последнее значение это тест фракционника
    if (nPopr==MAX_CNT_FRACTION_RECT)
      { 
         sprintf_P(lcd_buffer,PSTR("Fraction Rect")); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
         sprintf_P(lcd_buffer,PSTR("Test =%3i"),(int) TekFraction+1); //запись в буфер текста и значений температуры в подготовленном
      }
    else
    {
      if (TempFractionRect[nPopr]>=0)
         sprintf_P(lcd_buffer,PSTR("tFrRect(%1i)=%4i"),(int) nPopr+1, (int) TempFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      else
       sprintf_P(lcd_buffer,PSTR("timFR(%1i)=%5im"),(int) nPopr+1,(int) -TempFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном        
         
      if (flPopr==0) 
       {  
         sprintf_P(lcd_buffer,PSTR("%s%c"),lcd_buffer,'*');
       }
       
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
     sprintf_P(lcd_buffer,PSTR("Angle=%3i"),(int) AngleFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном 
      
      if (flPopr==1) sprintf_P(lcd_buffer,PSTR("%s%c"),lcd_buffer,'*');
    }
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 314:
   sprintf_P(lcd_buffer,PSTR("%4i %4i %4i"),(int)PowerPhase[0],(int)PowerPhase[1],(int)PowerPhase[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0)sprintf_P(lcd_buffer,PSTR(" PH1"));
    if (nPopr==1)sprintf_P(lcd_buffer,PSTR("      PH2"));
    if (nPopr==2)sprintf_P(lcd_buffer,PSTR("           PH3"));
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 315:
   sprintf_P(lcd_buffer,PSTR("%3i %3i %3i=%3i"),(int)KtPhase[0],(int)KtPhase[1],(int)KtPhase[2],(int)KtPhase[0]+KtPhase[1]+KtPhase[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0)sprintf_P(lcd_buffer,PSTR("PH1"));
    if (nPopr==1)sprintf_P(lcd_buffer,PSTR("    PH2"));
    if (nPopr==2)sprintf_P(lcd_buffer,PSTR("        PH3"));
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 316:
    sprintf(lcd_buffer,String(F("%02i %02i %02i %02i %02i")).c_str() ,(int)ds1820_nums[0]+1,(int)ds1820_nums[1]+1,(int)ds1820_nums[2]+1,(int)ds1820_nums[3]+1,(int)ds1820_nums[4]+1); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<(nPopr)*3+1)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
    
  default:
    break;
  }

  //    
  //  lcd.setCursor(0, 0);
  //  my_lcdprint(Seconds);
  //  lcd.setCursor(5, 0);
  //  my_lcdprint(MaxVoltsOut);
  //  lcd.setCursor(9, 0);
  //  my_lcdprint((long)MaxVoltsOut*707/1000);
  //  lcd.setCursor(0, 1);
  //  my_lcdprint(index_input);
  //  lcd.setCursor(5, 1);
  //  my_lcdprint(TimeOpenTriac);
  //  NeedDisplaying=false;
  //  lcd.setCursor(10, 1);
  //  my_lcdprint(TicZero);
  // предупреждения теперь выводим на всех страницах.
  
  if (flNumStrPrint<2) 
  {
    lcd_buffer[0]=0;
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
  }
  NeedDisplaying=false;

}
