
// контроль нуля идет на 1-е прерывание (это pin 3)
// Управление симистором для фазового регулятора мощности реализовано через PIN 36
// АЦП от трансформатора подключен на pin А2 (раньше шел на pin A3)
// Датчики ds18b20 сидят на 3ь7 пине. (потому что на пины с 7 по 13 я подключил ULM2003, из-за желания использовать встроенный ШИМ в Ардуино)


// Кнопки подключены на следующие пины:
// почему на этих - да потому, что они рядом идут, и еще пин земли рядом, а гребенку 6 онтактов проще паять и подключать, чем каждый контакт одтельно
// PIN_SELECT 53
// PIN_RIGHT 51
// PIN_LEFT 49
// PIN_UP 45
// PIN_DOWN 47

// Уровень НПГ подключен по следующей схеме: Подтяджка - 10 ком, защита -330 ом, замыкание - 30, резистор 1.1К (верхниц уровень) - 128, 2.2К (рабочий уровень) - 256, 3,3К (нижний уровень)-266

// Почему-то иногда глючит дисплей - когда это происходит (на нем появляются иероглифы или перестает отображаться текст),
// нажать и держать одновременно клавишу влево и впрёаво, либо клавишей вправо перейти на 6-ю страницу, дисплей переинициализируется.
// одновременное нажатие кнопок вверх и вних позволчет перейти к следующему этапу процесса ректификации , также можно сделать это на 8 странице кнопками вверх и вниз однако это не рекомендуется работа не гаранитируется.

// Клапана для управления ШИМ подключены, начиная с PIN 22
// Всего максимум 5 клапанов, то есть на пины с 22 по 26 реализован
// программный ШИМ по количество полупериодов с контролем нуля.


// Дисплей на следующих пинах - почему на этих - да потому, что они рядом идут, и еще пин земли рядом, как раз для вывода R/W дисплея
// а гребенку из 7 контактов проще паять и подключать, чем каждый контакт одтельно
// LiquidCrystal lcd(52,50, 48, 46, 44, 42);

//#define TEST   // Раскомметировать, если нужно получать всяческие тестовые значения через Serial1
//#define TESTMEM   // Раскомметировать, если нужно получать всяческие тестовые значения через Serial1
//#define TESTGSM   // Раскомметировать, если нужно дублировать входящюю информацияю из serial2 (сотового телефона) в Serial1 (для отладки)//.
//#define TESTGSM1   // Раскомметировать, если нужно дублировать входящюю информацияю из serial2 (сотового телефона) в Serial1 (для отладки)
//#define TESTRM   // Раскомметировать, если нужно получать тестовые значения регулятора мощности через Serial1
//#define TESTERR   // Раскомметировать, если нужно получать тестовые значения ошибок через Serial1
//#define DEBUG  // Режим отладки, в этом режиме не считываются значения датчиков температуры, а они передаются через монитор порта в ардуине

#define USE_ZMPT 1   // Раскомметировать, если нужно получать тестовые значения ошибок через Serial1

//  (монитор порта надо настроить так, чтобы он выдавал возврат каретки и перевод строки) 
#define PR_REWRITE_EEPROM 9  // Константа, которая содержит признак необходимости перезаписи энергонезависимой памяти (1-254). 
// При запуске программы, значение 0-го байта ЕЕПРОМ сравнивается с этим знначением, 
// и если они не совпадают, тогда энергонезависимая память переписывается текущими значениями переменных
// То есть для значений переменных из скетча в контроллер, ее значение надо поменять например с 9 до 10.
#define NUM_PHASE 0
unsigned char WiFiAP[12]="A2345678901";
unsigned char WiFiPass[12]="12345678901";
char my_phone[13]="+77777777777";
const char my_version[]="v3.60";
unsigned char idDevice[11]="0123456789";
unsigned char ip[4]={0,0,0,0};
unsigned int ipPort=20123;
char CorrectASC712=2;      // Признак того, как надо использовать датчик asc712 
                         // (0- не надо, 1 - только показывать мощность, 2-корректировать мощность через фактический ток, 3- ПИД регулирование через ток)

#define SIMPLED_VERSION 0      // Признак того, насколько упрощена версия
                                // 0 - стандартная
                                // 1 - с твердотельным реле в качестве регулятора мощности по брезинхему, с датчиком ASC712 30A в качестве датчика напряжения в сети
                                // с двумя релейным модуля для управления клапанами отбором голов и хвостов и товарного спирта.
                                // LCD keypad shield в качестве кнопок и экрана.
                                // 2 - то же, что и 1, но с цифровыми датчиками уровня спирта, голов, разлития жидкости
                                // 3 - то же, что и 2, но только с одним датчиком уровня спирта без датчика голов и разлития жидкости.
                                // 4 - то же что и 3, но с датчиком напряжения на трансформаторе.
                                // 5 - это почти нулевая версия, но разгон и двигатель управляются реле с низким уровнем и используется LCD keypad shield в качестве дисплея и кнопок.
                                // 6-  то же что и 5 но с поддержкой НПГ, с расчетом фактической мощности через датчик тока..
                                // 7 - slave конороллер, управляемый через внешние пины.
                                // 8 - То же что и 2, но с аналоговыми датчиками уровня спирта, голов, разлития жидкости.
                                // 9 - То же что и 5, но с расчетом фактической мощности через датчик тока.
                                // 20 - эксперимент с трехфазным нестабилизированным контроллером.
                                // 30 - то же что и 5 но с измененными пинами
                                        
#define SENSITIVE_ASC712 135 // Чувствительность датчика тока (показаний АЦП ардуино на 10 ампер тока 135 для 30А датчика, 205 для 20А датчика 82 для 50А датчика)

#define KLP_HIGH 1              // Для клапанов с низким уровнем управления поменять 0 на 1

#include <Wire.h>               //при использовании I2C раскомментировать
#include <LiquidCrystal_I2C.h>  //при использовании I2C раскомментировать

#define USE_LCD_KEYPAD_SHIELD 1  // 1 - использовать стандартный шильд с кнопкми ардуино, 0 - не использовать
//#define USE_PROVODIMOST_SR    2 // (теперь за это отвечает переменная UrovenProvodimostSR) 1 - использовать датчик проводимости спирта для контроля окончания голов, 0 - не использовать,
// 2 - использовать датчик проводимости как индикатор наполнения приемной емкости с головами.

int UrovenProvodimostSR=0;   // Уровень проводимости, меньше которого считаем, что закончились головы и начался спирт.
int UrovenBarda=250;        // Уровень сигнала, достижение котогого свидетельсвует о срабатывании датчика бардоотводчика.

#define PIN_PROVODIMOST_SR A7        // Пин для анализа проводимости спирта (аналоговый пин А7)
#define MAX_COUNT_PROVODIMOST_SR 6  // Количество срабатываний датчика, по достижении которых можно точно сказать, что головы закончились
// Каждое значение - это 5 секунд, то есть в данном случае датчик должен показывать 30 секунд проводимость менее 20


#define UROVEN_ALARM 1        // Уровень сигнала, достижение котогого свидетельсвует о срабатывании аналогового датчика (в обычном состоянии он выведен на значение около 1000 для датчиков на уменьшение напряжения)
                               // или на значение около 0-10 для датчиков на увеличение напряжения 
#define COUNT_ALARM 6          // Сколько должно держаться значение уровня, чтобы сработало предупреждение каждое значение - это полсекунды.
#define COUNT_ALARM_VODA 60    // Сколько должно держаться значение разлития воды, чтобы сработала тревога каждое значение - это полсекунды.
#define COUNT_ALARM_UROVEN 200 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости каждое значение - это полсекунды.
#define COUNT_ALARM_UROVEN_FR 60 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости при фракционной перегонке каждое значение - это полсекунды.

#ifdef DEBUG
#define COUNT_ALARM_UROVEN 20 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости каждое значение - это полсекунды.
#endif

#define PIN_GAS_SENSOR A8        // Пин для анализа датчика загазованности (спирта)
#define USE_GAS_SENSOR 0        // Надо ли использовать датчик загазованности
#define UROVEN_GAS_SENSOR 700    // Уровень сигнала, достижение котогого свидетельсвует о срабатывании датчика спиртового пара
#define COUNT_GAS_SENSOR 6          // Сколько должно держаться значение уровня, чтобы сработала тревога каждое значение - это полсекунды.

#define TIME_PROGREV_GAS_SENSOR 60    // Время для програва датчика спиртовых паров газа.


#define USE_ALARM_UROVEN 2  // Нужно ли использовать датчик уровня в приемной емкости ардуино 1- использовать для остановки всег процесса
                            // 2 - датчик используется как уровень при котором останавливается отбор, но не останавливается ректификация
#define USE_ALARM_VODA   0  // Нужно ли использовать датчик разлития воды ардуино

//#define NPG_UROVEN_PIN A3         // Пин уровня НПГ. (закомментировать, если НПГ не используется во избежании ложных сработок)
#if NUM_PHASE==1
#define NPG_UROVEN_PIN_MIN A8         // Пин уровня НПГ. (закомментировать, если НПГ не используется во избежании ложных сработок)
#define NPG_UROVEN_PIN_WORK A9         // Пин уровня НПГ. (закомментировать, если НПГ не используется во избежании ложных сработок)
#endif

#define MAX_TIME_WIFI 200;

#define MAX_COUNT_NPG_ALARM 60     // Количество сработок осушения или переполнения, чтобы достоверно детектировать состояние НПГ (каждое значение -полсекунды)

#define PIN_MPX5010 A9      // Пин датчика давления MPX5010DP

#define PIN_DVIGATEL 28 // Пин управления двигателем в фазовом режиме (не исползуется).

#define PIN_NASOS_NBK 12  // Пин управления насосом НБК через ШИМ (двигатель не шаговый, подключать полевик, например IRL2703 или транзисторный ключ или драйвер полевика).

#define PIN_NASOS_NBK_BRD 46  // Пин управления насосом бардоотводчика НБК через ШИМ (двигатель не шаговый, подключать полевик, например IRL2703 или транзисторный ключ или драйвер полевика).

unsigned char zPS=0; // Число прерываний нуля за секунду.
unsigned char zPSOut=0; // Число прерываний нуля за секунду для вывода на экран.
#define PIN_LIGHT 10
unsigned char PeriodRefrServer=30;

int TimeStabKolonna=900; // Время стабилизации колонны (положительное значение - время от последнего изменения температуры, отрицательное - абсолютное время).

#define MAX_TABLE_T 200

unsigned char tableS10[MAX_TABLE_T]; //табличное значение времени задежки открытия триака

#define MAX_TABLE_SQRT 26
unsigned char tableSQRT[MAX_TABLE_SQRT];  //Значение корня
unsigned int tableSQ[MAX_TABLE_SQRT];     //Значение квадрата
int TekTemp=0; //Текущая температура для отображения


int timeNBK=0;   // Время работы насоса НБК в секундах со скоростью SpeedNKB. По истечении этого времени насос остановится
int MaxPressByPeriod=0;
char minPressNBK=26;
char deltaPressNBK=25;
char timePressNBK=36;
char UprNasosNBK=1;

int tempDeflNBK=0;
unsigned char tempProlivNBK=160;


#define PIN_MIXER     32  // Пин управления мешалокой 

int timeMIXER=0; // Время работы двигателя миксера в секундах. По истечении этого времени мешалка остановится

int time1=0;   // Таймер для отсчета секунд 1
int time2=0;   // Таймер для отсчета секунд 2
int time3=0;   // Таймер для отсчета секунд 3
unsigned char timeBRD=0; // Таймер для отсчета времени открытия бардо-отводчика.
unsigned char timeGPRS=0;   // Таймер для отсчета GPRS соединения
unsigned char timeWaitGPRS=0;   // Таймер для отсчета ответа соединения
unsigned char timeRefrServer=0;   // Таймер для отсчета ответа соединения
char flAutoDetectPowerTEN=0;
char flNeedRefrServer=0;// Флаг того, что надо обновить данные на сервере.
char ErrGPRSConnectInernet=0;
char ErrGPRSConnectServer=0;
char flNeedCall=0; // Состояние необходимости звонка по тревоге
                   // 0 - звонить не нужно
                   // 1 - надо позвонить
                   // 2 - дозваниваемся
                   // 3 - звонили, получили ответ  

char cmdGPRS=' ';// Посланная команда от сервера
char cmdGPRSIsp=' ';// Выполненная команда от сервера
unsigned char flGPRSState=0;    // Флаг состояния обработки команд.
char stateAfterDelete=0; // Семантика обработки команд после некотрых завершающих состояний.

#define UDP_PROTOKOL  // Призанк использования UDP протокола для обмена

int U_MPX5010=0;       // Текущее значение давления (в 10 мм р.ст, то есть 100, это 10 мм рст).
int P_MPX5010=0;       // Поправка для датчика 
int AlarmMPX5010=100;   // Давление при котором надо выдавать сингал тревоги.

char countAlrmNPG=0;  // Количество сработок тревоги НПГ.

#define USE_DIFAVTOMAT 1       // Константа, которая показывает, используется ли дифавтомат в работе системы нужно для того, чтобы при нормальном завершении процесса
// при плановом отключении дифавтомата не выдавалась тревога.

#define PEREGREV_ON 1  // Того, что надо использовать режим работы клапана в режиме защиты от перегрева. 1- использовать, 0-нет.

int NaprPeregrev=300;  // Какое среднеквадратичное надо поддерживать для защиты клапанов от перегрева.

#if PEREGREV_ON==0
#define PER_KLP_OPEN  1 // клапана открываем через полу-период (аналог диода), чтобы не перегревались и
#define PER_KLP_CLOSE 1 // чтобы не быо гидроударов
#else
#define PER_KLP_OPEN  1000 // клапана на воду переводим в фазовое управление, чтобы раз в 10 секунд на них подавалось полное напряжение, а затем напряжение
#define PER_KLP_CLOSE 0    // из контанты NAPR_PEREGREV 150 
#endif

#define PIN_READU A2         // Аналоговый Пин для чтения сетевого напряжения (тока) 
#define PIN_READI A4         // Аналоговый Пин для чтения тока 

#define USE_ASC712 0           // Надо ли исполозовать датчик тока
#define PIN_DS18B20 37
#define RELAY_HIGH 1         // Какой сигнал подавать на релейные выходы мешалки и разгона 

#define ALL_OFF_HIGH 1         // Какой сигнал подавать на релейные выходы мешалки и разгона 

#define PIN_TRIAC  36    // Управление симистором реализовано через PIN 36

char flCorrASC712=1; // Флаг того, что надо расчитывать в данный момент среднеквадратичную мощность 1-мощность, 2-напряжение.

#if SIMPLED_VERSION==0
// Константа определяющая датчик потока воды.
#endif


//unsigned int Sec5;      // 1/5 секунды

// Номер телефона
// Номер телефона
const char sms_start[]="0410"; // SMS для старта (рестарта процесса), это большая русская буква А в формате UNICODE 
// (обязательно надо использовать русские буквы, чтобы SMS гарантированно пришел в формате UNICODE, другие программа 
// анализировать не может, точнее может, но надо заранее тогда знать, что придет последними 4 байтами в сообщении.
const char sms_stop[]="0411"; // SMS для остановки процесса, это большая русская буква Б в формате UNICODE
const char call_sms[]="0412"; // SMS для получения состояния в виде SMS  в любом случае, даже если включена отправка на сервер (большая русская буква В в UNICODE).
const char call_gprs[]="0413"; // SMS для отключения получения состояния в виде SMS  при звонке и перевода на получения состояния через GPRS (большая русская буква Г в UNICODE).


char lastSMSState=0; // Последнее отправленное состояние по SMS (Чтобы не отправлять его многократно)
char SMSOnCall=0;
char pdu_phone[14];  // Номер телефона в формате отправки SMS (заполняется автоматически)
unsigned char CntErrDs18=0;   // Количество глюков, зафиксированных от датчика 
int FindKt=0;         // Нужный процент открытия симистора (если отрицательный, значит 
char CntErrPower=0;   // Количество глюков, зафиксированных от датчика 
char NumErrDs18=0;   // Номер сглючившего датчика
//char NumErr=0;       // Код ошибки 1 - глючит датчик ds18b20

unsigned char SpeedNBK=0;
#define MAX_ERR_DS18 120    // После тридцати глюков подряд (а это тридцать секунд) от датчиков температуры, считаем, что процесс надо остановить.
#define MAX_ERR_MPX5010 120 // После 120 значений датчика давления подряд (а это 60 секунд) от датчиков температуры, считаем, что процесс надо остановить.
char CountAlarmMPX5010=0;   // Количество глюков, зафиксированных от датчика 

char timeOpenBRD=2; // Скорость порта, деленная на 1200

//#define STAB_RM 1  // Поставить 1, если программе пытаться стабилизировать регулятор мощности, путем запрета вывода информации на дисплей в момент работы, чтения температуры и т.д.
// Поставить 0, если идет отладка программы без подключенных датчиков, контроллера детектора нуля, схемы измерения текущего напряжения в сети. 

#include <Wire.h> 

#include <LiquidCrystal_I2C.h>

#include <avr/wdt.h>

#include <OneWire.h>

#include <EEPROM.h> 


//(раскомментировать если используется тест свободной памяти. 
//#ifdef TESTMEM 
//int freeRam () 
//{
//  extern int __heap_start, *__brkval; 
//  int v; 
//  return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval); 
//}
//#endif

unsigned int ee_addr; // Переменная для хранения текущего адреса чтения/записи в EEPROM
unsigned char eeReadChar()
{
  unsigned char lByte = EEPROM.read(ee_addr);
  ee_addr++;
  return lByte;
}

void eeWriteChar(char p_value)
{
  if (EEPROM.read(ee_addr)!=p_value)
    EEPROM.write(ee_addr, p_value);
  ee_addr++;
}

void eeWriteInt(int p_value)
{
  unsigned char lByte = (unsigned char) (p_value);
  unsigned char hByte =(unsigned char) (p_value >> 8);

  // Для экономии ресурса флеш памяти, сначала проверяем ее содержимое и запись производим только если значение отличается.
  eeWriteChar(lByte);
  eeWriteChar(hByte);
}

//This function will read a 2 byte integer from the eeprom at the specified address and address + 1
unsigned int eeReadInt()
{
  unsigned char lByte = eeReadChar();
  unsigned char hByte = eeReadChar();
  return (unsigned int) (lByte) | (unsigned int)  (hByte << 8);
}


#define MAX_INDEX_INPUT 540

#define MAX_INDEX_BY_PERIOD 90
#define MIN_INDEX_BY_PERIOD 75

#define CNT_PERIOD 4  // Кооличество полу-периодов для обсчета среднеквадратичного

//unsigned char ErrCountIndex=0;

#define BEEP_LONG 20   //Длительность сигнала оповещения о состояниях процесса

//int data_adc[MAX_INDEX_INPUT+1];
//#ifdef TESTRM
//int tic_adc[MAX_INDEX_INPUT+1];
//#endif

char lcd_buffer[33]; //Буфер для хранения данных для вывода на дисплей
char CntPeriod=0; //Номер обсчитываемого полу-периода
#define MY_RX_BUFFER_SIZE 90
#define MY_TX_BUFFER_SIZE 90
char my_tx_buffer[MY_TX_BUFFER_SIZE];
char my_rx_buffer[MY_RX_BUFFER_SIZE];
char my_gprs_buffer[MY_TX_BUFFER_SIZE];
char pos_rx_buffer=0;


unsigned long SqNaprT=0,SqNaprPrevT=0; //  Переменные для накапливания квадратов напряжений.

int NewErr;// Новая ошибка рассогласования
int OldErrOut;// Новая ошибка рассогласования
int OldErr;// Старая ошибка рассогласования
int It;     // Интегральная составляющая (без коэффициентов, чтобы избавиться от дробей, коэффициенты учтем в момент ее применения);
int Dt;     // Дифференциальная составляющая (без коэффициентов, чтобы избавиться от дробей, коэффициенты учтем в момент ее применения);

int NewErrTemp;// Новая ошибка рассогласования температуры
int OldErrTemp;// Старая ошибка рассогласования температуры
int OldErrTempOut;// Старая ошибка рассогласования температуры
int ItTemp;     // Интегральная составляющая температуры (без коэффициентов, чтобы избавиться от дробей, коэффициенты учтем в момент ее применения);
int DtTemp;     // Дифференциальная составляющая температуры (без коэффициентов, чтобы избавиться от дробей, коэффициенты учтем в момент ее применения);

int KtT;        // Коэффициент мощности ТЭНа в 1000 долей.

char PIDTemp[3]={20,10,30};    // Пропорциональный коэффициент пид-регулятора температуры [0]
                            // Интегральный коэффициент пид-регулятора температуры [1]
                            // Дифференциальный коэффициент пид-регулятора температуры [2]
unsigned char PIDTime=5;

int  FlState=0;  // Флаг состоянияч конечного автомата обработки нажатия кнопок клавиатуры 
unsigned char  IspReg=101; // Используемый в данный момент режим (по умолчанию пока ставим регулятор мощности)
char  DispPage=0; // Какую страницу отображать на дисплее
int TempTerm=200;
int Delta=5;
char FlToGSM=0;        // Признак того, что сотовый используется для вывода информации
char FlToUSART=0;      // Признак того, что CОМ-порт используется для вывода информации
char FlAvtonom=0;      // Признак того, что CОМ-порт используется для вывода информации
char BeepEndProcess=1; // Пищать динамиком по окончании процесса.
char BeepStateProcess=1; // Пищать динамиком при переходе между процессами.
char BeepKeyPress=1; // Пищать динамиком при нажатии на клавиши
int Temp1P=992;        // Температура первой (недробной) перегонки 
int Temp2P=964;        // Температура второй  перегонки  (дистилляция без дефлегматора)
int Temp3P=954;        // Температура третьей перегонки  (дистилляция без дефлегматора)
int TempKipenZator=800;// Температура начала закипания затора (либо это температура в верхней части заторника (если два термометра, либо в заторнике, если стоит один термометр)
char TempZSP=50;// Температура при которой можно засыпать несоложенку.
char TempZSPSld=63;// Температура при которой можно засыпать солод.
char TempHLDZatorBrog1=36;// Температура брожения
int PowerGlvDistil=800; // Мощность отбора голов при простой дистилляции
int PowerDistil=3000; // Мощность дистилляции
int PowerNBK=2400; // Мощность дистилляции
unsigned char SpeedNBKDst=0; // Скорость насоса НБК
int PowerRazvZerno=820; // Мощность, при которой будут развариваться зерновые (2 часа).
int PowerVarkaZerno=3000; // Мощность, при которой будут варится зерновые и доводиться до кипения (она меньше, чем мощность ТЭНов, потому что на полной мощности может быть факелирование).

int TempDeflBegDistil=700; //Температура в дефлегматоре, для начала подачи воды в холодильник.
int TempDefl=820; //Температура в дефлегматоре, которую надо поддерживать путем включения клапана дефлегматора
unsigned char DeltaDefl=20; //дельта Температуры в дефлегматоре, которую надо поддерживать путем включения клапана дефлегматора
int tEndDistDefl=985;       // Температура в кубе, при которой надо прекращать дистилляцию с дефлегматором 
int timerMinute=0;          // Время для таймера
int PowerMinute=0;          // Установленная мощность
int tEndRectRazgon=810;     // Температура окончания режима разгона 83.0 С +(температура в кубе) - (температура в колонне)
int PowerRect=1000;     // Мощность ректификации
int tStabSR;// Температура, относительно которой стабилизируется отбор СР
char ProcChimSR;// Текущий процент отбора СР
long SecTempPrev;// Знчение секудндомера, при котором было считана эта температура.
long SecTempPrev1;// Знчение секудндомера, при котором было считана эта температура.
long SecOstatok;// Знчение секудндомера, сколько еще осталось до стабилизации
int TempPrev=0;// Значение предыдущей температуры (для сверки с текущей (проверка стабилизации значение 344 для облегчения отладки)

int tEndRectOtbGlv=854;     // Температура окончания отбора голов 85.4 С
unsigned int timeChimRectOtbGlv=2000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 20 секунд)
char ProcChimOtbGlv=5;  // Процент ШИМ отбора голов (в данном случае это 5 процентов)
char ProcChimOtbHvost=90;  // Процент ШИМ отбора хвостов (в данном случае это 5 процентов)
unsigned int timeChimRectOtbSR=1000;  // Шим отбора голов (в полупериодах сетевого напряжения в данном случае это около 10 секунд)
char tDeltaRect=3;  // Дельта ректификации (в десятых градуса Цельсия) в данном случае - это 10 десятых, то есть 1 градус Цельсия
char tDeltaRectVZ=3;  // Дельта ректификации (в десятых градуса Цельсия) в данном случае - это 10 десятых, то есть 1 градус Цельсия
int tEndRectOtbSR=965;  // Температура окончания отбора спирта-ректификата и начала отбора хвостов (в данном случе 96.5 С)
int tEndRect=995;       // Температура в кубе, при которой прекращается ректификация (в данном случе 99.5 С)
char minProcChimOtbSR=20;  // Минимальный ШИМ, за который нельзя выходить при отборе СР
char begProcChimOtbSR=40;  // Начальный ШИМ отбора СР
char ProcChimOtbCP=0;  // Процент ШИМ отбора голов при работе с царгой пастеризации положительные значения-отбор относительно отбора голов, отрицательные - абсолютное значение

char StateMachine=0; // Состояние конечного автомата процесса 
char flNeedReadAlarm;// Флаг того, что нужно анализировать состояние датчиков НПГ, Уровня в приемной емкости, Разлития по полу.
char flAlarmUroven=0; // Флаг того, что уровень в приемной емкости достик предела
char flAlarmMPX5010=0; // Флаг того, что уровень в приемной емкости достик предела
char flNoAlarmLowPower=0; // Флаг того, что не надо предупреждать о низком напряжении в сети (оно в общем-то важно только для ректификации и НБК).


char FlUsart=0; // Признак того, что надо вывести информацию на СОМ-порт
char flRing=0; // Признак наличия звонка от своего номера (запрос на СМС о состоянии процесса);

char flNeedAnalyse=0; // Флаг того, что надо анализировать результат измерения температуры
//char flStateProcess=0;
char flNeedScanKbd=0; // Флаг того, что надо читать состояние клавиш 
char flScanKbd; // Признак того, что в данный момент идет сканирование клавиатуры, состояние не менять.
char CountKeys;       // Переменная для защиты от дребезга
char secPressKeys;    // Признак того, сколько секунд нажата клавиша
unsigned char AddPressKeys=1;    // Признак того, сколько прибавлять значений, в зависимости от длительности нажатия клавиши.
unsigned char AddPressKeys10=10;   // Признак того, сколько прибавлять значений, в зависимости от длительности нажатия клавиши.
char CountState=0; // Флаг того, что сохраняем состояние процесса (каждое значение - это полсекунды)
char DispDopInfo=0; // Флаг отображения дополнительной информации (через раз)
                    // 1 - смените емкость
                    // 2 - емкость с головами.
                    // 3 - низкое напряжение для поддержания мощности
                    // 4 - датчик ds18b20
                    // 5 - датчик давления MPX5010

char usePB=1;
unsigned char ProcChimOtbNO=0;  // Процент ШИМ отбора с нижд
int tempBegOtbNO=800;


#define MAX_KLP 5       // Количество клапанов, которыми надо управлять по ШИМ. 

#define PIN_KLP_BEG 22  // Начальный пин для управления клапанами 

#define KLP_NPG  0      // Номер клапана для управления НПГ (при дистилляции) 
#define KLP_VODA 0      // Номер клапана для управления общей подачей воды в систему
#define KLP_DEFL 1      // Номер клапана для подачи воды в дефлегматор
#define KLP_DEFL_D 1    // Номер клапана для подачи воды в дефлегматор (при дистилляции с дефлегматором с паровым отбором)
#define KLP_GLV_HVS  3  // Номер клапана отбора головных и хвостовых фракций
#define KLP_BARDA  0  // Номер клапана слива барды
#define KLP_SR   4      // Номер клапана отбора ректификата
#define KLP_HLD  1      // Номер клапана холодильника (для дистилляции)
#define KLP_PB 0      // Номер клапана для слива польского буфера

#define TEMP_KUB  0      // Номер датчика  термометра в кубе
#define TEMP_RK20 1      // Номер датчика термометра в РК 20 см от насадки
#define TEMP_TSA  2      // Номер термометра в трубке связи с атмосферой
#define MAX_TEMP_TSA 650 // Максимальная температура в датчике ТСА
#define TEMP_DEFL 1      // Номер датчика  термометра в дефлегматоре
#define TEMP_TERMOSTAT 0 // Номер датчика  термометра термостата
#define TEMP_RAZVAR 0    // Номер датчика  термометра для разваривания зерновых

#define PIN_RZG_ON 30    // Пин для включения режима разгона             (может работать и без него)

#if SIMPLED_VERSION>=1
  #define USE_LCD_KEYPAD_SHIELD 1  // 1 - использовать стандартный шильд с кнопкми ардуино, 0 - не использовать
  // Пятая версия это почти нулева
  #undef PIN_MPX5010 A9      // Пин датчика давления MPX5010DP
  #if SIMPLED_VERSION!=5 && SIMPLED_VERSION!=6 && SIMPLED_VERSION!=8 && SIMPLED_VERSION!=9 && SIMPLED_VERSION<30
    #define PEREGREV_ON 0  // Не используем защиту клапанов от перегрева
    #define PER_KLP_OPEN  100 // Клапана на воду постоянно открыты
    #define PER_KLP_CLOSE 0  // из контанты NAPR_PEREGREV 150 
    #define USE_ALARM_UROVEN 0  // Нужно ли использовать датчик уровня в приемной емкости ардуино
    #define USE_ALARM_VODA   0  // Нужно ли использовать датчик разлития воды ардуино
    #define UROVEN_ALARM 1        // Датчик уровня переводим в цифровой режим
  #endif

  #define USE_GAS_SENSOR 0        // Пин для анализа датчика загазованности (спирта)
  #define UROVEN_GAS_SENSOR 1    // уровень газа переводим в цифровой режим
  
  #if SIMPLED_VERSION!=6
    #undef NPG_UROVEN_PIN A3         // Отключаем датчик НПГ елси не SIMPLED 6
  #else
    #define NPG_UROVEN_PIN A3         // Включаем датчик НПГ елси не SIMPLED 6
  #endif
  
  #define USE_ASC712 1        // Надо ли исполозовать датчик тока
  #define PIN_READI A2         // Аналоговый Пин для чтения тока 

#endif

// Версия урощена 2 - то же, то упрощенная версия, но с цифровыми датчиками уровня голов, спирта, разлития воды
#if SIMPLED_VERSION==2
#define USE_ALARM_UROVEN 1  // Нужно ли использовать датчик уровня в приемной емкости ардуино 
                            // 2, нужно использовать как признак стопа ректификации.
#define USE_ALARM_VODA   0  // Нужно ли использовать датчик разлития воды ардуино
#define PIN_READI A2         // Аналоговый Пин для чтения тока 

#endif

#if SIMPLED_VERSION==3
  #define USE_ALARM_UROVEN 2  // Нужно ли использовать датчик уровня в приемной емкости ардуино 2 - датчик используется как уровень при котором останавливается отбор, но не останавливается ректификация
  #define USE_ALARM_VODA   0  // Нужно ли использовать датчик разлития воды ардуино
  #define KLP_HIGH 0              // В простой версии 3 реле с низким уровнем включения
  #define PIN_READI A2         // Аналоговый Пин для чтения тока 
#endif

#if SIMPLED_VERSION==4
  #define USE_ALARM_UROVEN 2  // Нужно ли использовать датчик уровня в приемной емкости ардуино 2 - датчик используется как уровень при котором останавливается отбор, но не останавливается ректификация
  #define USE_ALARM_VODA   0  // Нужно ли использовать датчик разлития воды ардуино
  #define KLP_HIGH 1              // В простой версии 3 реле с низким уровнем включения
  #define USE_ASC712 1        // Надо ли исполозовать датчик тока
#endif

#if SIMPLED_VERSION==5 || SIMPLED_VERSION==6 || SIMPLED_VERSION==7 || SIMPLED_VERSION==8 || SIMPLED_VERSION==9 || SIMPLED_VERSION==20 || SIMPLED_VERSION>=30
  #define USE_ALARM_UROVEN 2  // Нужно ли использовать датчик уровня в приемной емкости ардуино 2 - датчик используется как уровень при котором останавливается отбор, но не останавливается ректификация
  #define USE_ALARM_VODA   1  // Нужно ли использовать датчик разлития воды ардуино
  #define KLP_HIGH 1              // В простой версии 5 вместо реле на клапана используются симисторы.
  #define USE_ASC712 0        // Надо ли исполозовать датчик тока
  #define PIN_TRIAC  10    // Управление симистором реализовано через PIN 10 (для удобства пайки)
  #define PIN_DS18B20 2    // датчики температуры подключены к PIN 2 (для удобства пайки)
  #define PIN_MPX5010 A1      // Пин датчика давления MPX5010DP к А1 (для удобства пайки)
  #define RELAY_HIGH  0         // Какой сигнал подавать на релейные выходы мешалки и разгона 
  #define KLP_HLD     2      // Номер клапана холодильника (для дистилляции), такой же, как и дефлегматор.
  #define KLP_DEFL_D  4    // Номер клапана дефлегматора дистиллятора - такой же, как и номер клапана отбора спирта, поскольку клапан отбора спирта не используется при дистилляции.
  // Версия Slave-регулятора мощности.
  #if SIMPLED_VERSION==7
    #define USE_ALARM_UROVEN 0 // Нужно ли использовать датчик уровня в приемной емкости ардуино 2 - датчик используется как уровень при котором останавливается отбор, но не останавливается ректификация
    #define USE_ALARM_VODA   0 // Нужно ли использовать датчик разлития воды ардуино
    #undef PIN_MPX5010 A1      // Пин датчика давления MPX5010DP к А1 (для удобства пайки)
    #define USE_SLAVE  1       // Переводим контроллер в Slave - режим
  #endif
  // Версия с датчиком тока (в основном это для отладки на моем оборудовании подключил датчик тока на A1)
  #if SIMPLED_VERSION==8
    #define PIN_READI A4         // Аналоговый Пин для чтения тока 
    #define USE_ASC712 1         // Надо ли исполозовать датчик тока
    #define PEREGREV_ON 0        // Отключаем защиту от перегрева клапанов.
    #define PER_KLP_OPEN  100 // Клапана на воду постоянно открыты
    #define PER_KLP_CLOSE 0  // из контанты NAPR_PEREGREV 150 
  #endif
  
  #if SIMPLED_VERSION==6 || SIMPLED_VERSION==9 || SIMPLED_VERSION==7 || SIMPLED_VERSION==5 || SIMPLED_VERSION==15
    #define PIN_READI A4         // Аналоговый Пин для чтения тока 
  #endif
  
 #if SIMPLED_VERSION>=30
  #define PIN_READI A4 
  #define PIN_ALL_OFF 32  // Пин, при подаче напряжения на который вырыбаеся вообще все (например выключается УЗО) (может работать и без него)
  #define PIN_TRIAC  36    // Управление симистором реализовано через PIN 36 (для удобства пайки)
  #define PIN_MIXER  38
  #define PIN_RZG_ON 34
  #define RELAY_HIGH 1         // Релейные выходы не используем, вместо них при необходимости симисторное управление.
  #define KLP_NPG  4      // Номер клапана для управления НПГ (при дистилляции) 
  #define KLP_VODA 3      // Номер клапана для управления общей подачей воды в систему
  #define KLP_DEFL 0      // Номер клапана для подачи воды в дефлегматор
  #define KLP_DEFL_D 0    // Номер клапана для подачи воды в дефлегматор (при дистилляции с дефлегматором с паровым отбором)
  #define KLP_GLV_HVS  1  // Номер клапана отбора головных и хвостовых фракций 
  #define KLP_BARDA  2  
  #define KLP_HLD     0      // Номер клапана холодильника (для дистилляции), такой же, как и дефлегматор.
  #define KLP_DEFL_D  2    // Номер клапана дефлегматора дистиллятора - такой же, как и номер клапана отбора спирта, поскольку клапан отбора спирта не используется при дистилляции.
  #define KLP_SR   2      // Номер клапана отбора ректификата
  #define KLP_PB 4      // Номер клапана для слива польского буфера


  #if NUM_PHASE>1
    #undef PIN_MPX5010 A9      // Пин датчика давления MPX5010DP
    #define PER_KLP_OPEN  100 // Клапана на воду постоянно открыты
    #define PER_KLP_CLOSE 0  // из контанты NAPR_PEREGREV 150 
    #define USE_ALARM_UROVEN 0  // Нужно ли использовать датчик уровня в приемной емкости ардуино
    #define USE_ALARM_VODA   0  // Нужно ли использовать датчик разлития воды ардуино
    #define PEREGREV_ON 0  // Не используем защиту клапанов от перегрева
  #endif
  
 
 #endif
  
  
  #if SIMPLED_VERSION==20
    #define USE_ALARM_UROVEN 0 // Нужно ли использовать датчик уровня в приемной емкости ардуино 2 - датчик используется как уровень при котором останавливается отбор, но не останавливается ректификация
    #define USE_ALARM_VODA   0 // Нужно ли использовать датчик разлития воды ардуино
    #define PIN_MPX5010 A1      // Пин датчика давления MPX5010DP к А1 (для удобства пайки)
  #endif
  
  
#endif

#define PIN_SLAVE_0 38
#define PIN_SLAVE_1 40
#define PIN_SLAVE_2 42
#define PIN_SLAVE_3 44


char SlaveON=0;

OneWire  ds(PIN_DS18B20);  // on pin 37
#define MAX_DS1820 5
unsigned char ds1820_devices;                  // Количество датчиков ds18b20 
unsigned char ds1820_rom_codes[MAX_DS1820][9]; // Коды датчиков ds18b20
char ds1820_popr[MAX_DS1820];                  // Поправки к температуре датчиков
char ds1820_flread[MAX_DS1820];                  // Поправки к температуре датчиков
char ds1820_poprPress[MAX_DS1820];                  // Поправки к температуре датчиков
unsigned char ds1820_nums[MAX_DS1820]={0,1,2,3,4};                  // Поправки к температуре датчиков

// В этой переменной храним температуру в кубе для 
#define COUNT_CHIM 15
int tempK[COUNT_CHIM]={0  ,  880,  960,  1000,0,0,0,0,0,0,0,0,0,0,0};
char CHIM[COUNT_CHIM]={-1,   68,   25,  0,0,0,0,0,0,0,0,0,0,0,0};
// здесь храним количество значений в таблице (Отрицательные значения означают, что колнна находится в режиме само-обучения);
char CntCHIM=-4;
char flPopr; // Флаг поправки означает что в данный момент редактируется, температура или ШИМ 0-температура, 1- ШИМ.
#define MAX_CNT_PAUSE 16
char CntPause=8;
char tempP[MAX_CNT_PAUSE]={10,35,45,50,58,64,70,71,110,0,0,0,0,0,0,0};           // Температурные паузы в градусах (первое значение - это время работы насоса).
unsigned char timeP[MAX_CNT_PAUSE]={2,15,15,20,30,60,30,0,120,0,0,0,0,0,0,0};  // Время паузы в минутах (если 0, то это значит ожидаем действия пользователя (первое значение - это время паузы насоса). 

#define MAX_CNT_FRACTION_DIST 8
char CountFractionDist=0;
char CountFractionRect=0;
char TekFraction=0;
int TempFractionDist[MAX_CNT_FRACTION_DIST];
int PowerFractionDist[MAX_CNT_FRACTION_DIST];
unsigned char AngleFractionDist[MAX_CNT_FRACTION_DIST];
#define MAX_CNT_FRACTION_RECT 5

int TempFractionRect[MAX_CNT_FRACTION_RECT];
unsigned char AngleFractionRect[MAX_CNT_FRACTION_RECT];


char IncrementCHIM=0;
char DecrementCHIM=10;
int TimeAutoIncCHIM=600;
int TimeRestabKolonna=3600; // Время если в течении которого колонна не стабилизировалась, считаем новую температуру стабилизации

unsigned int KlOpen[MAX_KLP];  // Время закрытия клапанов (в полупериодах, то есть 100 - это примерно 1 секунда)
unsigned int KlClose[MAX_KLP];// Время открытия клапанов  (в полупериодах,то есть 100 - это примерно 1 секунда)
char KlState[MAX_KLP];         // Состояние клапанов (1 открыт - 0 закрыт) 
unsigned int  KlCount[MAX_KLP]; // Счетчик состояния клапанов
char KlReg[MAX_KLP];         // Режим работы
char KlSelect=0;  // Выбран режим прибавления - либо время открытия, либо время закрытия - это для ручного управления ШИМом, тестирования и прочего
char KlTek=0;     // Для отладки - режим какого клапана отображать на дисплее  - это для ручного управления ШИМом, тестирования и прочего .  
//char flSyncKLP=0; // Флаг того, что идет синхронизация клапанов, признак того, что состояние клапанов не менять.  
int Angle=0;
// Ну это понятно, это подключен LCDs

LiquidCrystal_I2C lcd(0x27, 16, 2);
 # define PIN_START_1 4      // На этих двух пинах устанавливается заданный уровень при старте процесса и снимается при окончкни нагрева для включения индукционки через реле, например)
 # define PIN_START_2 5

int MaxIOut;
int MaxVoltsOut;


int temps[MAX_DS1820];            // Температура датчиков  
int Maxtemps[MAX_DS1820];           // максимальная Температура датчиков  за процесс.

unsigned char nPopr=0;                     // Текущий датчик, которому вносится поправка

#define PIN_SOUND 11    // На 11 пине сидит спикер от компа (мощная штука, 15 ом, потребляет 300ма, поэтому ей пока не злоупотребляю, может заменить ее в дальнейшем на Пьезо?)


#define PIN_ALL_OFF 31  // Пин, при подаче напряжения на который вырыбаеся вообще все (например выключается УЗО) (может работать и без него)
#define PIN_RST_WDT 43  // Пин, на который периодически меняется значение с 0 на 1 (раз в 5 секунд обычно) служит для отслеживаения зависания Ардуины внешним устройством.

char flAllOff;           // Флаг того, что все выключено

unsigned char Counter1=0;
long Seconds;   // Текущее состояние времени с начала процесса (не беззнаковое, потому, что есть проверки на <0);
long SecondsEnd;// Время окончания процесса 

char NeedDisplaying;
char flNoPhase=1;  // Переменная признак отключения фазового управления клапанов (например на период чтения датчиков температуры)
int resultU;
char NeedGPRS;

unsigned char StateVolts=0;  // Состояние вычисление среднеквадратичного 
//0 - надо вычислить - запускается старт, 1 - вычисляется, 2 - вычислено, 3 - идет обработка рузультата
// 4 - Результат обработан, можно вычислять следующий
int index_input=0; // Текущий размер массива дла расчета среднеквадратичного
int prev_index_input=0; // Текущий размер массива дла расчета среднеквадратичного
int indexOut=0;    // Размер для вывода на экран

unsigned char flCrossZero=0;
//unsigned int VoltsZr;
unsigned long TekPower;
unsigned long TekPowerKLP;
unsigned int TimeOpenTriac=0;
unsigned int TimeOpenTriacFact=0;
unsigned int TimeOpenKLP=0;
unsigned int TicZero; // Количество тиков таймера от нуля до нуля.
//char FirstRun;
// Установка мощности (Пока в виде переменных)

int Power=3000;       // Номинальная мощность ТЭНов
int PowerPhase[3]={3000,0,0};
unsigned char KtPhase[3]={100,100,100};
int FactPower=0;       // Номинальная мощность ТЭНов
int UstPower;     // Нужно получить мощность от регулятора (текущая мощность на всех фазах)
int UstPwrPH1;     // Нужно получить мощность от регулятора (текущая мощность на первой фазе)
int UstPwrPH2;     // Нужно получить мощность от регулятора (текущая мощность на первой фазе)
int UstPwrPH3;     // Нужно получить мощность от регулятора (текущая мощность на первой фазе)
int R_TEN20;        // Сопротиввление ТЭНов, умноженное на 10;

int UstPowerReg=500;     // Мощность в режиме регулятора мощности

char flNeedTemp=0;    // Флаг того, что нужно читать температуру датчиков
char StepOut=0;       // Признак шага чтения температуры 0 - выдаем команду на запрос температуры
// 1 - читаем температуру

//#define USE_BRESENHAM 0// Надо ли использовать брезинхем для управлением двигателем.

int deltaPower=0; // Разница мощности при дистилляции с дефлегматором.

unsigned char b_size[3];  // Размер брезинхема
unsigned char b_value[3]; // Текущее значение алгоритма
int b_error[3]; // Переменная
unsigned char b_stepNumber[3]; // Номер шага

void bresenham_Init(char n, unsigned char sz)
{
  b_size[n] = sz;
  b_error[n] = b_size[n]/2;
  b_stepNumber[n] = 0;
  b_value[n] = 0;
}

boolean bresenham_getNext(char n) 
{
  boolean result;
  b_error[n] -= b_value[n];
  if ( b_error[n] < 0 ) 
  {
    b_error[n] += b_size[n];
    result = HIGH;
  }
  else 
  {
    result = LOW;
  }

  if ( ++b_stepNumber[n] >= b_size[n]) {
    b_stepNumber[n] = 0;
    b_error[n] = b_size[n]/2;
  }
  return result;
}		



// Пины, на которых сидят кнопки
#define PIN_SELECT 53
#define PIN_RIGHT 51
#define PIN_LEFT 49
#define PIN_UP 45
#define PIN_DOWN 47

#define PRESS_SELECT digitalRead(PIN_SELECT)==0
#define PRESS_RIGHT  digitalRead(PIN_RIGHT)==0
#define PRESS_LEFT  digitalRead(PIN_LEFT)==0
#define PRESS_UP     digitalRead(PIN_UP)==0
#define PRESS_DOWN   digitalRead(PIN_DOWN)==0

char KeyCode; // Код нажатой клавиши

#if USE_LCD_KEYPAD_SHIELD
#define PRESS_SELECT KeyCode==1
#define PRESS_RIGHT  KeyCode==2
#define PRESS_LEFT   KeyCode==3
#define PRESS_UP     KeyCode==4
#define PRESS_DOWN   KeyCode==5
#endif


#define PIN_ALARM_VODA   A5      // Пин, на котором сидит датчик разлития воды на полу (да какой датчик, два луженых провода).     
#define PIN_ALARM_UROVEN A6      // Пин, на котором сидит датчик уровня в приемной емкости (да какой датчик, два луженых провода).
unsigned char CountAlarmVoda=0;          // Счетчик срабатываний датчика (если сработал три раза, тогда тревога)
unsigned char CountAlarmUroven=0;        // Счетчик срабатываний датчика (если сработал три раза, тогда тревога)
char CountGasSensor=0;          // Счетчик срабатываний датчика паров спирта (если сработал три раза, тогда тревога)

#define PIN_TERMOSTAT_ON  28    // Пин термостата, который включается при превышении температуры 
#define PIN_TERMOSTAT_OFF 29    // Пин термостата, который отключается при превышении температуры 

unsigned int BeepTime;
char StateNPG=0; // Состояние автомата обработки НПГ
// 0 - не запускался
// 1 - инициализируется (наполнение)
// 2 - рабочий режим
// 3 - режим одного уровня тревоги (один раз считан нижний или верхний уровень)

int U_VODA=0,U_UROVEN=0,U_GAS=0,U_NPG=0,U_GLV=0; // Уровни воды, газа, НПГ, голов


char NpgDt;// 4- нет сработки датчика 1 - нижний уровень, 2 - рабочий, 3-верхний

char WebFl=0;
int WebKey=652;
long WebValue=783;
char WebPopr=0;

#include <SPI.h>

#include <Adafruit_Sensor.h>
#include <Adafruit_BMP280.h>

#define BMP_SCK 13
#define BMP_MISO 12
#define BMP_MOSI 11 
#define BMP_CS 10

Adafruit_BMP280 bmp; // I2C

int PressAtm=760;
unsigned char flReadPress=0;
unsigned char timePressAtm=60;

void ReadStateDtNPG()
{
 #ifdef NPG_UROVEN_PIN   
  U_NPG=analogRead(NPG_UROVEN_PIN);    
  // Уровень НПГ подключен по следующей схеме: Подтяджка - 10 ком, защита -330 ом, замыкание - 30, резистор 1.1К (верхниц уровень) - 128, 2.2К (рабочий уровень) - 256, 3,3К (нижний уровень)-266
  if (U_NPG>=80) NpgDt=1;  // Нижний уровень
  if (U_NPG>=180) NpgDt=2;  // Рабочий уровень
  if (U_NPG>=240) NpgDt=3;  // Верхний уровень
  if (U_NPG>=500) NpgDt=4; // Нет сработки

  // Если находимся в режиме аварии, состояние НПГ всегда нет сработки
  if (IspReg>240) StateNPG=2;
#endif

#ifdef NPG_UROVEN_PIN_MIN   
  NpgDt=4; // Нет сработки
  // Датчик уровня в следущем виде 10 (первая цифра сработка минимума, 2 цифра сработка нормального уровня)
  U_NPG=analogRead(NPG_UROVEN_PIN_MIN);
  if (UrovenBarda>0)
  {
    if (U_NPG<=UrovenBarda) NpgDt=1; // Нижний уровень
    else
    {
      U_NPG=analogRead(NPG_UROVEN_PIN_WORK); 
      if (U_NPG<=UrovenBarda) NpgDt=2; 
    }
  }
  else
  {
    if (U_NPG>=-UrovenBarda) NpgDt=1; // Нижний уровень
    else
    {
       NpgDt=2; // Нет сработки
    }    
  }
  if (IspReg>240) StateNPG=2;
#endif
}

void ProcessNPG()
{

#ifndef NPG_UROVEN_PIN
#ifndef NPG_UROVEN_PIN_MIN
  StateNPG=2;
  return;
#endif
#endif

ReadStateDtNPG();

  switch (StateNPG)
  {
  case 0:// НПГ не запущен
    if (NpgDt==1) // Если сработка нижнего уровня, то тогда НПГ надо наполнить.
    {
      StateNPG=1;
      break;
    }
    StateNPG=2;
    break;
  case 1:// Инициализация НПГ - наполнение
    KlOpen[KLP_NPG]=PER_KLP_OPEN;
    KlClose[KLP_NPG]=PER_KLP_CLOSE;
    if (NpgDt==2 || NpgDt==3) // Дошли до рабочего уровня или до переполнения, тогда переходим в рабочий режим.
    {
#ifdef TEST
      sprintf(my_tx_buffer,"NAPOLN NPG=%i NpgDt=%i",U_NPG,NpgDt);
      Serial.println(my_tx_buffer);
#endif      

      // Повторное чтение для подтверждения датчика 
      ReadStateDtNPG();
      if (NpgDt==2 || NpgDt==3)  StateNPG=4; // Переводим в режим однократной сработки, если прошло подтверждение
    }
    break;
  case 2:// НПГ работает в штатном режиме.
    if (NpgDt==1 || NpgDt==3)  
    {
#ifdef TEST
      sprintf(my_tx_buffer,"Alarm NPG=%i NpgDt=%i",U_NPG,NpgDt);
      Serial.println(my_tx_buffer);
#endif      
      // Повторное чтение для подтверждения датчика 
      ReadStateDtNPG();
      if (NpgDt==1 || NpgDt==3) StateNPG=3; // Переводим в режим однократной сработки аварии, если прошло подтверждение
      countAlrmNPG=1;
    }

    if (NpgDt==2) 
    {
      // Сработка рабочего уровня НПГ
      KlOpen[KLP_NPG]=PER_KLP_OPEN;
      KlClose[KLP_NPG]=PER_KLP_CLOSE;
      countAlrmNPG=0;

    }

    if (NpgDt==4) // Нет никакой сработки - отключаем подачу воды
    {
      // Сработка рабочего уровня НПГ
      KlOpen[KLP_NPG]=0;
      KlClose[KLP_NPG]=10;
      countAlrmNPG=0;
    }
    break;
  case 3:  // Была однократная сработка датчиков осушения или переполнения

    if (NpgDt==1) 
    {
      countAlrmNPG++;
      ReadStateDtNPG();
#ifndef TEST
#ifndef DEBUG
      if (countAlrmNPG>MAX_COUNT_NPG_ALARM)
      {
        IspReg=253;      // Переводим контроллер в режим тревоги по осушению НПГ
      }
#endif
#endif

#ifdef TEST
      sprintf(my_tx_buffer,"Alarm pNPG=%i NpgDt=%i",U_NPG,NpgDt);
      Serial.println(my_tx_buffer);
#endif      
      break;
    }
    if (NpgDt==3) 
    {
      countAlrmNPG++;
      ReadStateDtNPG();
      // Сработка верхнего уровня НПГ, исклчение - переполнение НПГ.
#ifndef TEST
#ifndef DEBUG
      IspReg=254;      // Переводим контроллер в режим тревоги по осушению НПГ
#endif
#endif

#ifdef TEST
      sprintf(my_tx_buffer,"Alarm pNPG=%i NpgDt=%i",U_NPG,NpgDt);
      Serial.println(my_tx_buffer);
#endif      
      break;
    }
    StateNPG=2; // Если тревога не подтвердилась, переходим в обычный ражим.
    countAlrmNPG=0;
    break;

  case 4:// При наполнении НПГ была однократная сработка датчиков уровня или переполнения

    // Если подтверждаестся повторная сработка датчика, то токда считаем НПГ переведенным в рабочее состояние
    if (NpgDt==2 || NpgDt==3) // Дошли до рабочего уровня или до переполнения, тогда переходим в рабочий режим.
    {
#ifdef TEST
      sprintf(my_tx_buffer,"NAPOLN pNPG=%i NpgDt=%i",U_NPG,NpgDt);
      Serial.println(my_tx_buffer);
#endif      
      StateNPG=2; // Переводим НПГ в рабочее состояние.
    }
    break;
  } 
}

// Функция устанавливает пищалку на заданное время (в 1/125 секунды), то есть 125-это одна секунда.
void my_beep(unsigned int mBeepTime)
{
  analogWrite(PIN_SOUND, 10);  
  BeepTime=mBeepTime;
}

// Функция расчета квадратного корня.
// Значения корней от 0 до 90 и от 256 до 512 считаются по очень приблизительным формулам, поскольку такое значение среднеквадратичного в нормальной сети 220 вольт недопустимо
// Больше 512 значение не определено.
int my_sqrt(unsigned long tsQT)
{  char i;
   unsigned int sQT; // Временная переменная, чтобы поменьше сравнивать 4-байтных чисел.
   int res=666;
   char fl2=0;
    if (tsQT<64) 
    {
      tsQT=tsQT<<10;
      fl2=5;
    }
    else
    if (tsQT<256) 
    {
      tsQT=tsQT<<8;
      fl2=4;
    }
    else
    if (tsQT<1024) 
    {
      tsQT=(tsQT<<6);
      fl2=3;
    }
    else
    if (tsQT<4096) 
    {
      tsQT=(tsQT<<4);
      fl2=2;
    }
    else
     if (tsQT<tableSQ[0])
       {
        tsQT=tsQT<<2;
        fl2=1;
       }
       
   // Если попадаем в диапазон
   if (tsQT<tableSQ[0]) 
   {
     // Если меньше минимального значения, тогда расчет по крайне приближенной формуле
     res=tsQT*tableSQRT[0]/tableSQ[0];
   }
   else
   if (tsQT<=tableSQ[MAX_TABLE_SQRT-1])
   {
     sQT=tsQT;
     for(i=1;i<MAX_TABLE_SQRT;i++)
     {
       
       if (tableSQ[i-1]<=sQT && tableSQ[i]>=sQT)
        {
           if (tableSQ[i-1]==sQT) res=tableSQRT[i-1]; // На крайних значениях берем готовые цифры
             else
               if (tableSQ[i]==sQT) res=tableSQRT[i]; // На крайних значениях берем готовые цифры
                else res=(sQT-tableSQ[i-1])*(tableSQRT[i]-tableSQRT[i-1])/(tableSQ[i]-tableSQ[i-1]) + tableSQRT[i-1] +1; // На промежуточных вычисляем.
           break;
        }
     }
   }
   else
   {
     // Если больше максимального считаем по крайне приближенной формуле, исходя из максимума значений в 512
     res=(tsQT-tableSQ[MAX_TABLE_SQRT-1])*(512-tableSQRT[MAX_TABLE_SQRT-1])/(262144-tableSQ[MAX_TABLE_SQRT-1]) + tableSQRT[MAX_TABLE_SQRT-1] +1;
   }

   // Если перед корнем умножали на 4, результат уменьшим на 2
   return  res >> fl2;
}

void setup() 
{
  wdt_enable(WDTO_8S);
  unsigned char i;
  //my_beep(5);
  // set up the LCD's number of columns and rows: 

  Serial.begin(9600);
  Serial2.begin(9600);
  
  #if NUM_PHASE>0
    Serial1.begin(9600);
  #endif

  StateVolts=6;

  lcd.begin(16, 2);
  lcd.init();
  lcd.backlight();

  // Print a message to the LCD.
  //  my_lcdprint("hello, world!");
  //  analogReference(DEFAULT);

  //  #if USE_LCD_KEYPAD_SHIELD==0
  //    analogReference(INTERNAL2V56);
  //  #else
  // теперь опорно напряжение всегда делаем +5В, чтобы работа программы была одинаковой, как с использованием дисплей шильда, так и без него
  analogReference(DEFAULT);
  // #endif

 pinMode(PIN_TRIAC, OUTPUT);
 pinMode(PIN_ALL_OFF, OUTPUT);
 pinMode(PIN_RST_WDT, OUTPUT);
 
 pinMode(PIN_RZG_ON, OUTPUT);
 digitalWrite(PIN_RZG_ON,!RELAY_HIGH);

 pinMode(PIN_START_1, OUTPUT);
 digitalWrite(PIN_START_1,!RELAY_HIGH);
 pinMode(PIN_START_2, OUTPUT);
 digitalWrite(PIN_START_2,!RELAY_HIGH);
  
  pinMode(PIN_NASOS_NBK, OUTPUT);
  pinMode(PIN_NASOS_NBK_BRD, OUTPUT);
  pinMode(PIN_MIXER, OUTPUT);
  digitalWrite(PIN_MIXER,!RELAY_HIGH);
  digitalWrite(PIN_NASOS_NBK, LOW);  
  pinMode(PIN_TERMOSTAT_ON, OUTPUT);
  pinMode(PIN_TERMOSTAT_OFF, OUTPUT);
  
  if (UROVEN_ALARM==1)
  {
    pinMode(PIN_ALARM_VODA, INPUT);
    pinMode(PIN_ALARM_UROVEN, INPUT);
  }
 
 
 if (UrovenProvodimostSR==1) 
 {
   pinMode(PIN_PROVODIMOST_SR, INPUT);
 }
  
  #ifdef NPG_UROVEN_PIN_MIN
//    pinMode(NPG_UROVEN_PIN_MIN, INPUT);           // назначить выводу порт ввода
//    digitalWrite(NPG_UROVEN_PIN_MIN, HIGH);       // включить подтягивающий резистор
//    pinMode(NPG_UROVEN_PIN_WORK, INPUT);           // назначить выводу порт ввода
//    digitalWrite(NPG_UROVEN_PIN_WORK, HIGH);       // включить подтягивающий резистор
    
  #endif
  
 

  pinMode(PIN_SELECT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_SELECT, HIGH);       // включить подтягивающий резистор

  pinMode(PIN_RIGHT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_RIGHT, HIGH);       // включить подтягивающий резистор

  pinMode(PIN_LEFT, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_LEFT, HIGH);       // включить подтягивающий резистор

  pinMode(PIN_UP, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_UP, HIGH);       // включить подтягивающий резистор

  pinMode(PIN_DOWN, INPUT);           // назначить выводу порт ввода
  digitalWrite(PIN_DOWN, HIGH);       // включить подтягивающий резистор


  // Проходим по клапанам и устанавливаем им ШИМ и настраиваем пины
  for(i=0;i<MAX_KLP;i++)
  {
    #if SIMPLED_VERSION<30
      pinMode(PIN_KLP_BEG+i, OUTPUT);
      digitalWrite(PIN_KLP_BEG+i, !KLP_HIGH);  
    #else
      pinMode(PIN_KLP_BEG+i+i, OUTPUT);
      digitalWrite(PIN_KLP_BEG+i+i, !KLP_HIGH);  
    #endif
    KlOpen[i]=0;    
    KlClose[i]=10;   
    KlState[i]=0;          // Начальное состояние - клапан закрыт, счетчик 0
    KlCount[i]=0;  
  }
    #if NUM_PHASE>1
    for(i=0;i<NUM_PHASE;i++)
    {
     digitalWrite(PIN_KLP_BEG,HIGH);
     digitalWrite(PIN_KLP_BEG+4,HIGH);
     delay(1000);
     digitalWrite(PIN_KLP_BEG+4,LOW);
     digitalWrite(PIN_KLP_BEG,LOW);
     delay(1000); 
    }
    #endif

//  #if USE_ASC712==0
//  attachInterrupt(1, zero_crosss_int, RISING);  // Устанавливаем на 1-е прерывание функцию (это pin 3) обработку от детектора нулюя сетевого напряжения
//  #else
  // Сейчас всегда устанавливаем обработку на переход с ненуля на ноль, чтобы было немного больше времени на программу в прерывании нуля.
   attachInterrupt(1, zero_crosss_int, FALLING);  // Устанавливаем на 1-е прерывание функцию (это pin 3) обработку от детектора нулюя сетевого напряжения
//  #endif
  //  attachInterrupt(0, zero_crosss_trans, RISING);  // Устанавливаем на 0-е прерывание функцию (это pin 2) обработку от детектора нуля трансформатора.

   // Таймер 2 используется для подсчета числа секунд и, возможно, программного небыстрого ШИМа
  // Прерываение по этому таймеру будет вызываться 125 раз в секунду.
  // Timer/Counter 2 initialization
  // Clock source: System Clock
  // Clock value: 62,500 kHz
  // Mode: Normal top=0xFF
  // OC2A output: Disconnected
  // OC2B output: Disconnected
  TCCR2A=0x00;
  TCCR2B=0x07;
  TCNT2=0x00;
  OCR2A=0x7D;
  OCR2B=0x00;  
  //  // Timer/Counter 1 Interrupt(s) initialization
  TIMSK2=0x02;


  // Таймер 3 будет использоваться для такой, обычно очень несвойственной для него процедуры, как "замена" аппаратного прерывания АЦП.
  // (сейчас таймер свободен, так что может быть задействован для других целей)
  #if SIMPLED_VERSION==20
    // Timer/Counter 3 initialization
    // Clock source: System Clock
    // Clock value: 250,000 kHz
    // Mode: Normal top=0xFFFF
    // OC3A output: Discon.
    // OC3B output: Discon.
    // OC3C output: Discon.
    // Noise Canceler: Off
    // Input Capture on Falling Edge
    // Timer3 Overflow Interrupt: Off
    // Input Capture Interrupt: Off
    // Compare A Match Interrupt: On
    // Compare B Match Interrupt: Off
    // Compare C Match Interrupt: Off
    TCCR3A=0x00;
    TCCR3B=0x03;
    TCNT3H=0x00;
    TCNT3L=0x00;
    ICR3H=0x00;
    ICR3L=0x00;
    OCR3AH=0x00;
    OCR3AL=0x00;
    OCR3BH=0x00;
    OCR3BL=0x00;
    OCR3CH=0x00;
    OCR3CL=0x00;
    // Timer/Counter 3 Interrupt(s) initialization
    TIMSK3=0x02;
  #endif


  // Таймер 4 будет использоваться для подсчета числа тиков при вызове АЦП в расчете среднеквадратичного 
  // (поскольку непонятно, чего и сколько это занимает в Ардуино - исходный код разбирать неохота)
  // Timer/Counter 4 initialization
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC4A output: Discon.
  // OC4B output: Discon.
  // OC4C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer4 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: Off
  // Compare B Match Interrupt: Off
  // Compare C Match Interrupt: Off
  TCCR4A=0x00;
  TCCR4B=0x03;
  TCNT4H=0x00;
  TCNT4L=0x00;
  ICR4H=0x00;
  ICR4L=0x00;
  OCR4AH=0x00;
  OCR4AL=0x00;
  OCR4BH=0x00;
  OCR4BL=0x00;
  OCR4CH=0x00;
  OCR4CL=0x00;
  // Timer/Counter 4 Interrupt(s) initialization
  TIMSK4=0x00;
  
  #if SIMPLED_VERSION==20
    // Timer/Counter 4 Interrupt(s) initialization
    TIMSK4=0x02;
  #endif  


  // Таймер 5 будет использоваться для управления симистором регулятора мощности по прерыванию COMPA.
  // Таймер 5 будет использоваться для управления симистороми клапанов по прерыванию COMPB.
  // Таймер 5 будет использоваться для управления симистором регулятора оборотов двигателя прерыванию COMPС.
  // Timer/Counter 5 initialization
  // Clock source: System Clock
  // Clock source: System Clock
  // Clock value: 250,000 kHz
  // Mode: Normal top=0xFFFF
  // OC5A output: Discon.
  // OC5B output: Discon.
  // OC5C output: Discon.
  // Noise Canceler: Off
  // Input Capture on Falling Edge
  // Timer5 Overflow Interrupt: Off
  // Input Capture Interrupt: Off
  // Compare A Match Interrupt: On
  // Compare B Match Interrupt: On
  // Compare C Match Interrupt: On

  TCCR5A=0x00;
  TCCR5B=0x03;
  TCNT5H=0x00;
  TCNT5L=0x00;
  ICR5H=0x00;
  ICR5L=0x00;
  OCR5AH=0x00;
  OCR5AL=0x02;
  OCR5BH=0x00;
  OCR5BL=0x00;
  OCR5CH=0x00;
  OCR5CL=0x00;
  // Timer/Counter 5 Interrupt(s) initialization
  //  TIMSK5=0x06;
  TIMSK5=0x0E;// Инициализируем прерывания таймера


  //  TekPower=(unsigned long) UstPower*220*220/ Power;
  nPopr=1;
  ds1820_devices=0;
  while(ds.search(ds1820_rom_codes[ds1820_devices])) {
    ds1820_devices++;
    if (ds1820_devices>=MAX_DS1820) break;
  }
  ds.reset_search();
  #if SIMPLED_VERSION>=30 || SIMPLED_VERSION==5
    if (ds1820_devices<3 && NUM_PHASE<=1) ScanDS18b20Slave();
  #endif
  
  lcd.clear();
#ifdef DEBUG
  ds1820_devices=3;
  sprintf(lcd_buffer,"debug=%u",ds1820_devices); //запись в буфер текста и значений температуры в подготовленном
#else
  sprintf(lcd_buffer,"ds18B20Count=%u",(int) ds1820_devices); //запись в буфер текста и значений температуры в подготовленном
#endif

  my_lcdprint(lcd_buffer);                      
  sprintf(lcd_buffer,"C,V,P =%i,%i,%i(%1i) ",USE_ALARM_UROVEN,USE_ALARM_VODA,UrovenProvodimostSR,(int)nPopr); //запись в буфер текста и значений температуры в подготовленном
  nPopr=0;                    
  lcd.setCursor(0, 1);
  my_lcdprint(lcd_buffer);  
  delay(2000);
  lcd.clear();
  sprintf(lcd_buffer,"%s  RWR=%i",my_version,PR_REWRITE_EEPROM); //запись в буфер текста и значений температуры в подготовленном
  my_lcdprint(lcd_buffer);                 
  lcd.setCursor(0, 1);
  #ifndef USE_SLAVE
    sprintf(lcd_buffer,"Simpled=%u ",SIMPLED_VERSION); //запись в буфер текста и значений температуры в подготовленном
  #else
    sprintf(lcd_buffer,"Simpled=%u Slave",SIMPLED_VERSION); //запись в буфер текста и значений температуры в подготовленном
  #endif
  my_lcdprint(lcd_buffer);                      
  delay(1000);
  flNeedTemp=0;
  StepOut=0;
  
  // Читаем ранее сохраненные значения из энергонезависимой памяти.
  if (EEPROM.read(0)!=PR_REWRITE_EEPROM)
  { 
    writeEEPROM();
  }

  for(i=0;i<ds1820_devices;i++)
  {
    temps[i]=0;
    Maxtemps[i]=0;
    ds1820_popr[i]=0;                  // Поправки к температуре датчиков устанавливаем в ноль (в дальнейшем они сами считаются из eeprom, если были ранее записаны).
    // Выдадим номера датчиков.
    if (FlToUSART)
    {
      sprintf(my_tx_buffer,"ds18b20\t%1X\t%02X%02X%02X%02X%02X%02X%02X%02X",i,ds1820_rom_codes[i][0],ds1820_rom_codes[i][1],ds1820_rom_codes[i][2],
      ds1820_rom_codes[i][3],ds1820_rom_codes[i][4],ds1820_rom_codes[i][5],ds1820_rom_codes[i][6],ds1820_rom_codes[i][7]);
      Serial.println(my_tx_buffer);
    }
  }

  readEEPROM();
  
  ScanKbd();
  // Если нажата кнопка "Вверх", то переключаем на прямое управление.
  //if  (KeyCode==4) { FlToGSM=12; WiFiChl=1; }
  // Если нажата кнопка "Вниз", то отключаем датчик атмосферного давления
  if  (KeyCode==5) timePressAtm=25;
  
  if (timePressAtm>=30)
  {
    lcd.clear();
    sprintf(lcd_buffer,String(F("Init bmp280...")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 0);
    my_lcdprint(lcd_buffer);  

    if (!bmp.begin()) {  
      //Serial.println("Could not find a valid BMP280 sensor, check wiring!");
      //Serial.println(bmp);
      timePressAtm=25;
      sprintf(lcd_buffer,String(F("NOT")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    }
    else
    {
      sprintf(lcd_buffer,String(F("OK")).c_str()); //запись в буфер текста и значений температуры в подготовленном
    }
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer);  
    delay(1000);
    lcd.clear();
  }  

  #ifdef USE_SLAVE
    IspReg=103; // Для Slave режима всегда устанавливаем регулятор мощности при перезагрузке
    pinMode(PIN_SLAVE_0, INPUT);
    pinMode(PIN_SLAVE_1, INPUT);
    pinMode(PIN_SLAVE_2, INPUT);
    pinMode(PIN_SLAVE_3, INPUT);
  #else
    pinMode(PIN_SLAVE_0, OUTPUT);
    pinMode(PIN_SLAVE_1, OUTPUT);
    pinMode(PIN_SLAVE_2, OUTPUT);
    pinMode(PIN_SLAVE_3, OUTPUT);
    // Отключаем подчиненные контроллеры
    digitalWrite(PIN_SLAVE_0, 0);
    digitalWrite(PIN_SLAVE_1, 0);
    digitalWrite(PIN_SLAVE_2, 0);
    digitalWrite(PIN_SLAVE_3, 0);
  #endif
  
  #if SIMPLED_VERSION==20 || NUM_PHASE>1
    IspReg=103; // Для режима регулятора всегда устанавливаем регулятор мощности при перезагрузке
    Power=1000;
    UstPowerReg=0;
    UstPower=0;
    UstPwrPH1=0;
  #endif
  
  #ifndef DEBUG
    my_beep(10);
  #endif
  
  if (IspReg>=240) IspReg=101;
  // Выдаем тестовую команду
 // InitGSM();

  if (IspReg>=250) IspReg=101;

  GetPhonePDU();
#ifdef DEBUG
  //  Serial.begin(9600);
  Serial.println("start debug");
#endif

  CloseAllKLP();
//  digitalWrite(PIN_REG_ON,LOW);
  digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
  digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
  delay(100);
  digitalWrite(PIN_ALL_OFF,!ALL_OFF_HIGH);
  flAllOff=0;

  digitalWrite(PIN_TERMOSTAT_ON,LOW);
  digitalWrite(PIN_TERMOSTAT_OFF,LOW);
  UstPower=0;
  StateNPG=0;
  StateMachine=0;

  bresenham_Init(0,200);
  bresenham_Init(1,125);
  bresenham_Init(2,125);
  
  b_value[0]=0;

  #ifdef TEST
    temps[TEMP_KUB]=799;
    GetCHIMOtbor();
    temps[TEMP_KUB]=880;
    GetCHIMOtbor();
    temps[TEMP_KUB]=890;
    GetCHIMOtbor();
    temps[TEMP_KUB]=900;
    GetCHIMOtbor();
    temps[TEMP_KUB]=960;
    GetCHIMOtbor();
    temps[TEMP_KUB]=980;
    GetCHIMOtbor();
  #endif

  // Устанавливаем значение таблицы открытия симистора
  tableS10[ 0]= 217;//tableK[ 0]= 5;
  tableS10[ 1]= 217;//tableK[ 1]= 10;
  tableS10[ 2]= 217;//tableK[ 2]= 15;
  tableS10[ 3]= 214;//tableK[ 3]= 20;
  tableS10[ 4]= 211;//tableK[ 4]= 25;
  tableS10[ 5]= 208;//tableK[ 5]= 30;
  tableS10[ 6]= 206;//tableK[ 6]= 35;
  tableS10[ 7]= 204;//tableK[ 7]= 40;
  tableS10[ 8]= 202;//tableK[ 8]= 45;
  tableS10[ 9]= 200;//tableK[ 9]= 50;
  tableS10[ 10]= 198;//tableK[ 10]= 55;
  tableS10[ 11]= 196;//tableK[ 11]= 60;
  tableS10[ 12]= 195;//tableK[ 12]= 65;
  tableS10[ 13]= 193;//tableK[ 13]= 70;
  tableS10[ 14]= 192;//tableK[ 14]= 75;
  tableS10[ 15]= 190;//tableK[ 15]= 80;
  tableS10[ 16]= 189;//tableK[ 16]= 85;
  tableS10[ 17]= 188;//tableK[ 17]= 90;
  tableS10[ 18]= 186;//tableK[ 18]= 95;
  tableS10[ 19]= 185;//tableK[ 19]= 100;
  tableS10[ 20]= 184;//tableK[ 20]= 105;
  tableS10[ 21]= 183;//tableK[ 21]= 110;
  tableS10[ 22]= 182;//tableK[ 22]= 115;
  tableS10[ 23]= 181;//tableK[ 23]= 120;
  tableS10[ 24]= 180;//tableK[ 24]= 125;
  tableS10[ 25]= 179;//tableK[ 25]= 130;
  tableS10[ 26]= 178;//tableK[ 26]= 135;
  tableS10[ 27]= 177;//tableK[ 27]= 140;
  tableS10[ 28]= 176;//tableK[ 28]= 145;
  tableS10[ 29]= 175;//tableK[ 29]= 150;
  tableS10[ 30]= 174;//tableK[ 30]= 155;
  tableS10[ 31]= 173;//tableK[ 31]= 160;
  tableS10[ 32]= 172;//tableK[ 32]= 165;
  tableS10[ 33]= 171;//tableK[ 33]= 170;
  tableS10[ 34]= 170;//tableK[ 34]= 175;
  tableS10[ 35]= 169;//tableK[ 35]= 180;
  tableS10[ 36]= 168;//tableK[ 36]= 185;
  tableS10[ 37]= 168;//tableK[ 37]= 190;
  tableS10[ 38]= 167;//tableK[ 38]= 195;
  tableS10[ 39]= 166;//tableK[ 39]= 200;
  tableS10[ 40]= 165;//tableK[ 40]= 205;
  tableS10[ 41]= 164;//tableK[ 41]= 210;
  tableS10[ 42]= 164;//tableK[ 42]= 215;
  tableS10[ 43]= 163;//tableK[ 43]= 220;
  tableS10[ 44]= 162;//tableK[ 44]= 225;
  tableS10[ 45]= 161;//tableK[ 45]= 230;
  tableS10[ 46]= 160;//tableK[ 46]= 235;
  tableS10[ 47]= 160;//tableK[ 47]= 240;
  tableS10[ 48]= 159;//tableK[ 48]= 245;
  tableS10[ 49]= 158;//tableK[ 49]= 250;
  tableS10[ 50]= 157;//tableK[ 50]= 255;
  tableS10[ 51]= 157;//tableK[ 51]= 260;
  tableS10[ 52]= 156;//tableK[ 52]= 265;
  tableS10[ 53]= 155;//tableK[ 53]= 270;
  tableS10[ 54]= 154;//tableK[ 54]= 275;
  tableS10[ 55]= 154;//tableK[ 55]= 280;
  tableS10[ 56]= 153;//tableK[ 56]= 285;
  tableS10[ 57]= 152;//tableK[ 57]= 290;
  tableS10[ 58]= 152;//tableK[ 58]= 295;
  tableS10[ 59]= 151;//tableK[ 59]= 300;
  tableS10[ 60]= 150;//tableK[ 60]= 305;
  tableS10[ 61]= 150;//tableK[ 61]= 310;
  tableS10[ 62]= 149;//tableK[ 62]= 315;
  tableS10[ 63]= 148;//tableK[ 63]= 320;
  tableS10[ 64]= 148;//tableK[ 64]= 325;
  tableS10[ 65]= 147;//tableK[ 65]= 330;
  tableS10[ 66]= 146;//tableK[ 66]= 335;
  tableS10[ 67]= 146;//tableK[ 67]= 340;
  tableS10[ 68]= 145;//tableK[ 68]= 345;
  tableS10[ 69]= 144;//tableK[ 69]= 350;
  tableS10[ 70]= 144;//tableK[ 70]= 355;
  tableS10[ 71]= 143;//tableK[ 71]= 360;
  tableS10[ 72]= 142;//tableK[ 72]= 365;
  tableS10[ 73]= 142;//tableK[ 73]= 370;
  tableS10[ 74]= 141;//tableK[ 74]= 375;
  tableS10[ 75]= 140;//tableK[ 75]= 380;
  tableS10[ 76]= 140;//tableK[ 76]= 385;
  tableS10[ 77]= 139;//tableK[ 77]= 390;
  tableS10[ 78]= 138;//tableK[ 78]= 395;
  tableS10[ 79]= 138;//tableK[ 79]= 400;
  tableS10[ 80]= 137;//tableK[ 80]= 405;
  tableS10[ 81]= 136;//tableK[ 81]= 410;
  tableS10[ 82]= 136;//tableK[ 82]= 415;
  tableS10[ 83]= 135;//tableK[ 83]= 420;
  tableS10[ 84]= 134;//tableK[ 84]= 425;
  tableS10[ 85]= 134;//tableK[ 85]= 430;
  tableS10[ 86]= 133;//tableK[ 86]= 435;
  tableS10[ 87]= 132;//tableK[ 87]= 440;
  tableS10[ 88]= 132;//tableK[ 88]= 445;
  tableS10[ 89]= 131;//tableK[ 89]= 450;
  tableS10[ 90]= 131;//tableK[ 90]= 455;
  tableS10[ 91]= 130;//tableK[ 91]= 460;
  tableS10[ 92]= 129;//tableK[ 92]= 465;
  tableS10[ 93]= 129;//tableK[ 93]= 470;
  tableS10[ 94]= 128;//tableK[ 94]= 475;
  tableS10[ 95]= 128;//tableK[ 95]= 480;
  tableS10[ 96]= 127;//tableK[ 96]= 485;
  tableS10[ 97]= 126;//tableK[ 97]= 490;
  tableS10[ 98]= 126;//tableK[ 98]= 495;
  tableS10[ 99]= 125;//tableK[ 99]= 500;
  tableS10[ 100]= 124;//tableK[ 100]= 505;
  tableS10[ 101]= 124;//tableK[ 101]= 510;
  tableS10[ 102]= 123;//tableK[ 102]= 515;
  tableS10[ 103]= 122;//tableK[ 103]= 520;
  tableS10[ 104]= 122;//tableK[ 104]= 525;
  tableS10[ 105]= 121;//tableK[ 105]= 530;
  tableS10[ 106]= 121;//tableK[ 106]= 535;
  tableS10[ 107]= 120;//tableK[ 107]= 540;
  tableS10[ 108]= 119;//tableK[ 108]= 545;
  tableS10[ 109]= 119;//tableK[ 109]= 550;
  tableS10[ 110]= 118;//tableK[ 110]= 555;
  tableS10[ 111]= 118;//tableK[ 111]= 560;
  tableS10[ 112]= 117;//tableK[ 112]= 565;
  tableS10[ 113]= 116;//tableK[ 113]= 570;
  tableS10[ 114]= 116;//tableK[ 114]= 575;
  tableS10[ 115]= 115;//tableK[ 115]= 580;
  tableS10[ 116]= 114;//tableK[ 116]= 585;
  tableS10[ 117]= 114;//tableK[ 117]= 590;
  tableS10[ 118]= 113;//tableK[ 118]= 595;
  tableS10[ 119]= 112;//tableK[ 119]= 600;
  tableS10[ 120]= 112;//tableK[ 120]= 605;
  tableS10[ 121]= 111;//tableK[ 121]= 610;
  tableS10[ 122]= 110;//tableK[ 122]= 615;
  tableS10[ 123]= 110;//tableK[ 123]= 620;
  tableS10[ 124]= 109;//tableK[ 124]= 625;
  tableS10[ 125]= 108;//tableK[ 125]= 630;
  tableS10[ 126]= 108;//tableK[ 126]= 635;
  tableS10[ 127]= 107;//tableK[ 127]= 640;
  tableS10[ 128]= 107;//tableK[ 128]= 645;
  tableS10[ 129]= 106;//tableK[ 129]= 650;
  tableS10[ 130]= 105;//tableK[ 130]= 655;
  tableS10[ 131]= 105;//tableK[ 131]= 660;
  tableS10[ 132]= 104;//tableK[ 132]= 665;
  tableS10[ 133]= 103;//tableK[ 133]= 670;
  tableS10[ 134]= 103;//tableK[ 134]= 675;
  tableS10[ 135]= 102;//tableK[ 135]= 680;
  tableS10[ 136]= 101;//tableK[ 136]= 685;
  tableS10[ 137]= 100;//tableK[ 137]= 690;
  tableS10[ 138]= 100;//tableK[ 138]= 695;
  tableS10[ 139]= 99;//tableK[ 139]= 700;
  tableS10[ 140]= 98;//tableK[ 140]= 705;
  tableS10[ 141]= 98;//tableK[ 141]= 710;
  tableS10[ 142]= 97;//tableK[ 142]= 715;
  tableS10[ 143]= 96;//tableK[ 143]= 720;
  tableS10[ 144]= 96;//tableK[ 144]= 725;
  tableS10[ 145]= 95;//tableK[ 145]= 730;
  tableS10[ 146]= 94;//tableK[ 146]= 735;
  tableS10[ 147]= 93;//tableK[ 147]= 740;
  tableS10[ 148]= 93;//tableK[ 148]= 745;
  tableS10[ 149]= 92;//tableK[ 149]= 750;
  tableS10[ 150]= 91;//tableK[ 150]= 755;
  tableS10[ 151]= 90;//tableK[ 151]= 760;
  tableS10[ 152]= 90;//tableK[ 152]= 765;
  tableS10[ 153]= 89;//tableK[ 153]= 770;
  tableS10[ 154]= 88;//tableK[ 154]= 775;
  tableS10[ 155]= 87;//tableK[ 155]= 780;
  tableS10[ 156]= 86;//tableK[ 156]= 785;
  tableS10[ 157]= 86;//tableK[ 157]= 790;
  tableS10[ 158]= 85;//tableK[ 158]= 795;
  tableS10[ 159]= 84;//tableK[ 159]= 800;
  tableS10[ 160]= 83;//tableK[ 160]= 805;
  tableS10[ 161]= 82;//tableK[ 161]= 810;
  tableS10[ 162]= 82;//tableK[ 162]= 815;
  tableS10[ 163]= 81;//tableK[ 163]= 820;
  tableS10[ 164]= 80;//tableK[ 164]= 825;
  tableS10[ 165]= 79;//tableK[ 165]= 830;
  tableS10[ 166]= 78;//tableK[ 166]= 835;
  tableS10[ 167]= 77;//tableK[ 167]= 840;
  tableS10[ 168]= 76;//tableK[ 168]= 845;
  tableS10[ 169]= 75;//tableK[ 169]= 850;
  tableS10[ 170]= 74;//tableK[ 170]= 855;
  tableS10[ 171]= 73;//tableK[ 171]= 860;
  tableS10[ 172]= 72;//tableK[ 172]= 865;
  tableS10[ 173]= 71;//tableK[ 173]= 870;
  tableS10[ 174]= 70;//tableK[ 174]= 875;
  tableS10[ 175]= 69;//tableK[ 175]= 880;
  tableS10[ 176]= 68;//tableK[ 176]= 885;
  tableS10[ 177]= 67;//tableK[ 177]= 890;
  tableS10[ 178]= 66;//tableK[ 178]= 895;
  tableS10[ 179]= 65;//tableK[ 179]= 900;
  tableS10[ 180]= 64;//tableK[ 180]= 905;
  tableS10[ 181]= 62;//tableK[ 181]= 910;
  tableS10[ 182]= 61;//tableK[ 182]= 915;
  tableS10[ 183]= 60;//tableK[ 183]= 920;
  tableS10[ 184]= 58;//tableK[ 184]= 925;
  tableS10[ 185]= 57;//tableK[ 185]= 930;
  tableS10[ 186]= 56;//tableK[ 186]= 935;
  tableS10[ 187]= 54;//tableK[ 187]= 940;
  tableS10[ 188]= 52;//tableK[ 188]= 945;
  tableS10[ 189]= 51;//tableK[ 189]= 950;
  tableS10[ 190]= 49;//tableK[ 190]= 955;
  tableS10[ 191]= 47;//tableK[ 191]= 960;
  tableS10[ 192]= 45;//tableK[ 192]= 965;
  tableS10[ 193]= 42;//tableK[ 193]= 970;
  tableS10[ 194]= 40;//tableK[ 194]= 975;
  tableS10[ 195]= 37;//tableK[ 195]= 980;
  tableS10[ 196]= 34;//tableK[ 196]= 985;
  tableS10[ 197]= 29;//tableK[ 197]= 990;
  tableS10[ 198]= 24;//tableK[ 198]= 995;
  tableS10[ 199]= 11;//tableK[ 199]= 1000;
    
    // Заполняем таблицу квадратов от 90 - минимаальное значени напряжение при котором работает блок питания контролера до
    // 255 - ну просто максимальное среднеквадратичное значение напряжения в сети.
    #ifdef TESTRM
      Serial.println("TABLESQRT");
    #endif
    for(i=0;i<MAX_TABLE_SQRT;i++)
    {  tableSQRT[i]=(int) i*5+125;
       tableSQ[i]=(unsigned int) tableSQRT[i]*tableSQRT[i];
       #ifdef TESTRM
          Serial.print((unsigned int)i);
          Serial.write(9);
          Serial.print((unsigned int)tableSQRT[i]);
          Serial.write(9);
          Serial.println((unsigned int)tableSQ[i]);
       #endif
    }
    #ifdef TESTRM
      Serial.println("END TABLESQRT");
    #endif


    #ifdef TEST
      Serial.println("TEST MY_SQRT");
      int j;

      for(j=0;j<=600;j++)
      {
          Serial.print((unsigned int) j);
          Serial.write(9);
          Serial.print((unsigned long) j*j );
          Serial.write(9);
          Serial.print((unsigned int) sqrt((unsigned long) j*j) );
          Serial.write(9);
          Serial.print(my_sqrt((unsigned long) j*j) );
          Serial.write(9);
          Serial.println((long)my_sqrt((unsigned long) j*j)- (long) sqrt((unsigned long) j*j));
      }
      Serial.println("END TEST MY_SQRT");
    #endif
    StateVolts=0;
    // Состояние модема - инициализация   
    flGPRSState=98;
    // После инициализации переходим в нулевое состояние.
    stateAfterDelete=0;
    // На инициализации даем максимум 120 секунд
    timeGPRS=120;
    MaxVoltsOut=0;
    MaxIOut=0;
    
}

// Прерывание управления симистором.
ISR(TIMER5_COMPA_vect) 
{
  #if USE_ASC712==0
  // Включаем симистор
  if (UstPower>0 && StateMachine<100)
  {
    // Если НПГ инициализирован, токда подаем питание на ТЭНы, чтобы их не спалить при не заполненном НПГ
    if (StateNPG>1) digitalWrite(PIN_TRIAC, HIGH);  
    // ждем 20 мкс и выключаем симистор
  }
  delayMicroseconds(20);
  if (TimeOpenTriacFact!=9999)
  {
    digitalWrite(PIN_TRIAC, LOW);
  }
  #else
    // Отключаем симистор только если установленная мощность меньше заданной
    if (UstPwrPH1<PowerPhase[0]) digitalWrite(PIN_TRIAC, LOW);
  #endif

}

// Прерывание управления симистором клапанов
ISR(TIMER5_COMPB_vect) 
{
  #if USE_ASC712==0 && SIMPLED_VERSION!=20
  char i;  
  for (i=0;i<MAX_KLP;i++)
  { // Если клапан в режиме ШИМ и Состояние клапана включен, то включаем его 
    #if SIMPLED_VERSION<30
       if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i, KLP_HIGH); 
    #else
       if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i+i, KLP_HIGH);    
    #endif 
  }
  
  if (TimeOpenKLP!=9999 && !flNoPhase) // Если клапана не в режиме максимальной мощности или фазовое управление отключено
  {
    delayMicroseconds(20);       
  
    for (i=0;i<MAX_KLP;i++)
    { // Если клапан в режиме ШИМ и Состояние клапана включен, то выключаем его 
      #if SIMPLED_VERSION<30
        if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i, !KLP_HIGH);  
      #else
       if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i+i, !KLP_HIGH);  
      #endif
    }
  }
  //  digitalWrite(PIN_KLP_BEG+1, HIGH);  
  //  // ждем 20 мкс и выключаем симистор
  //  delayMicroseconds(20);       
  //  digitalWrite(PIN_KLP_BEG+1, LOW); 
  #endif
  // Взводим таймер открытия фазы дефлегматора
  
  #if SIMPLED_VERSION==20


    // Включаем симистор сразу если мощность более номинальной  (TimeOpenTriacFact==9999)
    if (UstPower>0 && StateMachine<100 && TimeOpenTriacFact==9999 && StateNPG>1) digitalWrite(PIN_KLP_BEG+KLP_DEFL, HIGH);  
    TCNT3H=0x00;
    TCNT3L=0x00;
    OCR3AH=(char)(TimeOpenTriacFact>>8);
    OCR3AL=(char)TimeOpenTriacFact;
  #endif
  
}

// Прерывание управления симистором двигателя
ISR(TIMER5_COMPC_vect) 
{
  // Взводим таймер открытия фазы голов
  #if SIMPLED_VERSION==20
    // Включаем симистор сразу если мощность более номинальной  (TimeOpenTriacFact==9999)
    if (UstPower>0 && StateMachine<100 && TimeOpenTriacFact==9999 && StateNPG>1) digitalWrite(PIN_KLP_BEG+KLP_GLV_HVS, HIGH);  
    TCNT4H=0x00;
    TCNT4L=0x00;
    OCR4AH=(char)(TimeOpenTriacFact>>8);
    OCR4AL=(char)TimeOpenTriacFact;
    // Отладка включаем в любом случае.
  #endif
}



#if SIMPLED_VERSION==20
  // Прерывание управления симистором.
  ISR(TIMER3_COMPA_vect) 
  {
    // Включаем симистор
    if (UstPower>0 && StateMachine<100)
    {
      // Если НПГ инициализирован, токда подаем питание на ТЭНы, чтобы их не спалить при не заполненном НПГ
      if (StateNPG>1) digitalWrite(PIN_KLP_BEG+KLP_DEFL, HIGH);  
      // ждем 20 мкс и выключаем симистор
    }
    delayMicroseconds(20);
    if (TimeOpenTriacFact!=9999)
    {
      digitalWrite(PIN_KLP_BEG+KLP_DEFL, LOW);
    }
   }

  // Прерывание управления симистором клапанов
  ISR(TIMER4_COMPA_vect) 
  {
    // Включаем симистор
    if (UstPower>0 && StateMachine<100)
    {
      // Если НПГ инициализирован, токда подаем питание на ТЭНы, чтобы их не спалить при не заполненном НПГ
      if (StateNPG>1) digitalWrite(PIN_KLP_BEG+KLP_GLV_HVS, HIGH);  
      // ждем 20 мкс и выключаем симистор
    }
    delayMicroseconds(20);
    if (TimeOpenTriacFact!=9999)
    {
      digitalWrite(PIN_KLP_BEG+KLP_GLV_HVS, LOW);
    }
 }
#endif

// Процедура открывает клапана, которые необходимо открыть.

void OpenKLP()
{
  char i;  
  for (i=0;i<MAX_KLP;i++)
  { // Если клапан в режиме ШИМ и Состояние клапана включен, то включаем его 
    #if SIMPLED_VERSION<30
      if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i, KLP_HIGH); 
    #else
      if (KlReg[i]==1 && KlState[i]==1) digitalWrite(PIN_KLP_BEG+i+i, KLP_HIGH); 
    #endif 
  }
}

char fl_read; // Признак того, что надо считать средреквадратичное


void ReadAlarm()
{
  boolean UprNBK;
  ProcessNPG();

 // Если уровень тревоги равен единице, то считаем, что датчик цифровой
  if  (USE_ALARM_VODA)
  {
      if (UROVEN_ALARM!=1)  U_VODA=analogRead(PIN_ALARM_VODA);    
                       else U_VODA=!digitalRead(PIN_ALARM_VODA); // Датчики влажности инверсные, то есть при не сработавшем состоянии у них на выходе 1, при сработке 0
                       
      if (U_VODA>=UROVEN_ALARM )
      {
        CountAlarmVoda++;
        
#ifdef TEST
        sprintf(my_tx_buffer,"ALARM U_VODA=%i cnt=%i",U_VODA,CountAlarmVoda);
        Serial.println(my_tx_buffer);
#endif      

        if (CountAlarmVoda>COUNT_ALARM)
        {
          DispDopInfo=2;
          if (IspReg==129) DispPage=4;
          
          if (flNeedCall==0) flNeedCall=1;
          // По прошествии минуты устанавливаем флаг сработки.
          if (CountAlarmVoda>COUNT_ALARM_VODA)
          {
            DispDopInfo=0;
    #ifndef TEST
    #ifndef DEBUG
    #ifndef TESTGSM
    #ifndef TESTGSM1
              IspReg=250;      // Переводим контроллер в режим тревоги, если не установлен тестовый режим.
    #endif
    #endif
    #endif
    #endif
          }
        }
      }
      else 
      {
        if (DispDopInfo==2)
        { flNeedCall=0; 
          DispDopInfo=0;
        }
        CountAlarmVoda=0;
      }
  }

  if (USE_ALARM_UROVEN)
  {
    if (UROVEN_ALARM!=1)  U_UROVEN=analogRead(PIN_ALARM_UROVEN);
                     else U_UROVEN=!digitalRead(PIN_ALARM_UROVEN); // Датчики влажности инверсные, то есть при не сработавшем состоянии у них на выходе 1, при сработке 0
                     
      // Для фракционной перегонки первой фракции считаем сработкой датчика уровня также и сработку датчика голов. Чтобы можно было отбирать головы через один клапан, тело через другой
      // без фракционника.
      if (IspReg==117 && TekFraction==0)
      {
          if (UROVEN_ALARM!=1)  U_UROVEN=U_UROVEN+analogRead(PIN_PROVODIMOST_SR);
                           else U_UROVEN=U_UROVEN || !digitalRead(PIN_PROVODIMOST_SR); // Датчики влажности инверсные, то есть при не сработавшем состоянии у них на выходе 1, при сработке 0
      
      }
        // Предупреждение по уровню генерируем только уже не произошла сработка уроня
        // Если произошла, то уже смысла анализировать нет
      if (U_UROVEN>=UROVEN_ALARM  && flAlarmUroven==0)
      {
        CountAlarmUroven++;
#ifdef TEST
        sprintf(my_tx_buffer,"ALARM U_UROVEN=%i cnt=%i",U_UROVEN,CountAlarmUroven);
        Serial.println(my_tx_buffer);
#endif      
        if (CountAlarmUroven>COUNT_ALARM )
        {
          DispDopInfo=1;
          if (flNeedCall==0) flNeedCall=1;
          // По прошествии минуты устанавливаем флаг сработки.
          if (CountAlarmUroven>COUNT_ALARM_UROVEN || ((IspReg==117 || IspReg==118) && CountAlarmUroven>COUNT_ALARM_UROVEN_FR) )
          {
            flAlarmUroven=1;
            flNeedAnalyse=1;
            DispDopInfo=0;
          }
        } 
      }
      else 
      {
        if (DispDopInfo==1)
        { flNeedCall=0; 
          DispDopInfo=0;
        }
        CountAlarmUroven=0;
      }
  }

  if (USE_GAS_SENSOR)
  {
    if (UROVEN_GAS_SENSOR!=1) U_GAS=analogRead(PIN_GAS_SENSOR);
                         else U_GAS=digitalRead(PIN_GAS_SENSOR); 
                         
    //      Если датчик еще не прогрелся, то выводим значение времени, оставшееся для прогрева датчика паров спирта
    if (Seconds<TIME_PROGREV_GAS_SENSOR) U_GAS=TIME_PROGREV_GAS_SENSOR-Seconds;
    else
    {

        if (U_GAS>=UROVEN_GAS_SENSOR) 
        {
          CountGasSensor++;
          #ifdef TEST
          sprintf(my_tx_buffer,"ALARM U_GAS=%i cnt=%i",U_GAS,CountGasSensor);
          Serial.println(my_tx_buffer);
          #endif  
    
          if (CountGasSensor>COUNT_GAS_SENSOR )
          {
            flNeedAnalyse=1;
            #ifndef TEST
            IspReg=252;      // Переводим контроллер в режим тревоги, если не установлен тестовый режим.
            #endif
          }
        }
        else
          CountGasSensor=0;
    }
  }
  

  #ifdef PIN_MPX5010
    U_MPX5010=analogRead(PIN_MPX5010);
    #if SIMPLED_VERSION==20
      Serial.println(U_MPX5010);
      if (UstPowerReg!=(U_MPX5010))
      { UstPowerReg=U_MPX5010;
        flNeedAnalyse=1;
      }
    #endif
    
    //      U_MPX5010=(U_MPX5010*4)/5-16;
    U_MPX5010=(U_MPX5010*4-160)/5;
    if (FlState!=253) U_MPX5010=U_MPX5010+P_MPX5010;
    
    if (U_MPX5010>MaxPressByPeriod) MaxPressByPeriod=U_MPX5010;
    
    if (U_MPX5010>=AlarmMPX5010 && AlarmMPX5010>0)
    {
      CountAlarmMPX5010++;
#ifdef TEST
      sprintf(my_tx_buffer,"ALARM MPX5010=%i cnt=%i",AlarmMPX5010,CountAlarmMPX5010);
      Serial.println(my_tx_buffer);
#endif      

      if (CountAlarmMPX5010>COUNT_ALARM)
      {
        DispDopInfo=5;
        if (flNeedCall==0) flNeedCall=1;
        // По прошествии минуты устанавливаем флаг сработки.
        if (CountAlarmMPX5010>MAX_ERR_MPX5010)
        {
          flAlarmMPX5010=1;
          flNeedAnalyse=1;
          DispDopInfo=0;
        }
      } 
    }
    else 
    {
      if (DispDopInfo==5) 
      {  DispDopInfo=0;
         flNeedCall=0;
      } 
      CountAlarmMPX5010=0;
    }
    
  #endif

  if (UrovenProvodimostSR!=0 || IspReg==112 || FlState==232 || IspReg==129) // Читаем датчик уровня голов, если установлено, что его надо читать, либо если в данный момент используется режим НБК.
  {
    if (UrovenProvodimostSR!=1) U_GLV=analogRead(PIN_PROVODIMOST_SR);
                             else U_GLV=!digitalRead(PIN_PROVODIMOST_SR);// Датчики влажности инверсные, то есть при не сработавшем состоянии у них на выходе 1, при сработке 0
  } 
  
  // Для НБК датчик голов служит датчиком заполнения барды.
  if (IspReg==112 || IspReg==129) // Если режим - НБК, то открываем слив барды
  {
    if (timeBRD==0) // Если датчик уже нужно анализировать
    {
      if (U_GLV>=UrovenBarda) // Если датчик НБК сработал, то открываем клапан слива барды
      {
         KlOpen[KLP_BARDA]=PER_KLP_OPEN;
         KlClose[KLP_BARDA]=PER_KLP_CLOSE;
         if (timeOpenBRD>0) timeBRD=timeOpenBRD;
                   else timeBRD=2;
         
      }
      else // Если не сработал, то закрываем.
      {
         if(IspReg!=129)
         { // Клапан барды в режиме тестирования не закрываем.е
           KlOpen[KLP_BARDA]=0;
           KlClose[KLP_BARDA]=100;
          UprNBK=LOW;
          if (!(UprNasosNBK&B00000010)) UprNBK=!UprNBK;
          digitalWrite(PIN_NASOS_NBK_BRD,UprNBK);  
         } 
      }
    }
  }
  
 
}


// Прерывание вызывается 125 раз в секунду
ISR(TIMER2_COMPA_vect) 
{
  boolean UprNBK;
  // Сброс таймера
  TCNT2=0x00;


  Counter1++;
  if (Counter1==62)
  {
    NeedDisplaying=true;
    flNeedReadAlarm=true;
    NeedGPRS=1;
  }

  // Насосом НБК все равно управляем ( в режим НБК кстати не такие высокие требования к мощности)
  if (SpeedNBK>0) 
  {  
    if (timeNBK>0)
     { 
       if (!(UprNasosNBK&B00000100)) // Насосом управляем через брезенхем 
       {
          b_value[1]=SpeedNBK;
          UprNBK=bresenham_getNext(1);
          if (!(UprNasosNBK&B00000001)) UprNBK=!UprNBK;
          digitalWrite(PIN_NASOS_NBK,UprNBK);
       }
       else
       {
         // Насосом управляем через ШИМ
         if (b_value[1]<SpeedNBK) digitalWrite(PIN_NASOS_NBK,HIGH);
                              else digitalWrite(PIN_NASOS_NBK,LOW);
         b_value[1]++;
         if (b_value[1]>b_size[1]) b_value[1]=0;
       }
        
     }
  }
  // Насосом бардоотводчика управляем всегда, если он включен.
   if (timeOpenBRD<0 && timeBRD>0)
   {
      b_value[2]=(int)SpeedNBKDst*(int)(-timeOpenBRD)/10;
      UprNBK=bresenham_getNext(2);
      if (!(UprNasosNBK&B00000010)) UprNBK=!UprNBK;
      digitalWrite(PIN_NASOS_NBK_BRD,UprNBK);
   }
   else
   {
      UprNBK=LOW;
      if (!(UprNasosNBK&B00000010)) UprNBK=!UprNBK;
      digitalWrite(PIN_NASOS_NBK_BRD,UprNBK);  
   }

  
  if (StateVolts==1) return;

  if (Counter1 % 25 ==0)
  {
//    Sec5++;
  }
  
  

  #ifdef DEBUG
    if (Serial.available()) return;
  #endif
  // Сканируем клавиатуру три раза секунду или если находимся не в режиме отображения информации, то постоянно, то есть 125 раз в секунду


  if (BeepTime>1) BeepTime--;
  else
  {
    if (BeepTime==1) analogWrite(PIN_SOUND, 255);
    BeepTime=0;
  }

  //  

  // Следим за защитой от дребезга клавиш
  if (Counter1 % 20 ==0)
  {          
    if (CountKeys>0 && flScanKbd==0) CountKeys--; 
    flNeedScanKbd=1; 

  }


//  if (Counter1 % 32 ==0)
//  {
//    if (StateVolts==4) 
//    {
//      StateVolts=0; // Раз в 1/3 секунды запускаем измерение среднеквадратичного (в дальнейшем можно будет настроить, 
//      // чтобы оно делалось так часто, насколько позволяют возможности контроллера).
//      if (CorrectASC712)  flCorrASC712=!flCorrASC712; // Читаем через раз, то мощность, то напряжение если, конечно установлено что надо считать мощность.
//      
//    }
//
//  }
  
  if (Counter1>=125)
  {
    wdt_reset();
//    analogWrite(PIN_LIGHT,100);
    if (CountKeys>0) 
    { 
      if (secPressKeys>0) { AddPressKeys=1;  AddPressKeys10=10;}
      if (secPressKeys>3) {AddPressKeys=5;   AddPressKeys10=20;}
      if (secPressKeys>5) {AddPressKeys=10;  AddPressKeys10=50;}
      if (secPressKeys>10) {AddPressKeys=100;AddPressKeys10=100;}
      if (secPressKeys>15) {AddPressKeys=200;AddPressKeys10=250;}
      if (secPressKeys<200) secPressKeys++;
    }
    else
    {
      secPressKeys=0;
      AddPressKeys=1;
      AddPressKeys10=10;
    }
    zPSOut=zPS;
    zPS=0;
    if (time1>0) time1--;
            else time1=0;
    if (time2>0) time2--;
            else time2=0;
    if (time3>0) time3--;
            else time3=0;
    if (timeGPRS!=0) timeGPRS--;
    if (timeBRD!=0) timeBRD--;
    
    if (timeWaitGPRS!=0) timeWaitGPRS--;
    
    if (timeRefrServer!=0) timeRefrServer--;
    else
    {
      // Если не находимся в режиме обновления сервера, тогда установим необходимость сессии GPRS  
        // Если GPRS используется и не переведено в режим отправки SMS и сессия GPRS не активирована и задан период опроса сервера.
        if (FlToGSM>1 && !SMSOnCall && timeGPRS==0 && PeriodRefrServer!=0 && (flGPRSState==0 || flGPRSState==98))
          {
            ErrGPRSConnectInernet=0;
            ErrGPRSConnectServer=0;
            if (flGPRSState==0) flGPRSState=14; // Активируем сессию GPRS
            flNeedRefrServer=1;
            timeGPRS=60;
          }
    }

    if (timeNBK>0) 
    {  
      // Задаем скорость насосу. 
      timeNBK--;
    }
    else
    {  
      // убираем насос.
      timeNBK=0;
    }

    if (timeNBK==0 || SpeedNBK==0 ) 
    {  
      // убираем насос НБК.
        UprNBK=LOW;
        if (!(UprNasosNBK&B00000001)) UprNBK=!UprNBK;
        digitalWrite(PIN_NASOS_NBK,UprNBK);
    }

    if (timeMIXER>0)
    { 
      timeMIXER--;
      digitalWrite(PIN_MIXER,RELAY_HIGH);
      if (IspReg== 108 || IspReg== 113 || IspReg== 114 || IspReg==112 || IspReg==104) // Если идет процесс разварки зерна,  то включаем мешалку, которую возможно подключить через реле на клапан голов
      {
          KlOpen[KLP_GLV_HVS]=40;
          KlClose[KLP_GLV_HVS]=0;
      }
    }
    else
    {
      timeMIXER=0;
      digitalWrite(PIN_MIXER,!RELAY_HIGH);
      if (IspReg== 108 || IspReg== 113 || IspReg== 114 || IspReg== 112  || IspReg==104) // Если идет процесс разварки зерна, то отключаем мешалку, которую возможно подключить через реле на клапан голов
      {
          KlOpen[KLP_GLV_HVS]=0;
          KlClose[KLP_GLV_HVS]=40;
      }
    }

    if (CountState>0) 
    {   
      //if (CountState==1) lcd.clear();
      CountState--;
    }
    Seconds++;
    flReadPress++;
    Counter1=0;
    NeedDisplaying=true;
    NeedGPRS=1;
    flNeedReadAlarm=true;
    flCrossZero++;
    if (flCrossZero>80)
    {
      // Если находимся не в режиме термостата или просмотра, и пропадание напряжения не появилось в результате нормального отключения дифавтомата,то переводим в режим тревоги.
      // Если не находимся в режиме тестирования
#ifndef TEST
#ifndef TESTRM
#ifndef DEBUG
#ifndef TESTGSM
#ifndef TESTGSM1
      if (IspReg>102 && (!USE_DIFAVTOMAT || !flAllOff))
      {
        // Выдаем ошибку детектирования нуля.
        IspReg=249;

      }
#endif
#endif
#endif
#endif
#endif
      StateVolts=0;
      flCrossZero=0;
    }
    
    
    // Если контроллер используется как термостат, или это уже чтение готового результата, или при чтении информации датчиков произошла ошибка то читаем раз в секунду.
    // Или мы сейчас вводим поправки.
    if (IspReg==102 || StepOut!=0 || FlState==300 || CntErrDs18) 
    {
      flNeedTemp=1; // Устанавливаем флаг того, что надо читать температуру
    }
    else
    {
      // Иначе запускаем расчет один раз в 5 секунд (чтоб поменьше мограл регулятор мощности).
      if (Seconds % 5==0) flNeedTemp=1; 
    }

  }
  // Выполняем процесс.

  if (CountState<=0 && flScanKbd==0) 
  {
    FlState=0;
    CountState=0;
  }  

}



// Функция вызывается по прерыванию нуля от нуля сети 220 вольт
boolean br_on; // Признак включения по брезенхему
unsigned char CntPeriodPause=0; // Число полу-периодов паузы

void zero_crosss_int()  // function to be fired at the zero crossing to dim the light
{
  #ifdef DEBUG
    if (Serial.available()) return;
  #endif

  unsigned char i;
  unsigned char flOpenClose;
  zPS++;
  flCrossZero=0;
  
  TicZero=(int) TCNT5L | (int) (TCNT5H<<8); // Расчитывааем текущее значение таймера
  // Сбрасываем 5-й таймер.
  TCNT5H=0x00;
  TCNT5L=0x00;
    
  if (StateVolts==1 ) 
   { 
    // Если за полу-период не выбрано допуустимое количество значений, тогда пропускаем эти выборки и пытаемся выбрать следующий полу-период.
    // также пропускаем выборку если управление по брезенхему и предыдущий период симистор был отключен
    
     if (index_input-prev_index_input>MAX_INDEX_BY_PERIOD || index_input-prev_index_input<MIN_INDEX_BY_PERIOD || !br_on) 
     {
        index_input=prev_index_input;
        SqNaprT=SqNaprPrevT;
     }
    else 
      CntPeriod++; // Если число в выборке допустимо, то прибавляем счетчик полу-периодов выборки
    
    // Если считали достаточное количество полу-периодов, тогда расчет закончен.
    if (CntPeriod>=CNT_PERIOD)
      {
        if (flCorrASC712==0) indexOut=index_input;
        StateVolts=2;// Если был расчет тока (напряжения), то ставим признак его окончания
        CntPeriodPause=0; 
      }
   } 
  else
   {
     CntPeriodPause++;
   } 

  if (StateVolts==4)
  {
    // Если пропустили два по необходимому числу полу-периодов, запускаем расчет.
    // Еще одно условие, чтобы мы не находились в режиме ввода клавиш, тогда расчет не запускаем, чтобы не тормозить отчаянно 
    // при вводе информации
    if (CntPeriodPause > CNT_PERIOD && CountKeys==0) 
    { 
      StateVolts=0;
      if (CorrectASC712)  flCorrASC712=!flCorrASC712; // Читаем через раз, то мощность, то напряжение если, конечно установлено что надо считать мощность.
    }
  }
   
  if (StateVolts==0) 
  {
      index_input=0;
      StateVolts=1; 
 //     MaxVolts=0;
      #if SIMPLED_VERSION!=20
      TCNT4H=0x00;
      TCNT4L=0x00;
      #endif
      CntPeriod=0;
      SqNaprT=0;
  }
    
  prev_index_input=index_input;
  SqNaprPrevT=SqNaprT;
  br_on=true;    

  #if USE_ASC712==0
  if (UstPwrPH1>=PowerPhase[0])
  {
    // Если мощность больше или равна номинальной, включаем триак всегда, при этом прерывание на закрытие никогда не выполнится.  
    TimeOpenTriac=9999;
    TimeOpenTriacFact=9999;
    // Если НПГ инициализирован, токда подаем питание на ТЭНы, чтобы их не спалить при не заполненном НПГ
    if (StateNPG>1) digitalWrite(PIN_TRIAC, HIGH);  
  }
  else
  {
    TimeOpenTriacFact=TimeOpenTriac;
  }

  // Если мощность не установлена отключена, или состояние машины конечное, то на всякий случай отключаем
  if (UstPower<=0 || StateMachine>=100) digitalWrite(PIN_TRIAC, LOW);

  if (TimeOpenTriac<=10)
  {
    // Если НПГ инициализирован, токда подаем питание на ТЭНы, чтобы их не спалить при не заполненном НПГ
    if (StateNPG>1 && UstPower>0) digitalWrite(PIN_TRIAC, HIGH);  
    TimeOpenTriacFact=9999;
  }

  //    TimeOpenTriacFact=TimeOpenTriac;
  //TimeOpenTriac=2000;
  // В прерывании нуля настраиваем, чтобы прерывание на 5-м таймере выдалось через то время, которое мы ранее рассчитали.
  OCR5AH=(char)(TimeOpenTriacFact>>8);
  OCR5AL=(char)TimeOpenTriacFact;

  if (TimeOpenKLP==0) TimeOpenKLP=9999;
  OCR5BH=(char)(TimeOpenKLP>>8);
  OCR5BL=(char)TimeOpenKLP;
  
  // Если считаем ток(напрряжение), тогда 
  #if SIMPLED_VERSION==20
    if (UstPower<=0 || StateMachine>=100) 
    {
      digitalWrite(PIN_TRIAC, LOW);
      digitalWrite(KLP_DEFL, LOW);
      digitalWrite(KLP_GLV_HVS, LOW);
    }
    // Взводим таймеры запуска таймеров дефлегматора и голов.
    OCR5BH=(char)(timeChimRectOtbSR>>8);
    OCR5BL=(char)timeChimRectOtbSR;
    
    OCR5CH=(char)(timeChimRectOtbGlv>>8);
    OCR5CL=(char)timeChimRectOtbGlv;
  #endif
  
  #else
     // Устанавливаем закрытие симистора по прерыванию таймера через некоторое время (отступить от таблицы мощности на 2 шага вполе достаточно).
     TimeOpenTriacFact=tableS10[MAX_TABLE_T-2];
     TimeOpenTriacFact*=10;
     TimeOpenTriac=TimeOpenTriacFact;
     OCR5AH=(char)(TimeOpenTriacFact>>8);
     OCR5AL=(char)TimeOpenTriacFact;
    // Если процент брезенхема не рассчитан, а мощность установлена, то запускаем измерительный период
    if (UstPower>0 && b_value[0]==0 || UstPwrPH1>=PowerPhase[0]) digitalWrite(PIN_TRIAC,HIGH);
     else
       if (UstPower<=0) digitalWrite(PIN_TRIAC,LOW);  // Если мощность не установлена, то на реле подаюм нулевой сигнал
         else
           {
             br_on=bresenham_getNext(0);
             digitalWrite(PIN_TRIAC,br_on); // Иначе стандартно вызываем алгоритм брезехема.
           }
  #endif
  

// фазовое управление давигателем пока не используем 
//    TimeOpenDvigatel=5000; 
//    if (SpeedNBK>0)
//    {
//      TimeOpenDvigatel=TicZero/100;
//      TimeOpenDvigatel=TimeOpenDvigatel*SpeedNBK;
//      TimeOpenDvigatel=TicZero-TimeOpenDvigatel;
//      if (SpeedNBK>=100) digitalWrite(PIN_DVIGATEL, HIGH);  
//    }
//
//    OCR5CH=(char)(TimeOpenDvigatel>>8);
//    OCR5CL=(char)TimeOpenDvigatel;

  // В прерывании нуля управляем открытием клапанов (а их лучше открывать по 0, чтобы не было помех)
  // Синхронизацию пока отключим
  //    if (!flSyncKLP) // Если клапана не находятся в режиме синхронизации
  {
    for (i=0;i<MAX_KLP;i++)
    {
      // Разбираемся с состоянием клапана
      if (KlState[i]==0)
      {
        flOpenClose=0;
        // Состояние клапана - выключен            
        if (KlCount[i]>KlClose[i]) // Если количество тиков превышает установленное для состояния "закрыто", переводим клапан в состояние "открыто"
        {
          // Клапан переводим в состояние-включен
          KlState[i]=1;
          KlCount[i]=0;
          if(KlOpen[i]) flOpenClose=1;
        } 
      }
      else
      { 
        flOpenClose=1;
        // Состояние клапана - выключен
        if (KlCount[i]>KlOpen[i]) // Если количество тиков превышает установленное для состояния "открыто", переводим клапан в состояние "открыто"
        {
          KlState[i]=0;
          KlCount[i]=0;
          if(KlClose[i]) flOpenClose=0;
        } 
      }

      // Если клапан в принципе не должен выключаться то всегда переводим в состояние влкючен
      if (KlClose[i]==0) 
      {  
        flOpenClose=1;
        KlState[i]=1; 
      }
      // Если клапан в принципе не должен включатся,то всегда переводим  в состояние выключаем
      if (KlOpen[i]==0) 
      {
        flOpenClose=0;
        KlState[i]=0; 
        KlCount[i]=0;
      }

      // С состоянием клапана разобрались, тепер в зависимости от состояния включаем или выключаем его

      if (!flOpenClose)
      {  // Если клапан-выключен, то выключаем его в любом случае
        #if SIMPLED_VERSION<30
          digitalWrite(PIN_KLP_BEG+i, !KLP_HIGH);  
        #else
          digitalWrite(PIN_KLP_BEG+i+i, !KLP_HIGH);  
        #endif
      }
      else
      {  // Если состояние клапана - включен, включаем его только в том случае, если клапан в находится в режиме ШИМ
        // Или клапан находится в режиме фазового управления, но включен менее, чем полсекунды назад, или время фазового управления еще не рассчитано, то включаем его тоже,
        // иначе для режима фазового управления клапан включится по принципу фазового управления в прерывании. Или временно фазовое управления убрано
        if (KlReg[i]==0 || KlCount[i]<50 || TimeOpenKLP==9999 || flNoPhase)
        #if SIMPLED_VERSION<30
          digitalWrite(PIN_KLP_BEG+i, KLP_HIGH);
        #else
           digitalWrite(PIN_KLP_BEG+i+i, KLP_HIGH);
        #endif
      }

      KlCount[i]++;
    }    
  }

}


char flNumStrPrint=0;





void ScanKbd()
{
  char i;
  #ifdef DEBUG
    if (Serial.available()) return;
  #endif
  
  // Если режим защиты от дребезга уже выключен
  if (CountKeys==0)
  {
    flScanKbd=1; // Установим признак сканирования клавиатуры.
#if USE_LCD_KEYPAD_SHIELD     
    int key1;
    
    if (cmdGPRS==' ')
    {
        key1=analogRead(A0);
  
      //          select 720
      //          left 478
      //          up 130 ( моргает на 131)
      //          down 306
      //          rigth 0
      //          #define PRESS_SELECT KeyCode==1
      //          #define PRESS_RIGHT  KeyCode==2
      //          #define PRESS_LEFT   KeyCode==3
      //          #define PRESS_UP     KeyCode==4
      //          #define PRESS_DOWN   KeyCode==5
  
        if (key1>=0) KeyCode=3;
        if (key1>=30) KeyCode=4;
        if (key1>=87) KeyCode=5;
        if (key1>=165) KeyCode=2;
        if (key1>=350) KeyCode=1;
        if (key1>=1000) KeyCode=0;
    }
    else
    {
      KeyCode=0;
      if (cmdGPRS=='R') KeyCode=2;
      if (cmdGPRS=='U') KeyCode=4;
      if (cmdGPRS=='D') KeyCode=5;
      if (cmdGPRS=='L') KeyCode=3;
      if (cmdGPRS=='S') KeyCode=1;
      #ifdef TESTGSM
          Serial.print("Go cmd=");
          Serial.print(cmdGPRS);
          Serial.print("=");          
          Serial.println((int)KeyCode);
      #endif
      cmdGPRS=' ';
    }

#endif

    if (PRESS_LEFT && PRESS_RIGHT)
    {
      if (BeepKeyPress) my_beep(2);

      lcd.begin(16, 2);
      lcd.clear();
      DisplayData();
    }


    // Нажатие кнопок одновременно ввехр и вниз позволяет перейти к следующему этапу (отладочные кнопки)
    if (PRESS_UP && PRESS_DOWN)
    {
      if (BeepKeyPress) my_beep(2);
      StateMachine++; // Состояние конечного автомата процесса ректификации
      CountKeys=10; // Большая защита от дребезга, чтоб случайно не нажали.
      DisplayData();
      timeNBK=0;
      timeMIXER=0;
      time1=0;
      time2=0;
      time3=0;

    }

    if (PRESS_SELECT)
    {            
      if (BeepKeyPress) my_beep(1);
       switch (FlState)
      {         
      case 0:   

        FlState=IspReg;
        break;
      case 100:
        FlState=200;      
        break;   
      case 101:
        FlState=0;      
        IspReg=101;   
        writeEEPROM();
        break;   
      case 102:
        if (IspReg!=102)
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=102;
        writeEEPROM();
        FlState=200;
        break;    
      case 200:
        FlState=0;
        writeEEPROM();
        break;    
      case 103:
        IspReg=103;
        writeEEPROM();
        FlState=202;
        break;    
      case 201:
        writeEEPROM();
        FlState=0;
        break;     
      case 202:
        writeEEPROM();
        FlState=0;
        break;     
      case 104:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=104 || !StateMachine)
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=104;
        writeEEPROM(); 
        FlState=206;
        break;     
      case 105:  
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=105 || !StateMachine) 
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }                      
        if (!StateMachine) StateMachine=1;
        IspReg=105;
        writeEEPROM();
        FlState=221;
        break;     
      case 106:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=106 || !StateMachine)
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=106;
        writeEEPROM(); 
        FlState=207;
        break;     
      case 107:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=107 || !StateMachine) 
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=107;
        writeEEPROM();
        FlState=208;
        break;     
      case 108:
        if (IspReg!=108 || !StateMachine) 
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=108;
        FlState=259;
        writeEEPROM();
        break;
      case 109:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=109 || !StateMachine)
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
        }
        if (!StateMachine) StateMachine=1;

        IspReg=109;
        FlState=209;
        writeEEPROM();
        break;
      case 110:  
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=110 || !StateMachine) // Если состояние автомата - не запущено, запускаем процесс
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }
        if (!StateMachine) StateMachine=1;

        IspReg=110;
        writeEEPROM();
        FlState=220;
        break;     
      case 111:  
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=111 || !StateMachine) // Если состояние автомата - не запущено, запускаем процесс
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
        }
        if (!StateMachine) StateMachine=1;

        IspReg=111;
        writeEEPROM();
        FlState=209;
        break;     
      case 112:  
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=112 || !StateMachine) // Если состояние автомата - не запущено, запускаем процесс
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
       }
        if (!StateMachine) StateMachine=1;

        IspReg=112;
        writeEEPROM();
        FlState=264;
        break;     
      case 113:  
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=113 || !StateMachine) // Если состояние автомата - не запущено, запускаем процесс
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
        }
        if (!StateMachine) StateMachine=1;

        IspReg=113;
        writeEEPROM();
        FlState=259;
        break;     
      case 114:  
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=114 || !StateMachine) // Если состояние автомата - не запущено, запускаем процесс
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
        }
        if (!StateMachine) StateMachine=1;
        
        IspReg=114;
        writeEEPROM();
        FlState=261;
        break;     
      case 115:  
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=115 || !StateMachine) // Если состояние автомата - не запущено, запускаем процесс
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
        }
        if (!StateMachine) StateMachine=1;
        
        IspReg=115;
        writeEEPROM();
        FlState=0;
        break;     
      case 116:  
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=116 || !StateMachine) // Если состояние автомата - не запущено, запускаем процесс
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
        }
        if (!StateMachine) StateMachine=1;
        
        IspReg=116;
        writeEEPROM();
        FlState=240;
        break; 
      case 117:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=117 || !StateMachine) 
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=117;
        writeEEPROM();
        FlState=257;
        break;             
      case 118:
        // Если ранее был выбран другой тип отбора, сбрасываем состояние автомата в начальное.
        if (IspReg!=118 || !StateMachine) 
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
          flAlarmMPX5010=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=118;
        writeEEPROM();
        FlState=258;
        break;             
      case 130:
        if (IspReg!=130 || !StateMachine) 
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=130;
        writeEEPROM();
        FlState=0;
        break;     
      case 129:
        if (IspReg!=129 || !StateMachine) 
        {
          Seconds=0;
          flAlarmUroven=0;
          StateMachine=0;
        }
        if (!StateMachine) StateMachine=1;
        IspReg=129;
        writeEEPROM();
        FlState=231;
        break;     
      case 203:       
      case 204:       
      case 205:       
      case 206:       
      case 207:       
      case 208:       
      case 209:       
      case 210:       
//      case 211:             
      case 212:       
      case 213:       
      case 214:       
      case 215:       
      case 216:       
      case 217:       
      case 218:       
      case 219:       
      case 220:       
      case 221:       
      case 222:       
      case 223:       
      case 224:       
      case 225:       
      case 226:       
      case 227:       
      case 228:       
      case 229:       
      case 230:       
      case 231:       
      case 232:       
      case 233:       
      case 234:       
      case 236:       
      case 237:       
      case 238:       
      case 239:       
      case 241:       
      case 243:       
      case 246:       
      case 247:       
      case 248:       
      case 250:     
      case 251:     
      case 252:     
      case 253:     
      case 254:     
      case 259:     
      case 260:     
      case 261:     
      case 264:     
      case 265:     
      case 266:     
      case 267:     
      case 268:     
      case 270:     
        writeEEPROM();
        FlState=0;
        break; 
      case 269:     
        FlState=316;
        nPopr=0;
        break;     
      case 211:
        FlState=300;
        nPopr=0;
        break;     
      case 235:
        FlState=301;
        nPopr=0;
        flPopr=0;
        break;     
      case 240:
        FlState=302;
        nPopr=0;
        flPopr=0;
        break;     
      case 242:
        FlState=303;
        nPopr=0;
        flPopr=0;
        break;
      case 244:
        FlState=304;
        nPopr=0;
        flPopr=0;
        break;
      case 245:
        FlState=305;
        nPopr=0;
        flPopr=0;
        break;
      case 249:
        FlState=309;
        nPopr=0;
        flPopr=0;
        break;
      case 255:
        FlState=310;
        nPopr=0;
        flPopr=0;
        break;
      case 256:
        FlState=311;
        nPopr=0;
        flPopr=0;
        break;
      case 257:
        FlState=312;
        nPopr=0;
        flPopr=0;
        break;
      case 258:
        FlState=313;
        nPopr=0;
        flPopr=0;
        break;
      case 262:     
        FlState=314;
        nPopr=0;
        flPopr=0;
        break;
      case 263:     
        FlState=315;
        nPopr=0;
        flPopr=0;
        break;
      case 300:       
        writeEEPROM();
        FlState=211;
        break;    
      case 301:       
        writeEEPROM();
        FlState=235;
        break;    
      case 302:       
        writeEEPROM();
        if (IspReg!=116) FlState=240;
                    else FlState=0;
        break;    
      case 303:       
        writeEEPROM();
        FlState=242;
        break;    
      case 304:       
        writeEEPROM();
        FlState=244;
        break;    
      case 305:       
        writeEEPROM();
        FlState=245;
        break;    
      case 309:       
        writeEEPROM();
        FlState=249;
        break;    
      case 310:       
        writeEEPROM();
        FlState=255;
        break;    
      case 311:       
        writeEEPROM();
        FlState=256;
        break;    
      case 312:       
        writeEEPROM();
        if (IspReg!=117) FlState=257;
                    else FlState=0;
        break;    
      case 313:       
        writeEEPROM();
        if (IspReg!=118) FlState=258;
                    else FlState=0;
        break;    
      case 314:       
        writeEEPROM();
        Power=PowerPhase[0]+PowerPhase[1]+PowerPhase[2];
        FlState=262;
        break;    
      case 315:       
        writeEEPROM();
        FlState=263;
        break;    
      case 316:       
        writeEEPROM();
        FlState=269;
        break;    
        
      }                            
      DisplayData();
      CountState=4;
      if (CountKeys==0) CountKeys=6;              
      CountState=10;

    }

    // Вторая  кнопка ( кнопка -)        
    if (PRESS_RIGHT)  
    { 
      if (BeepKeyPress) my_beep(1);
      switch (FlState)
      {                                              
      case 0:           
        if (DispPage<10) DispPage++;
        // Если перешли на третью страницу, то переинициализируем дисплей
        if (DispPage==4 || DispPage==10)
        {
          my_beep(BEEP_LONG*5);
          lcd.begin(16, 2);
          lcd.clear();
          DisplayData();
        }
        CountKeys=4;              
        break;
      case 100:
      case 101:
      case 102:
      case 103:
      case 104:
      case 105:
      case 106:
      case 107:
      case 108:
      case 109:
      case 110:
      case 111:
      case 112:
      case 113:
      case 114:
      case 115:
      case 116:
      case 117:
      case 129:
        FlState++;    
        break;   
      case 118:
        FlState=129;    
        break;   
      case 130:
        FlState=100;
        break;
      case 200:   
      case 201:
      case 202:
      case 203:
      case 204:
      case 205:
      case 206:
      case 207:
      case 208:
      case 209:
      case 210:
      case 211:
      case 212:
      case 213:
      case 214:
      case 215:
      case 216:
      case 217:
      case 218:
      case 219:
      case 220:
      case 221:
      case 222:
      case 223:
      case 224:
      case 225:
      case 226:
      case 227:
      case 228:
      case 229:
      case 230:
      case 231:
      case 232:
      case 233:
      case 234:
      case 235:
      case 236:       
      case 237:       
      case 238:       
      case 239:       
      case 240:       
      case 241:       
      case 242:       
      case 243:       
      case 244:       
      case 245:       
      case 246:       
      case 247:       
      case 248:       
      case 249:       
      case 250:
      case 251:
      case 252:
      case 253:
      case 254:
      case 255:
      case 256:
      case 257:
      case 258:
      case 259:
      case 260:
      case 261:
      case 262:
      case 263:
      case 264:
      case 265:
      case 266:
      case 267:
      case 268:
      case 269:
        FlState++;
        break;
      case 270:
        FlState=200;
        break;
      case 300:
        if (nPopr<MAX_DS1820-1) nPopr++;
        break;
      case 301:
        if (flPopr==0) flPopr=1;
        else
        {
          if (nPopr<COUNT_CHIM-1) nPopr++;
          flPopr=0;
          
        }
        break;
      case 302:
        if (flPopr==0) flPopr=1;
        else
        {
          if (nPopr<MAX_CNT_PAUSE-1) nPopr++;
          flPopr=0;
          
        }
        break;
      case 303:
        if (nPopr<3) nPopr++;
        break;
      case 304:
        if (nPopr<9) nPopr++;
        break;
      case 305:
        if (nPopr<11) nPopr++;
        break;
      case 309:
        if (nPopr<2) nPopr++;
        break;
      case 310:
      case 311:
        if (nPopr<10) nPopr++;
        break;
      case 312:
        if (flPopr<2) flPopr++;
        else
        {
          if (nPopr<MAX_CNT_FRACTION_DIST) nPopr++;
          flPopr=0;
        }
        break;
      case 313:
        if (flPopr<1) flPopr++;
        else
        {
          if (nPopr<MAX_CNT_FRACTION_RECT) nPopr++;
          flPopr=0;
        }
        break;
      case 314:
      case 315:
        if (nPopr<2) nPopr++;
        break;
      case 316:
        if (nPopr<4) nPopr++;
        break;
        
      }

      //NeedDisplaying=1;
      DisplayData();
      if (CountKeys==0) CountKeys=6;

      CountState=4;
      CountState=40;

    }               

    // первая  кнопка  (кнопка +)      

    if (PRESS_LEFT)
    { 
      if (BeepKeyPress) my_beep(1);
      switch (FlState)
      {

      case 0:          
        if (DispPage>0) DispPage--;
        else
          { // Если на нулевой странице нажали кнопку влево, то тоже переинициализируем дисплей. 
            my_beep(BEEP_LONG*2);
            lcd.begin(16, 2);
            lcd.clear();
            DisplayData();
          }
        
        CountKeys=4;              
        break;
      case 100:
        FlState=130;   
        break;
      case 101:
      case 102:
      case 103:
      case 104:
      case 105:
      case 106:
      case 107:
      case 108:
      case 109:
      case 110:
      case 111:
      case 112:
      case 113:
      case 114:
      case 115:
      case 116:
      case 117:
      case 118:
      case 130:
        FlState--;   
        break;
      case 129:
        FlState=118;   
        break;
      case 201:   
      case 202:
      case 203:
      case 204: 
      case 205: 
      case 206: 
      case 207: 
      case 208: 
      case 209: 
      case 210: 
      case 211: 
      case 212:
      case 213:
      case 214:
      case 215:
      case 216:
      case 217:
      case 218:
      case 219: 
      case 220:
      case 221:
      case 222:
      case 223:
      case 224:
      case 225:
      case 226:
      case 227:
      case 228:
      case 229:
      case 230:
      case 231:
      case 232:
      case 233:
      case 234:
      case 235:
      case 236:
      case 237:
      case 238:
      case 239:
      case 240:
      case 241:
      case 242:
      case 243:
      case 244:
      case 245:
      case 246:
      case 247:
      case 248:
      case 249:
      case 250:
      case 251:
      case 252:
      case 253:
      case 254:
      case 255:
      case 256:
      case 257:
      case 258:
      case 259:
      case 260:
      case 261:
      case 262:
      case 263:
      case 264:
      case 265:
      case 266:
      case 267:
      case 268:
      case 269:
      case 270:
        FlState--;
        break;
      case 200:
        FlState=270;
        break;     
      case 300:
        if (nPopr>0) nPopr--;
        break;
      case 301:
        if (flPopr==1) flPopr=0;
        else
        {
          if (nPopr>0) nPopr--;
          flPopr=1;
        }
        break;
      case 302:
        if (flPopr==1) flPopr=0;
        else
        {
          if (nPopr>0) nPopr--;
          flPopr=1;
        }
        break;
      case 303:
      case 304:
      case 305:
      case 309:
      case 310:
      case 311:
      case 314:
      case 315:
        if (nPopr>0) nPopr--;
        break;
      case 312:
        if (flPopr>0) flPopr--;
        else
        {
          if (nPopr>0) nPopr--;
          flPopr=2;
        }
        break;
      case 313:
        if (flPopr>0) flPopr--;
        else
        {
          if (nPopr>0) nPopr--;
          flPopr=1;
        }
        break;
      case 316:
        if (nPopr>0) nPopr--;
        break;
      }         

      //NeedDisplaying=1;
      DisplayData();
      flNeedAnalyse=1;
      CountState=4;
      CountState=40;
      if (CountKeys==0) CountKeys=6;
    }



    if (PRESS_UP)  
    { 
      if (BeepKeyPress) my_beep(1);
      CountState=0;
      switch (FlState)
      {                                              
      case 0:
        // В сотоянии 0 обработка клавиш происходит за выходом модели этого конечного автомата.
        if (DispPage==7) // На 8 странице вручную можно состояние процесса поменять
        {
          StateMachine++;
          break;
        }
        
        if (DispPage==5) // На 6 странице можно мощность внучную привбавить
        {
          UstPower+=10;
          break;
        }
        
        if (DispPage==4) // На 6 странице можно мощность вручную изменить.
        {
          PressAtm++;
          CountKeys=1;
          break;
        }

        // Ректификация
        if (IspReg==109  || IspReg==118)
        {
          switch(StateMachine)
          {
          case 2:
            tEndRectRazgon++;
            CountKeys=1;
            break;
          case 3:
            PowerRect+=10;
            CountKeys=2;
            break;
          case 4:
            if (UrovenProvodimostSR==0) tEndRectOtbGlv++;
            else SecTempPrev+=600;
            
            
            break;
            
          case 5:
            tStabSR++;
            break;
          case 6:
            ProcChimSR++;
            break;
          case 7:
            tEndRect++;
            break;
          }
        }

        // Регулятор мощности
        if (IspReg==103)
        {
          if (SlaveON==0) 
          {
            if (DispPage==1)
            {
              // На второй странице нажатик кнопки "вверх" приводи к авто-детекции мощности ТЭНа
              flAutoDetectPowerTEN=1;
            }
            else
            {
              UstPowerReg+=10;
              flAutoDetectPowerTEN=0;
            }
          }
          if (SlaveON==2) PowerGlvDistil+=10;
          if (SlaveON==3) PowerRect+=10;
          if (SlaveON==4) PowerDistil+=10;
          
          //TekPower=(unsigned long) UstPower*220*220/ Power;
          CountKeys=1;
        }

        if (IspReg==104)
        {
          CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil++;
          else
          {
            if (DispPage==0)  Temp1P++;
                        else  PowerDistil+=10;
          }
        }
        if (IspReg==106)
        {
          CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil++;
          else
          {
            if (DispPage==0)  Temp2P++;
                         else PowerDistil+=10;
          }
        }

        if (IspReg==107)
        {
          CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil++;
          else
          {
            if (DispPage==0)  Temp3P++;
                        else  PowerDistil+=10;
          }
        }
        
        if (IspReg==117)
        {
          CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil++;
          else
          {
            if (TekFraction<CountFractionDist)
            {
              if (DispPage==0)  TempFractionDist[TekFraction]++;
                           else PowerFractionDist[TekFraction]+=10;
            }
          }
        }

        if (IspReg==105)
        {
          CountKeys=1;
          if (StateMachine==3) PowerGlvDistil+=10;
          if (StateMachine==2) TempDeflBegDistil++;
        }

        if (IspReg==114)
        {
          TempHLDZatorBrog1++;
        }
        
        if (IspReg==129)
        {
          CloseAllKLP();
          ProcChimSR++;
        }
        
        if (IspReg==115)
        { CountKeys=2;
          if (DispPage==0) timerMinute+=AddPressKeys;
                     else  PowerMinute+=AddPressKeys10;
        }
        
        if (IspReg==116)
        {
          if (DispPage==0 && StateMachine==3 && timeP[KlTek]==0) timeP[KlTek]=255; 
          else
          {
            // На второй странице можно включить насос.
            if (DispPage==1) 
            {
              time1=0;
              KlOpen[KLP_HLD]=0;
            }
          }
        }

        if (IspReg==108 || IspReg==113)
        {   CountKeys=1;
            switch (StateMachine)
            { 
              case 0: //Не запущено
                time1=((int) tempP[0]+ (int) timeP[0])*60; // Взводим насос на десять минут работы
                timeMIXER=(int) tempP[0] *60;        
              break;
              case 1: //Нагрев до температуры 50 градусов
              if (DispPage==0) TempZSP++;
              else 
              {
                time1=((int) tempP[0]+ (int) timeP[0])*60; // Взводим насос на десять минут работы
                timeMIXER=(int) tempP[0] *60;        
              }
              break;
              case 3: //Нагрев до температуры 62 градуса
                TempZSPSld++;
                break;
              case 4: //Ожидание 15 минут, поддержка температуры
                time2+=60;
              case 2: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
              case 8: //ожидание засыпки солода, поддержка температуры
              // На этих этапах нажатие кнопки вверх включает мешалку, вниз - отключает.
              time1=((int) tempP[0]+ (int) timeP[0])*60; // Взводим насос на десять минут работы
              timeMIXER=(int) tempP[0] *60;        
              break;
              
              case 6: //Варка
              case 9: //Размешивание после засыпания солшода
              case 10: // Осахаривание
                if (DispPage==0) time2+=60;
                            else TempZSPSld++;
                break;
              case 5: //  Нагрев до закипания
                TempKipenZator++;
                break;
              case 7: //охлаждение до температуры осахаривания.
                TempZSPSld++;
                break;
              case 12: //охлаждение до температуры осахаривания.
                TempHLDZatorBrog1++;
                break;
              case 14: //охлаждение до температуры осахаривания.
              case 13: //охлаждение до температуры осахаривания.
                if (DispPage==0) TempHLDZatorBrog1++;
                else 
                {
                  time1=((int) tempP[0]+ (int) timeP[0])*60; // Взводим насос на десять минут работы
                  timeMIXER=(int) tempP[0] *60;        
                }
                break;
              case 100: //Окончание
                break;
            }
        }

        if (IspReg==110)
        { CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil++;
          else
            if (DispPage==0) TempDefl++;
                        else deltaPower+=10; 
        }

        // НДРФ
        if (IspReg==111)
        { CountKeys=2;
          switch(StateMachine)
          {
          case 2:
            tEndRectRazgon++;
            CountKeys=1;
            break;
          case 3:
            if (DispPage==0) SecOstatok+=60;
                      else PowerRect+=10;
            CountKeys=3;
            break;
          case 4:
            tEndRectOtbGlv++;
            break;
          case 5:
            tStabSR++;
            break;
          case 6:
            ProcChimSR++;
            break;
          case 7:
            tEndRect++;
            break;
          }
        }
        // NBK
        if (IspReg==112)
        { CountKeys=1;
          if (DispPage==0)
          {
             if (StateMachine==3) StateMachine=4;
           else
            {
              if (StateMachine==5) time2+=60;
              else
              {
                SpeedNBKDst+=1;
                SpeedNBK=SpeedNBKDst;
                CountKeys=1;
              }
            }
          }
          else
          {
            PowerNBK+=AddPressKeys10;
            UstPower=PowerNBK;
          }
        }
        if (IspReg==130) { Angle+=5; SetAngle(Angle);}
        
        break; 
      case 200:
        TempTerm+=AddPressKeys;
        CountKeys=2;
        break;
      case 201:
        Power+=AddPressKeys10;
        PowerPhase[0]=Power;
        CountKeys=3;
        break;
      case 202:
        UstPowerReg+=AddPressKeys10;
        CountKeys=3;
        break;
      case 203:
        FlToUSART=1;
        break;
      case 204:  
      
        if (FlToGSM<20) FlToGSM++;
        // Переинициализируем сотовый
        break;                     
      case 205:   
        Delta++;
        CountKeys=3;
        break;                     
      case 206:   
        Temp1P+=AddPressKeys;
        CountKeys=2;
        break;                     
      case 207:   
        Temp2P+=AddPressKeys;
        CountKeys=2;
        break;                     
      case 208:   
        Temp3P+=AddPressKeys;
        CountKeys=2;
        break;                     
      case 209:   
        tEndRectRazgon+=AddPressKeys;
        CountKeys=3;
        break;                     
      case 210:   
        PowerRect+=AddPressKeys10;
        CountKeys=3;
        break;                     
      case 212:
        tEndRectOtbGlv++;
        CountKeys=3;
        break;                     
      case 213:
        timeChimRectOtbGlv+=AddPressKeys10;
        CountKeys=3;
        break;
      case 214:
        ProcChimOtbGlv++;
        CountKeys=4;
        break;
      case 250:
        minProcChimOtbSR++;
        CountKeys=4;
        break;
      case 251:
        tStabSR++;
        CountKeys=3;
        break;
      case 252:
        begProcChimOtbSR++;
        CountKeys=4;
        break;
      case 253:
        P_MPX5010++;
        CountKeys=4;
        break;
      case 254:
        PowerNBK+=AddPressKeys10;
        CountKeys=3;
        break;
      case 215:
        timeChimRectOtbSR+=AddPressKeys10;
        CountKeys=3;
        break;
      case 216:
        tDeltaRect++;
        CountKeys=4;
        break;
      case 217:
        tEndRectOtbSR++;
        CountKeys=3;
        break;
      case 218:
        tEndRect++;
        CountKeys=3;
        break;
      case 219:
        PowerGlvDistil+=AddPressKeys10;
        CountKeys=3;
        break;
      case 220:
        PowerDistil+=AddPressKeys10;
        CountKeys=3;
        break;
      case 221:
        TempDeflBegDistil+=AddPressKeys;
        CountKeys=3;
        break;
      case 222:
        TempDefl++;
        CountKeys=3;
        break;
      case 223:
        DeltaDefl++;
        CountKeys=3;
        break;
      case 224:
        tEndDistDefl++;
        CountKeys=3;
        break;
      case 225:
        BeepEndProcess=1;
        break;
      case 226:
        BeepStateProcess++;
        CountKeys=5;
        break;
      case 227:
        BeepKeyPress=1;
        break;
      case 228:
        PowerRazvZerno+=AddPressKeys10;
        CountKeys=3;
        break;
      case 229:
        PowerVarkaZerno+=AddPressKeys10;
        CountKeys=3;
        break;
      case 230:
        PeriodRefrServer+=5;
        CountKeys=3;
        break;
      case 231:
        NaprPeregrev+=5;
        CountKeys=3;
        break;
      case 232:
        UrovenBarda+=5;
        CountKeys=3;
        break;
      case 233:
        UrovenProvodimostSR++;
        CountKeys=3;
        break;
      case 234:
        TimeStabKolonna+=60;
        CountKeys=3;
        break;
      case 235:
        CntCHIM++;
        CountKeys=3;
        break;
      case 236:
        DecrementCHIM++;
        CountKeys=3;
        break;
      case 237:
        IncrementCHIM++;
        CountKeys=3;
        break;
      case 238:
        TimeAutoIncCHIM+=60;
        CountKeys=3;
        break;
      case 239:
        TimeRestabKolonna+=60;
        CountKeys=3;
        break;
      case 240:
        if (CntPause<MAX_CNT_PAUSE-1) CntPause++;
        CountKeys=3;
        break;
      case 241:
        CorrectASC712++;
        CountKeys=3;
        break;
      case 243:
        ipPort+=AddPressKeys;
        CountKeys=2;
        break;
      case 246:
        AlarmMPX5010+=AddPressKeys;
        CountKeys=2;
        break;
      case 247:
        FlAvtonom++;
        CountKeys=5;
        break;
      case 248:
        timeOpenBRD++;
        CountKeys=2;
        break;
      case 249:
        PIDTemp[0]+=AddPressKeys;
        CountKeys=2;
        break;
      case 257:
        if (CountFractionDist<MAX_CNT_FRACTION_DIST) CountFractionDist++;
        CountKeys=3;
        break;
      case 258:
        if (CountFractionRect<MAX_CNT_FRACTION_RECT) CountFractionRect++;
        CountKeys=3;
        break;
      case 259:
        TempZSP++;
        CountKeys=3;
        break;
      case 260:
        TempZSPSld++;
        CountKeys=3;
        break;
      case 261:
        TempHLDZatorBrog1++;
        CountKeys=3;
        break;
      case 262:
        Power+=AddPressKeys10;
        CountKeys=3;
        break;
      case 264:
        minPressNBK++;
        CountKeys=1;
        break;
      case 265:
        deltaPressNBK++;
        CountKeys=1;
        break;
      case 266:
        timePressNBK++;
        CountKeys=1;
        break;
      case 267:
        UprNasosNBK++;
        CountKeys=3;
        break;
      case 268:
        ProcChimOtbCP++;
        CountKeys=1;
        break;
      case 270:
        if (timePressAtm<250) timePressAtm+=5;
                        else timePressAtm=250;
        CountKeys=2;
        break;
        
      case 300:   
        ds1820_popr[nPopr]++;
        CountState=8; // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.                
        CountKeys=4;
        break;                     
      case 301:   
        if (flPopr==0) {  tempK[nPopr]+=AddPressKeys;
                          CountKeys=1;
                       }
                  else CHIM[nPopr]++;
        break;                     
      case 302:
        if (flPopr==0) tempP[nPopr]++;
                  else 
                  { timeP[nPopr]++;
                    if (timeP[nPopr]==255) timeP[nPopr]=0;
                  }
        CountKeys=1;
        break;                     
      case 303:
        ip[nPopr]++;
        CountKeys=1;
        break;                     
      case 304:
        idDevice[nPopr]++;
        CountKeys=1;
        break;                     
      case 305:
        my_phone[nPopr]++;
        CountKeys=1;
        break;                     
      case 309:
        PIDTemp[nPopr]+=AddPressKeys;
        CountKeys=2;
        break;                     
      case 310:
        WiFiAP[nPopr]++;
        CountKeys=1;
        break;                     
      case 311:
        WiFiPass[nPopr]++;
        CountKeys=1;
        break;                     
      case 312:
        if (nPopr==MAX_CNT_FRACTION_DIST)
        {

          if (TekFraction<MAX_CNT_FRACTION_DIST-1)
          {
              TekFraction++;
              SecTempPrev=Seconds;
              SetAngle(AngleFractionDist[TekFraction]);
          }
          CountKeys=3;
          
        }
        else
        {      
          CountKeys=2;
          if (flPopr==0) TempFractionDist[nPopr]+=AddPressKeys;
          if (flPopr==2) PowerFractionDist[nPopr]+=AddPressKeys10;
          if (flPopr==1) { AngleFractionDist[nPopr]++;  CountKeys=1;}
        }
        break;
      case 313:   
        if (nPopr==MAX_CNT_FRACTION_RECT)
        {

          if (TekFraction<MAX_CNT_FRACTION_RECT-1)
          {
              TekFraction++;
              SecTempPrev1=Seconds;
              SetAngle(AngleFractionRect[TekFraction]);
          }
          CountKeys=3;
        }
        else
        {      
          CountKeys=2;
          if (flPopr==0) TempFractionRect[nPopr]+=AddPressKeys;
          if (flPopr==1) { AngleFractionRect[nPopr]++;  CountKeys=1;}
        }
        break;
      case 314:
        PowerPhase[nPopr]+=AddPressKeys10;
        CountKeys=2;
        break;                     
      case 315:
        KtPhase[nPopr]+=AddPressKeys;
        CountKeys=2;
        break;                     
      case 316:
        if (ds1820_nums[nPopr]<4) ds1820_nums[nPopr]++;
        CountKeys=4;
        break;                     
        
      }         

      //NeedDisplaying=1;
      DisplayData();
      flNeedAnalyse=1;
      if (CountState==0) CountState=4;
      if (CountKeys==0) CountKeys=6;
      CountState=40;
    }


    if (PRESS_DOWN)  
    { 
      if (BeepKeyPress) my_beep(1);
      CountState=0;
      switch (FlState)
      {                                              
      case 0:

        // В сотоянии 0 обработка клавиш происходит за выходом модели этого конечного автомата.
        if (DispPage==2) // На третьей странице сбрасываем датчик потока
        {
          break;
        }
        
        if (DispPage==7) // На 8 странице можно состояние процесс поменять.
        {
          StateMachine--;
          break;
        }
        
        if (DispPage==5) // На 6 странице можно мощность вручную изменить.
        {
          UstPower-=10;
          break;
        }
        if (DispPage==4) // На 6 странице можно мощность вручную изменить.
        {
          PressAtm--;
          CountKeys=1;
          break;
        }

        // Ректификация
        if (IspReg==109  || IspReg==118)
        {
          switch(StateMachine)
          {
          case 2:
            tEndRectRazgon--;
            CountKeys=1;
            break;
          case 3:
            PowerRect-=10;
            CountKeys=3;
            break;
          case 4:
            if (UrovenProvodimostSR==0) tEndRectOtbGlv--;
            else SecTempPrev-=600;
            break;
          case 5:
            tStabSR--;
            break;
          case 6:
            ProcChimSR--;
            break;
          case 7:
            tEndRect--;
            break;
          }
        }

        // Регулятор мощности
        if (IspReg==103)
        {
          if (SlaveON==0) UstPowerReg-=10;
          if (SlaveON==2) PowerGlvDistil-=10;
          if (SlaveON==3) PowerRect-=10;
          if (SlaveON==4) PowerDistil-=10;
          
          //TekPower=(unsigned long) UstPower*220*220/ Power;
          CountKeys=1;
        }
        if (IspReg==104)
        {
          CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil--;
          else
            if (DispPage==0)  Temp1P--;
                        else  PowerDistil-=10;
        }
        if (IspReg==106)
        {
          CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil--;
          else
            if (DispPage==0)  Temp2P--;
                        else  PowerDistil-=10;
        }

        if (IspReg==107)
        {
          CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil--;
          else
            if (DispPage==0)  Temp3P--;
                        else  PowerDistil-=10;
        }
        
        if (IspReg==117)
        { CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil--;
          else
          {
            if (TekFraction<CountFractionDist)
            {
              if (DispPage==0)  TempFractionDist[TekFraction]--;
                           else PowerFractionDist[TekFraction]-=10;
            }
          }
        }

        if (IspReg==105)
        {
          CountKeys=1;
          if (StateMachine==3) PowerGlvDistil-=10;
          if (StateMachine==2) TempDeflBegDistil--;
        }
        
        if (IspReg==114)
        { CountKeys=1;
          TempHLDZatorBrog1--;
        }
        
        if (IspReg==129)
        {
          CloseAllKLP();
          ProcChimSR--;
        }

        if (IspReg==115)
        { CountKeys=2;
          if (DispPage==0) timerMinute-=AddPressKeys;
                     else  PowerMinute-=AddPressKeys10;
        }
        if (IspReg==108 || IspReg==113)
        {  CountKeys=1;
            switch (StateMachine)
            { 
              case 0: //Не запущено
              timeMIXER=0;  
              time1=0;
              break;      
              case 1: //Нагрев до температуры 50 градусов
              if (DispPage==0) TempZSP--;
                       else timeMIXER=0;        
              break;
              case 2: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
              // Переход к следующему этапу
              StateMachine=3;
              CountKeys=3;
              break;
              case 3: //Нагрев до температуры 62 градуса
                TempZSPSld--;
                break;
              case 4: //Ожидание 15 минут, поддержка температуры
                 time2-=60;
              // На этих этапах нажатие кнопки вверх включает мешалку, вниз - отключает.
              timeMIXER=0;        
              break;
              
              case 6: //Варка
              case 9: //Размешивание после засыпания солшода
              case 10: // Осахаривание
                if (DispPage==0) 
                { if (time2>=65) time2-=60;
                            else time2=0;

                }
                         else TempZSPSld--;
              
                break;
              case 5: 
                TempKipenZator--;
                break;
              case 12: //охлаждение до температуры осахаривания.
                TempHLDZatorBrog1--;
                break;
              case 14: //охлаждение до температуры осахаривания.
              case 13: //охлаждение до температуры осахаривания.
                if (DispPage==0) TempHLDZatorBrog1--;
                else 
                {
                  timeMIXER=0;        
                }
                break;
                
              case 8:
                   // Нажатие кнопки вниз переводит на следующий этап 
                   StateMachine=9;
                   CountKeys=6;
                break;
              case 7: //охлаждение до температуры осахаривания.
                TempZSPSld--;
                break;
              case 100: //Окончание
                break;
            }
        }

        if (IspReg==110)
        { CountKeys=1;
          if (StateMachine==2) 
            TempDeflBegDistil--;
          else
            if (DispPage==0) TempDefl--;
                        else deltaPower-=10; 
            
        }

        // НДРФ
        if (IspReg==111)
        { CountKeys=2;
          switch(StateMachine)
          {  
          case 2:
            tEndRectRazgon--;
            CountKeys=1;
            break;
          case 3:
           
            if (DispPage==0) SecOstatok-=60;
                      else PowerRect-=10;
            CountKeys=3;
            break;
          case 4:
            tEndRectOtbGlv--;
            break;
          case 5:
            tStabSR--;
            break;
          case 6:
            ProcChimSR--;
            break;
          case 7:
            tEndRect--;
            break;
          }
        }
        // NBK
        if (IspReg==112)
        {  CountKeys=1;
          if (DispPage==0)
          {
              if (StateMachine==5) time2-=60;
              else
              {
                SpeedNBKDst-=1;
                SpeedNBK=SpeedNBKDst;
              }
          }
          else
          {
            PowerNBK-=AddPressKeys10;
            UstPower=PowerNBK;
           
          }
        }
        
        if (IspReg==116)
        {
            // На второй странице можно выключить насос.
            if (DispPage==1) 
            {
              time1=0;
              KlOpen[KLP_HLD]=40;
            }
        }

         if (IspReg==130) { Angle-=5; SetAngle(Angle);}      

        break; 
      case 200:
        TempTerm-=AddPressKeys;
        CountKeys=2;
        break;
      case 201:
        Power-=AddPressKeys10;
        PowerPhase[0]=Power;
        CountKeys=3;
        break;
      case 202:
        UstPowerReg-=AddPressKeys10;
        CountKeys=3;
        break;
      case 203:
        FlToUSART=0;
        break;
      case 204:   
        if (FlToGSM>0) FlToGSM--;
        break;                     
      case 205:   
        Delta--;
        CountKeys=3;
        break;                     
      case 206:   
        Temp1P-=AddPressKeys;
        CountKeys=2;
        break;                     
      case 207:   
        Temp2P-=AddPressKeys;
        CountKeys=2;
        break;                     
      case 208:   
        Temp3P-=AddPressKeys;
        CountKeys=2;
        break;                     
      case 209:   
        tEndRectRazgon-=AddPressKeys;
        CountKeys=3;
        break;                     
      case 210:   
        PowerRect-=AddPressKeys10;
        CountKeys=3;
        break;                     
      case 212:
        tEndRectOtbGlv--;
        CountKeys=3;
        break;                     
      case 213:
        timeChimRectOtbGlv-=AddPressKeys10;
        CountKeys=3;
        break;
      case 214:
        ProcChimOtbGlv--;
        CountKeys=4;
        break;
      case 250:
        minProcChimOtbSR--;
        CountKeys=4;
        break;
      case 251:
        tStabSR--;
        CountKeys=3;
        break;
      case 252:
        begProcChimOtbSR--;
        CountKeys=4;
        break;
      case 253:
        P_MPX5010--;
        CountKeys=4;
        break;
      case 254:
        PowerNBK-=AddPressKeys10;
        CountKeys=3;
        break;
      case 215:
        timeChimRectOtbSR-=AddPressKeys10;
        CountKeys=3;
        break;
      case 216:
        tDeltaRect--;
        CountKeys=4;
        break;
      case 217:
        tEndRectOtbSR--;
        CountKeys=3;
        break;
      case 218:
        tEndRect--;
        CountKeys=3;
        break;
      case 219:
        PowerGlvDistil-=AddPressKeys10;
        CountKeys=3;
        break;
      case 220:
        PowerDistil-=AddPressKeys10;
        CountKeys=3;
        break;
      case 221:
        TempDeflBegDistil-=AddPressKeys;
        CountKeys=3;
        break;
      case 222:
        TempDefl--;
        CountKeys=3;
        break;
      case 223:
        DeltaDefl--;
        CountKeys=3;
        break;
      case 224:
        tEndDistDefl--;
        CountKeys=3;
        break;
      case 225:
        BeepEndProcess=0;
        break;
      case 226:
        BeepStateProcess=0;
        break;
      case 227:
        BeepKeyPress=0;
        break;
      case 228:
        PowerRazvZerno-=AddPressKeys10;
        CountKeys=3;
        break;
      case 229:
        if (PowerVarkaZerno>10) PowerVarkaZerno-=AddPressKeys10;
        else PowerVarkaZerno=0;

        CountKeys=3;
        break;
      case 230:
        PeriodRefrServer-=5;
        CountKeys=3;
        break;
      case 231:
        NaprPeregrev-=5;
        CountKeys=3;
        break;
      case 232:
        UrovenBarda-=5;
        CountKeys=3;
        break;
      case 233:
        UrovenProvodimostSR--;
        CountKeys=3;
        break;
      case 234:
        TimeStabKolonna-=60;
        CountKeys=3;
        break;
      case 235:
        CntCHIM--;
        CountKeys=3;
        break;
      case 236:
        DecrementCHIM--;
        CountKeys=3;
        break;
      case 237:
        IncrementCHIM--;
        CountKeys=3;
        break;
      case 238:
        TimeAutoIncCHIM-=60;
        CountKeys=3;
        break;
      case 239:
        TimeRestabKolonna-=60;
        CountKeys=3;
        break;
      case 240:
        if (CntPause>=0) CntPause--;
        CountKeys=3;
        break;
      case 241:
        CorrectASC712--;
        CountKeys=3;
        break;
      case 243:
        ipPort-=AddPressKeys;
        CountKeys=2;
        break;
      case 246:
        AlarmMPX5010-=AddPressKeys;
        CountKeys=2;
        break;
      case 247:
        FlAvtonom--;
        if (FlAvtonom<0) FlAvtonom=0;
        CountKeys=5;
        break;
      case 248:
        timeOpenBRD--;
        CountKeys=2;
        break;
      case 249:
        PIDTemp[0]-=AddPressKeys;
        CountKeys=2;
        break;
     case 257:
        if (CountFractionDist>=0) CountFractionDist--;
        CountKeys=3;
        break;
      case 258:
        if (CountFractionRect>=0) CountFractionRect--;
        CountKeys=3;
        break;        
      case 259:
        TempZSP--;
        CountKeys=3;
        break;
      case 260:
        TempZSPSld--;
        CountKeys=3;
        break;
      case 261:
        TempHLDZatorBrog1--;
        CountKeys=3;
        break;
      case 262:
        Power-=AddPressKeys10;
        CountKeys=3;
        break;
      case 264:
        minPressNBK--;
        CountKeys=1;
        break;
      case 265:
        deltaPressNBK--;
        CountKeys=1;
        break;
      case 266:
        timePressNBK--;
        CountKeys=1;
        break;
      case 267:
        UprNasosNBK--;
        CountKeys=3;
        break;
      case 268:
        ProcChimOtbCP--;
        CountKeys=1;
        break;
        
      case 270:
        if (timePressAtm>5) timePressAtm-=5;
                        else timePressAtm=0;
        CountKeys=2;
        break;
        
       case 300: 
        ds1820_popr[nPopr]--;
        CountState=8; // При вводе поправок сохраняем состояние 4 секунды, а не две, тут спешка не нужна.                
        CountKeys=4;
        break;      
      case 301:   
        if (flPopr==0) { tempK[nPopr]-=AddPressKeys;CountKeys=1; }
                  else CHIM[nPopr]--;
        break;               
      case 302:
        if (flPopr==0) tempP[nPopr]--;
                  else 
                  { timeP[nPopr]--;
                    if (timeP[nPopr]==255) timeP[nPopr]=254;
                  }
        CountKeys=1;
        break;                     
      case 303:
        ip[nPopr]--;
        CountKeys=1;
        break;                     
      case 304:
        idDevice[nPopr]--;
        CountKeys=1;
        break;                     
      case 305:
        my_phone[nPopr]--;
        CountKeys=1;
        break;                     
      case 309:
        PIDTemp[nPopr]-=AddPressKeys;
        CountKeys=2;
        break;                     
      case 310:
        WiFiAP[nPopr]--;
        CountKeys=1;
        break;                     
      case 311:
        WiFiPass[nPopr]--;
        CountKeys=1;
        break;                     
      case 312:   
        if (nPopr==MAX_CNT_FRACTION_DIST)
        {

          if (TekFraction>0)
          {
              TekFraction--;
              SecTempPrev=Seconds;
              SetAngle(AngleFractionDist[TekFraction]);
          }
          CountKeys=3;
          
        }
        else
        {
          CountKeys=2;
          if (flPopr==0) TempFractionDist[nPopr]-=AddPressKeys;
          if (flPopr==2) PowerFractionDist[nPopr]-=AddPressKeys10;
          if (flPopr==1) { AngleFractionDist[nPopr]--;  CountKeys=1;}
        }
        break;
      case 313:   
      if (nPopr==MAX_CNT_FRACTION_RECT)
        {

          if (TekFraction>0)
          {
              TekFraction--;
              SecTempPrev1=Seconds;
              SetAngle(AngleFractionRect[TekFraction]);
          }
          CountKeys=3;
        }
       else
       {
        CountKeys=2;
        if (flPopr==0) TempFractionRect[nPopr]-=AddPressKeys;
        if (flPopr==1) { AngleFractionRect[nPopr]--;  CountKeys=1;}
       }
       break;
      case 314:
        PowerPhase[nPopr]-=AddPressKeys10;
        CountKeys=2;
        break;                     
      case 315:
        KtPhase[nPopr]-=AddPressKeys;
        CountKeys=2;
        break;                     
      case 316:
        if (ds1820_nums[nPopr]>0) ds1820_nums[nPopr]--;
        CountKeys=4;
        break;                     
        
      }         

      //NeedDisplaying=1;
      DisplayData();
      flNeedAnalyse=1;
      if (CountState==0) CountState=4;
      if (CountKeys==0) CountKeys=6;
      CountState=40;
    }
    flNeedScanKbd=0;
    flScanKbd=0; // Убираем признак того, что сканируется клавиатура.
  }
}




void CloseAllKLP()
{ 
  char i;
  // Все клапана зануляем.
  for(i=0;i<MAX_KLP;i++)
  {
    KlOpen[i]=0;    
    KlClose[i]=10;   
    KlState[i]=0;          // Начальное состояние - клапан закрыт, счетчик 0
    KlCount[i]=0;  
    KlReg[i]=PEREGREV_ON;
  }
  // Если автономная система охлаждения, то у клапана дефлегматора отключаем защиту от перегрева.
  if (FlAvtonom&B00000001)
  {
    KlReg[KLP_DEFL]=0; // Клапан дефлегматора и клапан холодильника отключим от системы защиты от перегрева если используется автономка.
    KlReg[KLP_HLD]=0;
  }
  
}

void PrepareProcess()
{ 
  char i;
  // Максимальную температуру процессов зануляем.
  for(i=0;i<MAX_DS1820;i++)
  {
    Maxtemps[i]=0;
  }
  // Все таймеры зануляем.
  timeMIXER=0;
  timeNBK=0;
  time1=0;
  time2=0;
  time3=0;
  flAutoDetectPowerTEN=0;// Убираем признак авто-детектирования ТЭНОв
  flNoAlarmLowPower=0;   // Убираем признак невыдачи предупреждения о низком уровне напряжения
  // Все клапана зануляем.
  CloseAllKLP();
  //  Разгон отключаем
  digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
}


void ProcessTermostat()
{
  
  if (ds1820_devices==0) StateMachine=100;
  
  switch  (StateMachine)
  {
  case 0: // Температура Больше необходиомй
    // Процесс не запущен Процесс термостат заппускается автоматически, чтобы он работал даже если выключат и включат свет.
    //break;
  case 1: // Старт процесса
    digitalWrite(PIN_TERMOSTAT_OFF,LOW);// Включаем охлаждение
    digitalWrite(PIN_TERMOSTAT_ON,LOW);// Выключаем нагрев
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    
    StateMachine=2;
  case 2: // Температура Больше необходиомй
    if (temps[TEMP_TERMOSTAT]<=TempTerm)
    {
      digitalWrite(PIN_TERMOSTAT_OFF,LOW);// Включаем охлаждение
      digitalWrite(PIN_TERMOSTAT_ON,HIGH);// Выключаем нагрев
      digitalWrite(PIN_START_1,RELAY_HIGH);
      digitalWrite(PIN_START_2,RELAY_HIGH);
      ProcessPIDTemp(TempTerm,temps[TEMP_TERMOSTAT]);
      UstPower=(long)Power*KtT/1000;
    // Мощность ограничена мощностью варки зерна
    if (UstPower>PowerVarkaZerno) UstPower=PowerVarkaZerno;

      break;
    }
    StateMachine=3;
    if (BeepStateProcess) my_beep(BEEP_LONG);
    
  case 3: //
    UstPower=0; // Убираем мощность с ТЭНов
    if (temps[TEMP_TERMOSTAT]>TempTerm-Delta)
    {
      digitalWrite(PIN_TERMOSTAT_ON,LOW);// Выключаем нагрев
      digitalWrite(PIN_TERMOSTAT_OFF,HIGH);// Включаем охлаждение
      digitalWrite(PIN_START_1,!RELAY_HIGH);
      digitalWrite(PIN_START_2,!RELAY_HIGH);
      
      break;
    }
    StateMachine=2;
    if (BeepStateProcess) my_beep(BEEP_LONG);
    break;
  case 100:// Конечное состояние автомата
    digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
    flAllOff=1;
    digitalWrite(PIN_TERMOSTAT_ON,LOW);// Выключаем нагрев
    digitalWrite(PIN_TERMOSTAT_OFF,LOW);// Включаем охлаждение
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    UstPower=0; // Убираем мощность с ТЭНов
    break;
  }
}

void ProcessTimerMaxPower()
{
  int minute;
  switch  (StateMachine)
  {
  case 0: // 
    // Процесс не запущен
    break;
  case 1: // Старт процесса
    timerMinute=0;
    StateMachine=2;
    lastSMSState=0;
  case 2: // Температура Больше необходиомй
    minute = Seconds / 60;
    if (minute<=timerMinute)
    {
      UstPower=PowerMinute; // Подаем полную мощность на ТЭНЫ
      digitalWrite(PIN_START_1,RELAY_HIGH);
      digitalWrite(PIN_START_2,RELAY_HIGH);
      break;
    }
    StateMachine=100;
    if (BeepStateProcess) my_beep(BEEP_LONG);
  case 100:// Конечное состояние автомата
    if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
    if (BeepEndProcess) my_beep(BEEP_LONG);
    digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
    digitalWrite(PIN_START_1,!RELAY_HIGH);
    digitalWrite(PIN_START_2,!RELAY_HIGH);
    
    flAllOff=1;
    UstPower=0; // Убираем мощность с ТЭНов
    break;
  }
}

// Процедура осуществляет ПИД регулирование температуры.
// В качестве результата возвращается коэффициент мощности, умноженный на 1000, то есть
// 1000 - это 100% подача мощности на ТЭНы.
void ProcessPIDTemp(int NeedTemp, int FactTemp)
{   
    NewErrTemp=(NeedTemp-FactTemp);
    DtTemp=NewErrTemp-OldErrTemp;
    ItTemp=ItTemp+NewErrTemp;
    
    if (ItTemp<-1000) ItTemp=-1000;
      else 
        if (ItTemp>1000) ItTemp=1000;
        
    
    OldErrTempOut=OldErrTemp; // Запоминаем старую ошибку.
    OldErrTemp=NewErrTemp; // Запоминаем старую ошибку.
    // Считаем коэффициент температуры
    KtT=((long)PIDTemp[0]*NewErrTemp*8 + (long)PIDTemp[1]*ItTemp/10+(long)PIDTemp[2]*DtTemp*10)/10;
    #ifdef TEST
      Serial.print("Ktt:");
      Serial.println(KtT);
    #endif
    if (KtT>1000) KtT=1000;
    if (KtT<0) KtT=0;
    // Если значение температуры превысило нужную, то сбрасываем интегральный коэффицциент
    // и убираем мощность.
    if (FactTemp>=NeedTemp) {ItTemp=0 ;KtT=0;}
    
}

void ProcessPIDPress(int NeedTemp, int FactTemp)
{   
    NewErrTemp=(NeedTemp-FactTemp);
    DtTemp=NewErrTemp-OldErrTemp;
    ItTemp=ItTemp+NewErrTemp;
    
    if (ItTemp<-1000) ItTemp=-1000;
      else 
        if (ItTemp>1000) ItTemp=1000;
        
    
    OldErrTempOut=OldErrTemp; // Запоминаем старую ошибку.
    OldErrTemp=NewErrTemp; // Запоминаем старую ошибку.
    // Считаем коэффициент температуры
    KtT=((long)PIDTemp[0]*NewErrTemp*8 + (long)PIDTemp[1]*ItTemp/10+(long)PIDTemp[2]*DtTemp*10)/10;
    #ifdef TEST
      Serial.print("Ktt:");
      Serial.println(KtT);
    #endif
    if (KtT>1000) KtT=1000;
    if (KtT<0) KtT=0;
    // Если значение температуры превысило нужную, то сбрасываем интегральный коэффицциент
    // и убираем мощность.
       
}



//#define MSerial1 Serial2

void GetPhonePDU()
{
  unsigned char i;
  for(i=1;i<=9;i+=2)
  {
    pdu_phone[i-1]=my_phone[i+1];
    pdu_phone[i]=my_phone[i];
  }
  pdu_phone[10]='F';
  pdu_phone[11]=my_phone[11];
  pdu_phone[12]=0;
}


void GetState()
{
  int tic1;
  unsigned char hour,minute;
  hour=Seconds / 3600;
  tic1=Seconds % 3600;
  minute=tic1 / 60;
  sprintf(my_tx_buffer,"%02u:%02u I=%3u S=%3u T=%3u,%3u,%3u V=%4u,%4u OFF=%1i,%4uW,U=%3u,%3imm",hour,minute,IspReg, StateMachine,temps[0],temps[1],temps[2],U_VODA,U_UROVEN, (int) flAllOff,UstPower,MaxVoltsOut,U_MPX5010);

}

void GetStateSerial()
{
  sprintf(my_tx_buffer,"%lu\tT=\t%3u\t%3u\t%3u\tGlv=%4u\tI=%3u\tS=%3u\t%4uW\tOFF=%1i\t%3imm\t%3uV",Seconds,temps[0],temps[1],temps[2],U_GLV,IspReg,StateMachine,UstPower,(int) flAllOff,U_MPX5010,MaxVoltsOut);
  Serial.println(my_tx_buffer);
}

void GetStateSerialErr()
{
  sprintf(my_tx_buffer,"Err ds18b20 CntDs=%3u NumDs=%3u",CntErrDs18,NumErrDs18);
  Serial.println(my_tx_buffer);
}


void StateToSMS()
{
  

#ifndef TESTERR
  if (FlToGSM<2 || SMSOnCall==1)  
  { if (flGPRSState!=98) flGPRSState=70;
    timeGPRS=15;
//    toUSARTPDU(my_tx_buffer);
    lastSMSState=StateMachine;
  }
  else
  {
    // Активизируем разовую отправку состояния на сервер
    if (FlToGSM>1 && !SMSOnCall && timeGPRS==0 && flGPRSState==0)
      {
        flGPRSState=2; // Активируем сессию GPRS
        flNeedRefrServer=1;
        timeGPRS=60;
        lastSMSState=StateMachine;
      }
  }
  
#else
  Serial.print("SMS: ");
  Serial.println(my_tx_buffer);
#endif

  // Запоминаем последнее переданное состояние на сотовый.

}

#ifdef DEBUG
void my_debug()
{
  char s_rx;
  char *st1;
  char *stb;
  int val1;
  static char NoScan=0;
  if (!NoScan)
  {
  while (Serial.available() > 0) 
  {  //если есть доступные данные
    // считываем байт
    s_rx=Serial.read();
    delay(10);
    if (s_rx==10)
    {
      my_rx_buffer[pos_rx_buffer-1]=0;
      NoScan=1;
      pos_rx_buffer=0;
      // передаем данные в следующем формате:
      // сколькоприбавитьсекунд,Темпереатура1,Температура2, Температура3
      Serial.print("dbl:");
      Serial.println(my_rx_buffer);
      stb=my_rx_buffer;
      st1=strchr(stb,',');
      if (st1)
      {
        st1[0]=0;
        //      Serial.println(stb);
        val1=atoi(stb);
        Seconds=Seconds+val1;
        timeNBK-=val1;   // Время работы насоса НБК в секундах со скоростью SpeedNKB. По истечении этого времени насос остановится
        timeMIXER-=val1; // Время работы двигателя миксера в секундах. По истечении этого времени насос остановится
        time1-=val1;   // Таймер для отсчета секунд 1
        time2-=val1;   // Таймер для отсчета секунд 2
        time3-=val1;   // Таймер для отсчета секунд 3
        
        stb=st1+1;
      }
      st1=strchr(stb,',');
      if (st1)
      {
        st1[0]=0;
        //      Serial.println(stb);
        val1=atoi(stb);
        temps[0]=val1;
        stb=st1+1;
      }
      st1=strchr(stb,',');
      if (st1)
      {
        st1[0]=0;
        //       Serial.println(stb);
        val1=atoi(stb);
        temps[1]=val1;
        stb=st1+1;
      }
      //      Serial.println(stb);
      val1=atoi(stb);
      temps[2]=val1;
      flNeedAnalyse=1;
      NoScan=0;
    }
    else
    {
      if (pos_rx_buffer>=MY_RX_BUFFER_SIZE) pos_rx_buffer=0;
      my_rx_buffer[pos_rx_buffer]=s_rx;
      pos_rx_buffer++;
    }
  }
  }
  // Окончание анализа отладки
}
#endif

static unsigned int SecondsRing;
static char *vid_sms;   // Вид СМС - память или Сим-карта
static char num_sms[10];// Номер СМС.
static char flSMS=0; // Признак того, что приходила SMS и она еще не удалена.
static char fAnGSM=0; // Состояние анализа входящего звонка

// Установка угла на серве с помощью delay
void SetAngle(unsigned char Angl)
{
  int TAngl;
  unsigned char i;
  TAngl= map(Angl, 0, 180, 600, 2400);
  noInterrupts();
  for(i=0;i<50;i++)
  { digitalWrite(PIN_NASOS_NBK,HIGH);
    delayMicroseconds(TAngl);
    digitalWrite(PIN_NASOS_NBK,LOW);
    delayMicroseconds(10000-TAngl);
    delayMicroseconds(10000);
  }
 interrupts();

}



void loop() 
{
  int i,j;
  char k;
  unsigned long SqNapr=0, SqNaprPrev=0,FindPower,FindPowerKLP;
  int FindKtKLP;
  byte data[12];
  byte present = 0;
  unsigned int raw;
  int raw1;
  byte ds18b20CRC;
//  static char  FlFindPower;
//  static char  FlFindPowerKLP;
  char flErrDs18;
  //unsigned int tic;
  static char trig_on=true; //Признак того, что выдаем в данном цикле - 0 или 1

  #ifdef DEBUG
  my_debug();
  #endif

  //  static int PowerPrev=0;
  //  static int UstPowerPrev=0;
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  // print the number of seconds since reset:
  // Если есть необходимость произвести отображениеш  информации на дисплее и среднеквадратичное уже рассчитано.
  // И контроллен находится в режиме "лазанья" по меню, тогда отображаем информацию.
  // Или контроллер не находится в режиме ошибки.
  // Обработка уровней и НПГ
  if (flNeedReadAlarm && StateVolts!=1)
  {
//    #ifndef DEBUG
    ReadAlarm();
//    #endif
    flNeedReadAlarm=0;
  }

  // Для обеспечения равномерности выборки делаем это в цикле подряд.
  while (StateVolts==1)
  {
    #ifdef DEBUG
      if (Serial.available()) return;
    #endif
    
    #if USE_ASC712==0 // если датчик тока не используем, тогда читаем значение и делим его на два
      if (!flCorrASC712)  
      {
        if (USE_ZMPT==0) resultU=(analogRead(PIN_READU)>>1); // читаем показания с pin А3 и делим их на два, для увеличения измеряемого выходного напряжения.
        else
        {
          // Читаем с ZMPT
          resultU=analogRead(PIN_READU)-512; // читаем показания с pin А3 и делим их на два, для увеличения измеряемого выходного напряжения.
          if (resultU<0) resultU=-resultU; 
        }  
        
      }
      else
      {
        if (StateVolts==1)
        {
          if (CorrectASC712==3)
          {
            resultU=(analogRead(PIN_READI)>>1); // читаем показания с pin А3 и делим их на два, для увеличения измеряемого выходного напряжения.
          }
          else
          {
            resultU=analogRead(PIN_READI)-512;  // читаем показания с датчика тока.
            if (resultU<0) resultU=-resultU; 
          }
        }       
      }
      
    #else
      // Если используем датчик тока, тогда читаем значение, если оно больше 512, значит приводим его к 512;
      resultU=analogRead(PIN_READI)-512;  // читаем показания с датчика тока.
      if (resultU<0) resultU=-resultU;
    #endif                  
                      

//      data_adc[index_input]=resultU;  
      // Пробуем расчет квадратов на лету.
      SqNaprT=SqNaprT+(unsigned long) resultU* (unsigned long) resultU;   
      #ifdef TESTRM
//        tic=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера
//        tic_adc[index_input]=tic;
      #endif
      if (index_input<MAX_INDEX_INPUT) index_input++;
      else StateVolts=0; // Если превышер размер массива, ставим флаг расчета заново.
      
  }

  if (NeedDisplaying && (StateVolts!=1 || IspReg>=240) && FlState==0)
  {
    DisplayData();
  }

  // Сканируем клавиатуру, если установлен флаг.
  if (flNeedScanKbd==1 )
  {
    ScanKbd();
    flNeedScanKbd=0;
  }

  if (flNeedTemp==1 && IspReg>=240)
  {
    flNeedAnalyse=1;
  }

 if (StateVolts!=1)                 
  {

    if(flReadPress>timePressAtm)
    {
      flReadPress=0;
      if (timePressAtm>=30)
      {
        PressAtm=(int)(bmp.readPressure()/133.3224);
      }

      if (PressAtm>=640 && PressAtm<=820)
      {
        for(i=0;i<ds1820_devices;i++)
        {
          if (timePressAtm!=0)
          {
            raw1= (PressAtm-760)*37;
            raw1=-raw1/10;
            
            if (abs(raw1) % 10 >=5) 
            {
              raw1=raw1/10;
              if (raw1>0) raw1=raw1+1;
                     else raw1=raw1-1;
            }
            else
            {
              raw1=raw1/10;
            }
            
            ds1820_poprPress[i]= (char) raw1;  
            
           //Serial.println((int)ds1820_poprPress[i]);
          }
          else
            ds1820_poprPress[i]=0; 
            
       }
      }
    }
    
    if (flNeedTemp==1)
    {
      flNoPhase=1; // временно убираем с фазового управления клапана, чтобы они не закрылись
      OpenKLP(); // открываем на всякий случай все клапана, которые необходимо открыть.
      if (StepOut==0)
      {
        ds.reset();
        ds.write(0xCC,1);         // start conversion, with parasite power on at the end
        ds.write(0x44,1);         // start conversion, with parasite power on at the end
        flNeedTemp=0;
        for (j=0;j<ds1820_devices;j++) ds1820_flread[j]=0;
        StepOut=1;
      }
      else
      {

        flErrDs18=0; // Сбрасываем флаг nошибки датчика ds18b20
        for (j=0;j<ds1820_devices;j++)
        {
          // По каждому датчику температуру считаем три раза
          k=0;
          while(k<3)
          {
            if (ds1820_flread[j]==0)
            {
              present=ds.reset();
    
    #ifdef TIMING
              TCNT4H=0x00;
              TCNT4L=0x00;
    #endif            
    
              // Здесь вообще засада, передача кода датчика занимает около 1600 тиков таймера, что гарантирует пропуск регуляции как минимум одного полупериода.
              // Возможно решение - посадить каждый датчик на отдельный ПИН, тогда код датчика передавать не нужно.
              ds.select(ds1820_rom_codes[j]);    
    
    #ifdef TIMING
              unsigned int Tic2=(int) TCNT4L | (int) (TCNT4H<<8); // Расчитывааем текущее значение таймера
              sprintf(my_tx_buffer,"TicDs18Select=%i",Tic2);
              FlUsart=1;
    #endif
    
              ds.write(0xBE);         // Read Scratchpad
              //          Serial.print(present,HEX);
              //          Serial.print(" ");
              //        Читаем пока только 2 байта из 9, остальные не трогаем.
              for ( i = 0; i < 9; i++) 
              {  
                data[i] = ds.read();
                //            Serial.print(data[i], HEX);
                //            Serial.print(" ");
              }
              //          Serial.print(" CRC=");
              ds18b20CRC=OneWire::crc8(data, 8);
    
              if (ds18b20CRC!=data[8]) //  Ошибка чтения, записываем признак ошибки 
              {
    #ifndef DEBUG          
                if (!flErrDs18 && k==2) // Если ранее в этом сеансе не было ошибок чтения датчика, то прибавляем количество ошибок чтения на единицу
                {             
                  flErrDs18=1; 
                  CntErrDs18++;
                  NumErrDs18=j+1; // Запоминаем номер сглючившего датчика.
                  if (CntErrDs18>30) DispDopInfo=4;  // Устанавливаем признак вывода информации об ошибке если ошибок больше 4
                  if (FlToUSART) GetStateSerialErr();
                }
    #endif
              }
              else // Если контрольная сумма совпадает, то считаем, что все нормально.
              {
                raw = (data[1] << 8) | data[0];
                 if (raw & 0x8000)                         // Если там единица - число отрицательное и его надо преобразовать
                  {                                        // Стандартное преобразование отрицательного числа, которое в микроконтроллере в дополнительной кодировке
                      raw = (raw ^ 0xffff) + 1;            // Путем исключающего ИЛИ плюс единица
                      raw1=raw*5/8;
                      raw1=-raw;
                  }
                  else
                    {
                      raw1=raw*25/4;
                      if (raw1 % 10 >=5) raw1=raw1/10+1;
                                    else raw1=raw1/10;
                    }  
                    
                // Температуру равной 850 считаем ошибочной.
                if (raw1==850 || raw1>1200 || raw1==0)
                {
                  // Если температура скаканула больше чем на 10 градусов, то считаем ошибкой.
                  present=ds1820_nums[j];
                  if ((abs(raw1-temps[present])>100 || raw1==0) && temps[present]!=0 || raw1>1200 )
                  {
                    if (!flErrDs18 && k==2) // Если ранее в этом сеансе не было ошибок чтения датчика, то прибавляем количество ошибок чтения на единицу
                    {             
                      flErrDs18=1; 
                      CntErrDs18++;
                      NumErrDs18=present+1; // Запоминаем номер сглючившего датчика.
                      if (CntErrDs18>30) DispDopInfo=4;  // Устанавливаем признак вывода информации об ошибке если ошибок больше 4
                      if (FlToUSART) GetStateSerialErr();
                    }
                  }
                }
                else 
                {
                  #ifndef DEBUG          
                  // Если температуру считали успешно, то поставим соотв флаг.
                   ds1820_flread[j]=1;
                   k=3;// Выходим из цикла чтения
                   present=ds1820_nums[j];
                   
                   if (present>=MAX_DS1820 || present<0) present=MAX_DS1820-1;
                   
                    temps[present]=raw1;
                    // Если мы сейчас не находимся в режиме ввода поправок к датчикам, то прибавляем к температуре значение поправки
        
                    if (FlState!=300)
                    {
                      temps[present]=temps[present]+(int) ds1820_popr[j] +(int) ds1820_poprPress[j];
                    }
                    // Запоминаем максимальную температуру датчиков
                    if (Maxtemps[present]<temps[present]) Maxtemps[present]=temps[present];
                  #endif
                }
              }
            }
            k++;
          }
            
        } 

        StepOut=0;
        flNeedTemp=0;
        
#ifdef DEBUG
        flErrDs18=0;
#endif

        flNoPhase=0; // восстанавливаем фазовое управление клапанами.
        
        if (!flErrDs18) // Если не было ошибок, то сбрасываем счетчики.
        {
          flNeedAnalyse=1;   // Все необходимые данные прочитаны устанавливаем флаг того, что нужно анализировать состояние выполнения процесса.
          CntErrDs18=0;      
          NumErrDs18=0;
          // Сбрасываем признак вывода информации об ошибке
          if (DispDopInfo==4) DispDopInfo=0;
        }
        else
        {
          // Если были ошибки, заново запускаем определение температуры
          ds.reset();
          ds.write(0xCC,1);         // start conversion, with parasite power on at the end
          ds.write(0x44,1);         // start conversion, with parasite power on at the end
          flNeedTemp=0;
          StepOut=1;
        }
       if (timeBRD>=5) timeBRD-=5;
                  else timeBRD=0;
      }

    }
  }


  if (CntErrDs18>MAX_ERR_DS18)
  {
    flNeedAnalyse=1;
#ifndef TEST
    IspReg=251;      // Переводим контроллер в режим ошибки датчиков.
#endif
  }



  if (flNeedAnalyse==1)
  {

    trig_on=!trig_on;         
    digitalWrite(PIN_RST_WDT,trig_on); // Выдаем признак работы для внешнего контроля
    
    
    #ifdef USE_SLAVE
     SlaveON=digitalRead(PIN_SLAVE_3)*8+digitalRead(PIN_SLAVE_2)*4+digitalRead(PIN_SLAVE_1)*2+digitalRead(PIN_SLAVE_0);
    #endif
    
#ifdef TEST
    Serial.println("BEGIN PROSSES");
#endif      

    switch(IspReg)
    {
    case 102: //Текущее состояние - термостат
      //UstPower=0;
      ProcessTermostat();
      break;
    case 103: //Текущее состояние - регулятор мощности
      #ifndef USE_SLAVE
      if (StateMachine<100) UstPower=UstPowerReg;
      else UstPower=0;
      #else
        if (SlaveON==0) UstPower=0;
        if (SlaveON==1) UstPower=Power;
        if (SlaveON==2) UstPower=PowerGlvDistil;
        if (SlaveON==3) UstPower=PowerRect;
        if (SlaveON==4) UstPower=PowerDistil;
      #endif
      // Если стоит признак авто-детектирования ТЭНа, то мощность устанавливаем максимально возможную.
      if (flAutoDetectPowerTEN==1 && StateMachine<100) UstPower=9999;
      break;
    case 108:
    case 113:
      ProcessRazvarZerno();
      break;
    case 114:
      ProcessHLDZatorByChiller();
      break;
    case 115:
      ProcessTimerMaxPower();
      break;
    case 116:
      ProcessBeerCloneBrau();
      break;
    case 117:
      ProcessDistillFractional();
      break;
    case 118: //Текущее состояние - фракционная ректификация
    case 109: //Текущее состояние - ректификация
      ProcessRectif();
      break;
    case 104: //Текущее состояние - первый недробный перегон
    case 106: //Текущее состояние - второй дробный
    case 107: //Текущее состояние - третий дробный
      ProcessSimpleDistill();
      break;
    case 105: //Текущее состояние - отбор голов
      ProcessSimpleGlv();
      break;
    case 110:
      ProcessDistilDefl();
      break;
    case 111:
      ProcessNDRF();
      break;
    case 112:
      ProcessNBK();
      break;
    case 129:
      ProcessTestKLP();
      break;
    case 130:
      if (StateMachine==1) // Если состояние автомата - не запущено
      {
        //            flRing=1;
        KlOpen[KLP_VODA]=900;
        KlClose[KLP_VODA]=100;
        KlOpen[KLP_HLD]=KlOpen[KLP_VODA];
        KlClose[KLP_HLD]=KlClose[KLP_VODA];
        KlState[KLP_HLD]=KlState[KLP_VODA];
        KlCount[KLP_HLD]=KlCount[KLP_VODA];
        KlOpen[KLP_DEFL]=KlOpen[KLP_VODA];
        KlClose[KLP_DEFL]=KlClose[KLP_VODA];
        KlState[KLP_DEFL]=KlState[KLP_VODA];
        KlCount[KLP_DEFL]=KlCount[KLP_VODA];
        KlOpen[KLP_SR]=KlOpen[KLP_VODA];
        KlClose[KLP_SR]=KlClose[KLP_VODA];
        KlState[KLP_SR]=KlState[KLP_VODA];
        KlCount[KLP_SR]=KlCount[KLP_VODA];
        digitalWrite(PIN_TERMOSTAT_ON,HIGH);
        digitalWrite(PIN_TERMOSTAT_OFF,HIGH);
        //             digitalWrite(30,HIGH);
        //             digitalWrite(31,HIGH);
        //             digitalWrite(32,HIGH);

        StateMachine=100; // Переводим процесс в состояние выполнения
      }
      break; 

    case 248:
    case 249:                 
    case 250:     
    case 251:
    case 252:
    case 253:
    case 254:
      #if NUM_PHASE>1
          KlOpen[KLP_HLD]=100;
          KlClose[KLP_HLD]=0;
          digitalWrite(PIN_KLP_BEG+KLP_HLD,HIGH);
      #endif
      StateMachine=100;
      if (flNeedCall==0) flNeedCall=1;
      if (flNeedCall==1)
      {
         // Звонок на телефон в обязательном порядке.
        flGPRSState=40; // Активируем звонок если в этом есть необходимость
        flNeedRefrServer=1;
        timeGPRS=60;
        
      }
      else
      {
        // Если в данный момент не дозавниваемся, то отправляем SMS или GPRS
        if (flNeedCall!=2)
          if (FlToGSM && lastSMSState!=StateMachine) StateToSMS();
      }
      // Тревога либо ошибки протечка воды, отключаем воду, отключаем мощность.
      UstPower=0;
      CloseAllKLP();
      // Пищим, независимо от настроек.
#ifndef TEST
      my_beep(BEEP_LONG*5);
#endif

      digitalWrite(PIN_RZG_ON,!RELAY_HIGH);
      digitalWrite(PIN_TRIAC,LOW);
      digitalWrite(PIN_ALL_OFF,ALL_OFF_HIGH);
      flAllOff=1;
      break;

    }

    if (FlToUSART) GetStateSerial();

#ifdef TEST
    Serial.println("END PROSSES");
#endif      

    flNeedAnalyse=0;
    RaspredPowerByPhase();
  }

if (StateVolts!=1)
{
  #if NUM_PHASE<2
  //  анализ сотового   
  ProcessGSM();
  #else
  ProcessSlavePhase();
  #endif
  
}
  //  анализ отладки

  if (FlUsart==1)
  {
    // Признак того, что надо выдать информацию в ком-порт (есл ее вдруг невозможно сразу выдать, например, из прерывания).
    Serial.println(my_tx_buffer);
    FlUsart=0;    
  }       


  // Начало расчета среднеквадратичного
  
  if (StateVolts==2)        
  {
   
    #ifdef TESTRM
        Serial.println("BEGIN SQNAPR");
        TCNT4H=0x00;
        TCNT4L=0x00;
    #endif      

    StateVolts=3;

    // поскольку тут идет преобразование и умножение 32 разрядных чисел, делаем это по необходимости, а не каждый раз (хотя какая разница, тут и таких умножений дохрена)
    SqNapr=(long) 220*220*20/PowerPhase[0]; // Рассчитали сопротивление ТЭНа, умноженное на 20
    R_TEN20=  SqNapr;

    #ifdef TESTRM
        Serial.print("UstPower=");
        Serial.println(UstPower);
        Serial.print("Power=");
        Serial.println(Power);
        Serial.print("NaprPeregrev=");
        Serial.println(NaprPeregrev);
        Serial.print("MaxVoltsOut=");
        Serial.println(MaxVoltsOut);
        Serial.print("R_TEN20=");
        Serial.println(R_TEN20);
    #endif

   
   SqNapr=0;
   SqNaprPrev=0;
//   MaxVolts=0;
   
   #ifdef TESTRM
        TCNT4H=0x00;
        TCNT4L=0x00;
   #endif

    
    #ifdef TESTRM
        Serial.print("SqNapr=");
        Serial.println(SqNaprT);
        //Считаем напряжение в сети исходя из среднеквадратичного, средневыпрямленного, максимального
        Serial.print("RMS/AVG/MAX");
        Serial.write(9);
        Serial.print((long) my_sqrt(SqNaprT/index_input));
        Serial.write(9);
        Serial.println((long)MaxVolts*707/1000);
    #endif

    
    #if USE_ASC712==0
      if (!flCorrASC712) // Расчет напряжения
      {
 
        TekPower=SqNaprT/index_input;     // Определили квадрат напряжения
        
        // Но фактически мощность подаваемая на ТЭНы меньше из-за падения на симисторе.
        
        

        MaxVoltsOut=my_sqrt(TekPower);  // Рассчитываем среднеквадратичное
        
        #ifdef TESTRM
            Serial.print("index_input=");
            Serial.println(index_input);
            Serial.print("TekPower2=");
            Serial.println(TekPower);
        #endif
        
        
        TekPower=(TekPower*20)/R_TEN20; // Определили фактическую мощность в зависимости от сопротивления ТЭНа
        
        #ifdef TESTRM
            Serial.print("TekPower2=");
            Serial.println(TekPower);
        #endif
        
        

        TekPowerKLP=(unsigned long) NaprPeregrev*NaprPeregrev;

        #ifdef TESTRM
            Serial.print("UstPower=");
            Serial.println(UstPwrPH1);
            Serial.print("FactPower=");
            Serial.println(FactPower);
            Serial.print("MaxVoltsOut=");
            Serial.println(MaxVoltsOut);
            Serial.print("TekPowerKLP=");
            Serial.println(TekPowerKLP);
        #endif
        
      
        if (FactPower>15 && CorrectASC712>=2 && !(UstPwrPH1>=PowerPhase[0])) // Если фактическая мощность рассчитана и мы не находимся в режиме подачи полного напряжения на ТЭНы
        {
          // Это формулы, для ПИД-регулировани, предоставленные коллегой m16 c homedistiller.ru
          //          ;******************************************************************************
          //          ;*
          //          ;*	new_err = Ps_r - Pv			;вычисляем новую ошибку
          //          ;*
          //          ;*
          //          ;*	It = It + ki_r * new_err	        ;считаем интегральную составляющую
          //          ;*
          //          ;*		if ( It < 0.0 ) It = 0.0        ;если интегральная отрицательна то присваиваем ей ноль
          //          ;*		else  if( It > Sc_r ) It = Sc_r	;если интегральная превысит установленный предел то присваиваем значение предела 
          //          ;*
          //          ;*	Dt =  kd_r * ( new_err - old_err )	;считаем дифференциальную
          //          ;*
          //          ;*	Ut = ( new_err*10 + It + Dt ) /  Sc_r	;вычисляем % от максимальной мощности
          //          ;*
          //          ;*		if ( Ut < 0.0 ) Ut = 0.0
          //          ;*		else if ( Ut > 100 ) Ut = 100
          //          ;*
          //          ;*	old_err = new_err                       ;присваиваем значению новой ошибке предыдущую
          //          ;******************************************************************************
          //          где
          //          Ps_r - мощность установленная
          //          Pv   - мощность измеренная
          //          new_err- новая ошибка рассогласования
          //          old_err- предыдущая ошибка рассогласования
          //          Sc_r   - максимальное накопление интегральной составляющей
          //          It     - интегральная
          //          ki_r   - коэф. интегральной
          //          Dt     - дифю составляющая 
          //          kd_r   - коэф. дифференциальной
          //          Ut     - % от макс. мощности
          // Считаем ошибку рассоглавования.

          // Ошибку рассогласования учитвыаем, если она не более 1/8 мощности ТЭНа.
          NewErr=((long)UstPwrPH1-(long)FactPower)*200/(long)Power;
          if (NewErr<-30) NewErr=-30;
          else
            if (NewErr>30) NewErr=30;
            
          Dt=NewErr-OldErr;
          It=It+NewErr;
          // Накопленную ошибку не более 1/2 мощности ТЭНа.
          if (It<-100) It=-100;
            else if (It>100) It=100;
            
          OldErrOut=OldErr; // Старая ошибка для отображения на экране
          OldErr=NewErr; // Запоминаем старую ошибку.
//          if (UstPower>FactPower) It=It+5;
//          else  
//            if (UstPower<FactPower) It=It-5;
        }
        else
        {
          // Если мощность не рассчитана, то считаем, что находимся в режиме отладки и не подключили ТЭНы В этом случае просто делаем фазовое регулирование исходя из
          // входного напряжения, не учитывая фактическую мощность, рассчитанную исходя из датчика тока на ТЭНах
          NewErr=0;
          OldErr=0;
          OldErrOut=0;
          It=0;
          Dt=0;
        }

    
        // Пока без коэффиццииенов
        FindKt=(long)(UstPwrPH1)*200/ TekPower;        // Установили коэффициент поиска мощности для регулятора мощности как соотношение необходимой мощности к имеющейся в данный момент.
        FindKt=FindKt+It;                              // Прибавляем коэффициент.
        
        
        
        // Нестабилизированная версия, фактическую мощность не учитываем.
        #if SIMPLED_VERSION==20
          FindKt=(long)(UstPowerReg)*200/ Power;        // Установили коэффициент поиска мощности для регулятора мощности как соотношение необходимой мощности к имеющейся в данный момент.
          MaxVoltsOut=220;
          flNoAlarmLowPower=1;
        #endif
    
                                                      
        if (FindKt>200 || It==-100) 
        {
          CntErrPower++; 
          if (UstPwrPH1<PowerPhase[0] && UstPwrPH1>15 && CntErrPower>100 && !flNoAlarmLowPower) 
          {   if (FindKt>200)  { DispDopInfo=3; FindKt=200; } // Выводим на экран информацию о низком напряжении но только в том случае, когда не в режиме разгона и установленная мощность больше 15
              else DispDopInfo=6;              // и в том случае когда не установлено, что не нужно выводить предупреждение о низком уровне напряжения
              #if NUM_PHASE>1
                if (FindKt>=200)
                {
                 KlOpen[KLP_HLD]=100; // Раз в секунду
                 KlClose[KLP_HLD]=100;
                }
                else
                {
                 KlOpen[KLP_HLD]=15; // Два раза в секунду
                 KlClose[KLP_HLD]=15;
                }
                
              #endif
          }
       }
        else
          {
            CntErrPower=0; 
            #if NUM_PHASE>1
               KlOpen[KLP_HLD]=0;
               KlClose[KLP_HLD]=50;
            #endif
           
            if (DispDopInfo==3 || DispDopInfo==6) 
            { 
              DispDopInfo=0; // Убираем информацию о низком напряжении, если она была ранее установлена
            }
            
          }
          
          #if NUM_PHASE>1
            if (IspReg>=240)
             {
               KlOpen[KLP_HLD]=100;
               KlClose[KLP_HLD]=0;
             }
          #endif
          
 
         // В клапанах тоже учитываем поправку мощности
        //TekPowerKLP=(TekPowerKLP+It)*1000/( (long) MaxVoltsOut* (long)MaxVoltsOut);
        //Пока убираем поправку мощности в клапанах, возможно из-за этого "пробивает" симистор.
        TekPowerKLP=(TekPowerKLP)*1000/( (long) MaxVoltsOut* (long)MaxVoltsOut);
        
        FindKtKLP=TekPowerKLP;// Установили коэффициент поиска мощности для клапанов
        
        // Проверка минимума и максимума
        if (FindKtKLP>1000) FindKtKLP=1000;
        if (FindKtKLP<5) FindKtKLP=5;

        #ifdef TESTRM
            Serial.print("NewErr=");
            Serial.println(NewErr);
            Serial.print("OldErr=");
            Serial.println(OldErrOut);
            Serial.print("FindKt=");
            Serial.println(FindKt);
            Serial.print("FindKtNoErr=");
            Serial.println((long)(UstPower)*1000/ TekPower);
            Serial.print("NaprPeregrev=");
            Serial.println(NaprPeregrev);
            Serial.print("FindKtKLP=");
            Serial.println(FindKtKLP);
            Serial.print("SqNaprT=");
            Serial.println(SqNapr);
            Serial.print("SqNaprPrev=");
            Serial.println(SqNaprPrev);
        #endif

        if (FindKt<1) FindKt=1;
        if (FindKt>200) FindKt=200;

        // Поскольку таблица разбита по мощности равномерно в пределах 5/1000 доли, то нет необходимости высчитывать и искать по таблице, достаточно просто поделить.
        TimeOpenTriac=tableS10[FindKt - 1];
        TimeOpenTriac*=10;
        // Учиываем предельно допустимый угол открытия триака
        if (FindKtKLP<1000)
        {
          TimeOpenKLP  =tableS10[FindKtKLP/5 - 1];
          // Защита от "дребезга клапана" на малых углах открытия симистора.
          if (TimeOpenKLP<70) TimeOpenKLP=0; 
          TimeOpenKLP*=10;
          
        }
        else
         TimeOpenKLP=0;
       
        
        if (TimeOpenKLP<=10) TimeOpenKLP=9999; // Если не нашли нужную мощность, то устанавливаем максимальную.
        if (flAutoDetectPowerTEN) TimeOpenTriac=9999;
      }
     else // Это расчет фактического тока и фактической мощности
      {

        if (CorrectASC712==3) // Расчет по напряжениию
        {
            TekPower=SqNaprT/index_input;     // Определили квадрат напряжения
            MaxIOut=my_sqrt(TekPower);  // Рассчитываем среднеквадратичное
            #ifdef TESTRM
                Serial.print("index_input=");
                Serial.println(index_input);
                Serial.print("TekPower2=");
                Serial.println(TekPower);
            #endif
            FactPower=(TekPower*20)/R_TEN20; // Определили фактическую мощность в зависимости от сопротивления ТЭНа
            
        }
        else
        {
          // Здесь определили квадрат тока умноженный на 10.
          SqNaprPrev=SqNaprT*100/ ((unsigned long) index_input*SENSITIVE_ASC712);
          // Определили ток, умноженный на 10 (для вывода на экран).
          MaxIOut=my_sqrt((long)SqNaprPrev*100/SENSITIVE_ASC712);
          if (flAutoDetectPowerTEN)
          {
              FindPower=(long) SqNaprPrev*100/(SENSITIVE_ASC712);
  //            Serial.print("I^2=");
  //            Serial.println(my_sqrt(FindPower));
              TekPower=(unsigned long) 220*22*my_sqrt(FindPower)/MaxVoltsOut;
              if (TekPower!=0)
              {
                  Power=(int)(TekPower/10)*10;
                  PowerPhase[0]=Power;
              }
          }
          
          
          FindPower=(long) SqNaprPrev*R_TEN20/ (20*SENSITIVE_ASC712);
          FactPower=FindPower;
         
          #ifdef TESTRM
            Serial.print("SqNaprT=");
            Serial.println(SqNaprT);
            Serial.print("index_input=");
            Serial.println(index_input);
            Serial.print("index_input*SENSITIVE_ASC712=");
            Serial.println((unsigned long)index_input*SENSITIVE_ASC712);
            Serial.print("SqNaprPrev=");
            Serial.println(SqNaprPrev);
            Serial.print("FindPower=");
            Serial.println(FindPower);
            Serial.print("FactPower=");
            Serial.println(FactPower);
          #endif
        } 
       }   

    #endif
    
    
//   Сумму квадратов измерений определили, она хранится в переменной SqNapr.
//   Теперь надо перевести это в фактический ток.
  #if USE_ASC712==1

      // Рассчитали сумму, пересчитанную в фактические значения тока.
      SqNaprPrev=SqNaprT*100/ ( (unsigned long) index_input*SENSITIVE_ASC712);
      #ifdef TESTRM
      Serial.print("SqNapr=");
      Serial.println(SqNapr);
      Serial.print("SqNaprPrev=");
      Serial.println(SqNaprPrev);
      #endif
      
      

      FindPower=(long) SqNaprPrev*R_TEN20/ (20*SENSITIVE_ASC712);
      FactPower=FindPower;
      
      MaxVoltsOut=my_sqrt(FindPower*R_TEN20/20);

      // Теперь зная мощность рассчитываем процент для брезенхема
      b_value[0]=(long) UstPower*b_size[0]/(long) FindPower;

      if (b_value[0]>b_size[0] && UstPower<Power) DispDopInfo=3; // Выводим на экран информацию о низком напряжении если находимся не в режиме разгона.
      else
        if (DispDopInfo==3) DispDopInfo=0; // Убираем информацию о низком напряжении, если она была ранее установлена
      
      
      #ifdef TESTRM
        Serial.print("MaxVoltsOut=");
        Serial.println(MaxVoltsOut);
        Serial.print("FindPower=");
        Serial.println(FindPower);
        Serial.print("FactPower=");
        Serial.println(FactPower);
        Serial.print("b_value[0]=");
        Serial.println((int)b_value[0]);
      #endif
  #endif

#ifdef TESTRM

    Serial.println("VOLTS");
    Serial.print("j=");
    Serial.println(j);
    Serial.print("SqNapr=");
    Serial.println(SqNapr);
    Serial.print("SqNaprPrev=");
    Serial.println(SqNaprPrev);
    Serial.print("FindPower=");
    Serial.println(FindPower);
    Serial.print("b_value=");
    Serial.println(b_value[0]);
    Serial.print("OpenTriac=");
    Serial.println(TimeOpenTriac);
    Serial.print("OpenKLP=");
    Serial.println(TimeOpenKLP);

    Serial.print("COUNT=");
    Serial.println(index_input);

//    for(i=0;i<index_input;i++)
//    {            
//      // Сканируем клавиатуру, если установлен флаг.
//      if (flNeedScanKbd==1 )
//      {
//        ScanKbd();
//        flNeedScanKbd=0;
//      }
//
//      Serial.print(tic_adc[i]);
//      Serial.write(9);
//      Serial.println(data_adc[i]);
//    }                                                    
    Serial.print("TICZERO=");
    Serial.write(9);
    Serial.println(TicZero);
    
//    Serial.println("TABLET");
//    for(i=0;i<MAX_TABLE_T;i++)
//    {            
//      // Сканируем клавиатуру, если установлен флаг.
//      if (flNeedScanKbd==1 )
//      {
//        ScanKbd();
//        flNeedScanKbd=0;
//      }
//
//      Serial.print(tableK[i]);
//      Serial.write(9);
//      Serial.println(tableT[i]);
//    }                                                    

    Serial.println("ENDVOLTS");


#endif      

    StateVolts=4;
  }
  
}
